[![pre-commit.ci status](https://results.pre-commit.ci/badge/github/xgcm/aerobulk-python/main.svg)](https://results.pre-commit.ci/latest/github/xgcm/aerobulk-python/main)

# aerobulk-python
A python wrapper for aerobulk (https://github.com/brodeau/aerobulk)

## Installation

## aerobulk-python developer guide

These are the steps to install and develop the package locally

1. Set up a development environment.
```
mamba create -n aerobulk-python-dev python=3.9 numpy gfortran xarray pytest ipython
conda activate aerobulk-python-dev
```

2. Clone the repository

Make sure to clone the repo with `--recursive` to also pull the git submodule!

```
git clone --recursive git@github.com:xgcm/aerobulk-python.git
```

3. Compile/Install aerobulk-python (this has to be rerun after every change to the fortran code/wrapper/signature file)
    Run these commands from within the `aerobulk-python` folder.

    a. Use pip to install aerobulk locally (this will install the python package and compile).
    ```
    pip install -e .
    ```
    b. Manual version (you will have to install the python module separately)
    ```
    python -m numpy.f2py --verbose -c --f90flags="-fdefault-real-8 -ffree-line-length-200 --std=gnu" ./source/fortran/aerobulk/src/mod_const.f90 ./source/fortran/aerobulk/src/mod_phymbl.f90 ./source/fortran/aerobulk/src/mod_skin_coare.f90 ./source/fortran/aerobulk/src/mod_skin_ecmwf.f90 ./source/fortran/aerobulk/src/mod_blk_andreas.f90 ./source/fortran/aerobulk/src/mod_common_coare.f90 ./source/fortran/aerobulk/src/mod_blk_coare3p0.f90 ./source/fortran/aerobulk/src/mod_blk_coare3p6.f90 ./source/fortran/aerobulk/src/mod_blk_ecmwf.f90 ./source/fortran/aerobulk/src/mod_blk_ncar.f90 ./source/fortran/aerobulk/src/mod_blk_neutral_10m.f90 ./source/fortran/aerobulk/src/mod_aerobulk_compute.f90 ./source/fortran/aerobulk/src/mod_aerobulk.f90 ./source/fortran/mod_aerobulk_wrap.f90 ./source/fortran/mod_aerobulk_wrap.pyf
    ```

4. Make sure things work
```
pytest test/test.py
```
🎉

## Local Aerobulk compilation guide
Assumes that you have an environment with a gfortran compiler set up, have aerobulk cloned and that you are in the root aerobulk (not aerobulk-python) directory.

1. Build the aerobulk source

First copy the appropriate macro file to the source directory:
```
cp arch/make.macro_GnuLinux make.macro
```

those of us on mac needed to edit `make.macro` make this change
```diff
# These are needed for the C/C++ interface
- FF += -std=gnu -lstdc++
+ FF += -std=gnu
```

Then you should be able to run `make`

This will build:
- Object files `src/*.o`
- Mode files `mod/*.mod`
- Library file `lib/libaerobulk.a`
- Binary executables `bin/*x`

I was able to run one of the binaries with `bin/example_call_aerobulk.x`


<details><summary>Output</summary>
```
*********** COARE 3.0 *****************

 ===================================================================
                    ----- AeroBulk_init -----

     *** Bulk parameterization to be used => "coare3p0"
        ==> will use the Cool-skin & Warm-ayer scheme of `coare3p0` !
     *** Computational domain shape: Ni x Nj = 00002 x 00001
     *** Number of time records that will be treated:           1
     *** Number of iterations in bulk algos: nb_iter  =   10
     *** Filling the `mask` array...
         ==> no points need to be masked! :)
     *** Type of prescribed air humidity  `specific humidity [kg/kg]`
 ===================================================================
 ===================================================================
                    ----- AeroBulk_bye -----
 ===================================================================


 ---------------------------------------------------------------------
     Parameter           | Unstable ASL |  Stable ASL  | units
 ---------------------------------------------------------------------
  Wind speed at zu       =   5.00000000       5.00000000      m/s
     SST                 =   22.0000000       22.0000000      deg.C
  Abs. temperature at zt =   20.0000000       25.0000000      deg.C
  Pot. temperature at zt =   20.0134144       25.0150242      deg.C

  Sensible heat flux: QH =  -15.1545086       17.8423691      W/m**2
   Latent  heat flux: QL =  -81.3846741      -50.8408585      W/m**2
   Evaporation:     Evap =  -2.87061906      -1.79333246      mm/day
  Skin temperature: SSST =   21.7219677       21.7576351      deg.C
  Tau_x                  =   3.57834995E-02   1.73626728E-02  N/m**2
  Tau_y                  =   0.00000000       0.00000000      N/m**2
  Tau                    =   3.57834995E-02   1.73626728E-02  N/m**2



  *********** COARE 3.6 *****************

 ===================================================================
                    ----- AeroBulk_init -----

     *** Bulk parameterization to be used => "coare3p6"
        ==> will use the Cool-skin & Warm-ayer scheme of `coare3p6` !
     *** Computational domain shape: Ni x Nj = 00002 x 00001
     *** Number of time records that will be treated:           1
     *** Number of iterations in bulk algos: nb_iter  =   10
     *** Filling the `mask` array...
         ==> no points need to be masked! :)
     *** Type of prescribed air humidity  `specific humidity [kg/kg]`
 ===================================================================
 ===================================================================
                    ----- AeroBulk_bye -----
 ===================================================================


 ---------------------------------------------------------------------
     Parameter           | Unstable ASL |  Stable ASL  | units
 ---------------------------------------------------------------------
  Wind speed at zu       =   5.00000000       5.00000000      m/s
     SST                 =   22.0000000       22.0000000      deg.C
  Abs. temperature at zt =   20.0000000       25.0000000      deg.C
  Pot. temperature at zt =   20.0134144       25.0150242      deg.C

  Sensible heat flux: QH =  -15.3865499       17.0818920      W/m**2
   Latent  heat flux: QL =  -83.0788422      -48.4459152      W/m**2
   Evaporation:     Evap =  -2.93033028      -1.70883954      mm/day
  Skin temperature: SSST =   21.7057972       21.7485600      deg.C
  Tau_x                  =   3.21817845E-02   1.51577257E-02  N/m**2
  Tau_y                  =   0.00000000       0.00000000      N/m**2
  Tau                    =   3.21817845E-02   1.51577257E-02  N/m**2



  *********** ECMWF *****************

 ===================================================================
                    ----- AeroBulk_init -----

     *** Bulk parameterization to be used => "ecmwf"
        ==> will use the Cool-skin & Warm-ayer scheme of `ecmwf` !
     *** Computational domain shape: Ni x Nj = 00002 x 00001
     *** Number of time records that will be treated:           1
     *** Number of iterations in bulk algos: nb_iter  =   10
     *** Filling the `mask` array...
         ==> no points need to be masked! :)
     *** Type of prescribed air humidity  `specific humidity [kg/kg]`
 ===================================================================
 ===================================================================
                    ----- AeroBulk_bye -----
 ===================================================================


 ---------------------------------------------------------------------
     Parameter           | Unstable ASL |  Stable ASL  | units
 ---------------------------------------------------------------------
  Wind speed at zu       =   5.00000000       5.00000000      m/s
     SST                 =   22.0000000       22.0000000      deg.C
  Abs. temperature at zt =   20.0000000       25.0000000      deg.C
  Pot. temperature at zt =   20.0134144       25.0150242      deg.C

  Sensible heat flux: QH =  -14.3822346       17.6531811      W/m**2
   Latent  heat flux: QL =  -80.2958984      -52.4623947      W/m**2
   Evaporation:     Evap =  -2.83224440      -1.85053933      mm/day
  Skin temperature: SSST =   21.7325401       21.7630310      deg.C
  Tau_x                  =   3.84389125E-02   1.93256922E-02  N/m**2
  Tau_y                  =   0.00000000       0.00000000      N/m**2
  Tau                    =   3.84389125E-02   1.93256922E-02  N/m**2



  *********** NCAR *****************

 ===================================================================
                    ----- AeroBulk_init -----

     *** Bulk parameterization to be used => "ncar"
     *** Cool-skin & Warm-layer schemes will NOT be used!
     *** Computational domain shape: Ni x Nj = 00002 x 00001
     *** Number of time records that will be treated:           1
     *** Number of iterations in bulk algos: nb_iter  =   10
     *** Filling the `mask` array...
         ==> no points need to be masked! :)
     *** Type of prescribed air humidity  `specific humidity [kg/kg]`
 ===================================================================
 ===================================================================
                    ----- AeroBulk_bye -----
 ===================================================================


 ---------------------------------------------------------------------
     Parameter           | Unstable ASL |  Stable ASL  | units
 ---------------------------------------------------------------------
  Wind speed at zu       =   5.00000000       5.00000000      m/s
     SST                 =   22.0000000       22.0000000      deg.C
  Abs. temperature at zt =   20.0000000       25.0000000      deg.C
  Pot. temperature at zt =   20.0134144       25.0150242      deg.C

  Sensible heat flux: QH =  -16.6969528       10.7261686      W/m**2
   Latent  heat flux: QL =  -88.4781876      -71.9012222      W/m**2
   Evaporation:     Evap =  -3.12166286      -2.53679895      mm/day
  Tau_x                  =   3.58519591E-02   2.77329944E-02  N/m**2
  Tau_y                  =   0.00000000       0.00000000      N/m**2
  Tau                    =   3.58519591E-02   2.77329944E-02  N/m**2



  *********** ANDREAS *****************

 ===================================================================
                    ----- AeroBulk_init -----

     *** Bulk parameterization to be used => "andreas"
     *** Cool-skin & Warm-layer schemes will NOT be used!
     *** Computational domain shape: Ni x Nj = 00002 x 00001
     *** Number of time records that will be treated:           1
     *** Number of iterations in bulk algos: nb_iter  =   10
     *** Filling the `mask` array...
         ==> no points need to be masked! :)
     *** Type of prescribed air humidity  `specific humidity [kg/kg]`
 ===================================================================
 ===================================================================
                    ----- AeroBulk_bye -----
 ===================================================================


 ---------------------------------------------------------------------
     Parameter           | Unstable ASL |  Stable ASL  | units
 ---------------------------------------------------------------------
  Wind speed at zu       =   5.00000000       5.00000000      m/s
     SST                 =   22.0000000       22.0000000      deg.C
  Abs. temperature at zt =   20.0000000       25.0000000      deg.C
  Pot. temperature at zt =   20.0134144       25.0150242      deg.C

  Sensible heat flux: QH =  -14.4129944       15.1970539      W/m**2
   Latent  heat flux: QL =  -74.4637756      -51.7018318      W/m**2
   Evaporation:     Evap =  -2.62721038      -1.82412970      mm/day
  Tau_x                  =   3.02770734E-02   1.79436151E-02  N/m**2
  Tau_y                  =   0.00000000       0.00000000      N/m**2
  Tau                    =   3.02770734E-02   1.79436151E-02  N/m**2
```
</details>

! AeroBulk / 2015 / L. Brodeau

MODULE mod_const

   IMPLICIT NONE

   PUBLIC

   !! Following NEMO:
   INTEGER, PARAMETER :: sp = SELECTED_REAL_KIND( 6, 37)   !: single precision (real 4)
   INTEGER, PARAMETER :: dp = SELECTED_REAL_KIND(12,307)   !: double precision (real 8)
   INTEGER, PARAMETER :: wp = dp                           !: working precision

   ! THINGS THAT NEED TO BE GIVEN A VALUE, anh have the same name and type as in NEMO...
   ! Stupid values here to prevent to ommit to give them a value:

   !! Space dimmension:
   INTEGER,  PARAMETER            :: jpk = 1

   !! Time dimmension:
   INTEGER,  PARAMETER            :: nit000 = 1
   INTEGER,                  SAVE :: nitend = 1 !: time steps (aka # of calls) at which to end

   LOGICAL, SAVE :: l_use_skin_schemes = .FALSE. !: do we use the cool-skin / warm-layer skin schemes ?
   
   !! Type of air humidity in use:
   CHARACTER(len=2),         SAVE :: ctype_humidity = 'sh' !: Default: spec. humidity [kg/kg ] => 'sh'
   !!                                                      !: * relative humidity         [%]  => 'rh'
   !!                                                      !: * dew-point temperature     [K]  => 'dp'
   
   REAL(wp), DIMENSION(jpk), SAVE :: gdept_1d = (/ 1._wp /) !: depth at which SST is measured [m]
   REAL(wp),                 SAVE :: rdt = 3600. !: time step for the cool-skin/warm-layer parameterization  [s]
   INTEGER,                  SAVE :: nb_iter=5  !: number of itteration in the bulk algorithm

   LOGICAL, PARAMETER :: ldebug_blk_algos=.false.

   !! General constants:
   REAL(wp), PARAMETER, PUBLIC :: grav  = 9.8      !: acceleration of gravity    [m.s^-2]
   REAL(wp), PARAMETER, PUBLIC :: rpi   = 3.141592653589793_wp
   REAL(wp), PARAMETER, PUBLIC :: twoPi = 2.*rpi
   REAL(wp), PARAMETER, PUBLIC :: to_rad = rpi/180.

   
   !! Earth constants:
   REAL(wp), PARAMETER, PUBLIC :: R_earth = 6.37E6 ! Earth radius (m)
   REAL(wp), PARAMETER, PUBLIC ::rtilt_earth = 23.5
   REAL(wp), PARAMETER, PUBLIC ::Sol0 = 1366.         !: Solar constant W/m^2
   !!
   REAL(wp), PARAMETER, PUBLIC :: roce_alb0  = 0.066   !: Default sea surface albedo over ocean when nothing better is available
   !!                                                      !: NEMO: 0.066 / ECMWF: 0.055
   REAL(wp), PARAMETER, PUBLIC :: rice_alb0  = 0.8     !: BAD!!! must use that of the sea-ice model when possible !!!


   !! Physics constants:
   REAL(wp), PARAMETER, PUBLIC ::emiss_w = 0.98_wp     !: Long-wave (thermal) emissivity of sea-water []
   REAL(wp), PARAMETER, PUBLIC ::emiss_i = 0.996       !:  "   for ice and snow => but Rees 1993 suggests can be lower in winter on fresh snow... 0.72 ...
   REAL(wp), PARAMETER, PUBLIC ::stefan = 5.67E-8 !: Stefan Boltzman constant

   !! Thermodynamics / Water:
   REAL(wp), PARAMETER, PUBLIC :: rt0  = 273.15      !: freezing point of fresh water [K]
   REAL(wp), PARAMETER, PUBLIC :: rtt0 = 273.16      !: triple point                  [K]
   !!
   REAL(wp), PARAMETER, PUBLIC :: rCp0_w  = 4190.    !: Specific heat capacity of seawater (ECMWF 4190) [J/K/kg]
   REAL(wp), PARAMETER, PUBLIC :: rho0_w = 1025.     !: Density of sea-water  (ECMWF->1025)             [kg/m^3]
   REAL(wp), PARAMETER, PUBLIC :: rnu0_w = 1.e-6     !: kinetic viscosity of water                      [m^2/s]
   REAL(wp), PARAMETER, PUBLIC :: rk0_w  = 0.6       !: thermal conductivity of water (at 20C)          [W/m/K]

   
   !! Thermodynamics:
   REAL(wp), PARAMETER, PUBLIC :: rCp0_a  = 1015.0   !: Specic heat of moist air                      [J/K/kg]
   REAL(wp), PARAMETER, PUBLIC :: rCp_dry = 1005.0   !: Specic heat of dry air, constant pressure      [J/K/kg]
   REAL(wp), PARAMETER, PUBLIC :: rCp_vap = 1860.0   !: Specic heat of water vapor, constant pressure  [J/K/kg]
   !!
   REAL(wp), PARAMETER, PUBLIC :: R_dry = 287.05     !: Specific gas constant for dry air              [J/K/kg]
   REAL(wp), PARAMETER, PUBLIC :: R_vap = 461.495    !: Specific gas constant for water vapor          [J/K/kg]
   REAL(wp), PARAMETER, PUBLIC :: R_gas = 8.314510   !: Universal molar gas constant                   [J/mol/K]
   !!
   REAL(wp), PARAMETER, PUBLIC :: rmm_dryair = 28.9647e-3             !: dry air molar mass / molecular weight     [kg/mol]
   REAL(wp), PARAMETER, PUBLIC :: rmm_water  = 18.0153e-3             !: water   molar mass / molecular weight           [kg/mol]
   REAL(wp), PARAMETER, PUBLIC :: rmm_ratio  = rmm_water / rmm_dryair
   !!
   REAL(wp), PARAMETER, PUBLIC :: rpoiss_dry = R_dry / rCp_dry  !: Poisson constant for dry air
   REAL(wp), PARAMETER, PUBLIC :: rgamma_dry = grav  / rCp_dry  !: dry adabiatic lapse rate [K/m]

   
   REAL(wp), PARAMETER, PUBLIC :: reps0 = R_dry/R_vap      !: ratio of gas constant for dry air and water vapor => ~ 0.622
   REAL(wp), PARAMETER, PUBLIC :: rctv0 = R_vap/R_dry - 1. !: for virtual temperature (== (1-eps)/eps) => ~ 0.608
   !!
   REAL(wp), PARAMETER, PUBLIC :: rnu0_air  = 1.5E-5   !: kinematic viscosity of air    [m^2/s]
   !!
   REAL(wp), PARAMETER, PUBLIC :: rLevap = 2.46e+6_wp   !: Latent heat of vaporization for sea-water in   [J/kg]
   REAL(wp), PARAMETER, PUBLIC :: rLsub  = 2.834e+6_wp  !: Latent heat of sublimation for ice at 0 deg.C  [J/kg]
   !!
   REAL(wp), PARAMETER, PUBLIC :: Tswf  = 273.         !: BAD!!! because sea-ice not used yet!!!

   
   !! Some defaults:
   REAL(wp), PARAMETER, PUBLIC :: Patm  = 101000. !: reference atmospheric pressure at sea-level            [Pa]
   REAL(wp), PARAMETER, PUBLIC :: rho0_a = 1.2    !: Approx. of density of air                          [kg/m^3]
   
   
   !! Bulk model:
   REAL(wp), PARAMETER, PUBLIC :: vkarmn  = 0.4_wp         !: Von Karman's constant
   REAL(wp), PARAMETER, PUBLIC :: vkarmn2 = 0.4_wp*0.4_wp  !: Von Karman's constant ^2
   REAL(wp), PARAMETER, PUBLIC :: rdct_qsat_salt = 0.98_wp !: factor to apply to q_sat(SST) to account for salt in estimation of sat. spec. hum.
   REAL(wp), PARAMETER, PUBLIC :: z0_sea_max = 0.0025_wp   !: maximum realistic value for roughness length of sea-surface... [m]
   
   !! Cool-skin warm-layer:
   REAL(wp), PARAMETER, PUBLIC :: rcst_cs = -16._wp*9.80665_wp*rho0_w*rCp0_w*rnu0_w*rnu0_w*rnu0_w/(rk0_w*rk0_w) !: for cool-skin parameteri$
   !                              => see eq.(14) in Fairall et al. 1996   (eq.(6) of Zeng aand Beljaars is WRONG! (typo?)
   REAL(wp), PARAMETER, PUBLIC :: radrw    = rho0_a/rho0_w !: Density ratio
   REAL(wp), PARAMETER, PUBLIC :: sq_radrw = SQRT(rho0_a/rho0_w)

   REAL(wp), PARAMETER, PUBLIC :: Cx_min = 0.1E-3_wp ! smallest value allowed for bulk transfer coefficients (usually in stable conditions with now wind)
   

   !! Sea-ice stuff:
   REAL(wp), PARAMETER, PUBLIC :: rCd_ice = 1.4e-3_wp   !: transfer coefficient over ice
   REAL(wp), PARAMETER, PUBLIC :: to_mm_p_day = 24._wp*3600._wp  !: freshwater flux: from kg/s/m^2 == mm/s to mm/day
   REAL(wp), PARAMETER, PUBLIC :: wspd_thrshld_ice = 0.2_wp !: minimum scalar wind speed accepted over sea-ice...
   !REAL(wp), PARAMETER, PUBLIC :: wspd_thrshld_ice = 0.5_wp !: minimum scalar wind speed accepted over sea-ice...



   !! Calendar:
   INTEGER, DIMENSION(12), PARAMETER, PUBLIC :: &
      &   tdmn = (/ 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 /), &
      &   tdml = (/ 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 /)


   CHARACTER(len=200), PARAMETER :: cform_err = '(" *** E R R O R :  ")'




   !! For sanity check + guess of type of humidity we need an acceptable min and max
   !! On input field:   
   REAL(wp), PARAMETER :: ref_sst_min = 270._wp   , ref_sst_max = 320._wp    ! SST [K]
   REAL(wp), PARAMETER :: ref_taa_min = 180._wp   , ref_taa_max = 330._wp    ! Absolute air temperature [K]
   REAL(wp), PARAMETER :: ref_sha_min = 0._wp     , ref_sha_max = 0.08_wp    ! Specific humidity of air [kg/kg]
   REAL(wp), PARAMETER :: ref_dpt_min = 150._wp   , ref_dpt_max = 330._wp    ! Dew-point temperature [K]
   REAL(wp), PARAMETER :: ref_rlh_min = 0._wp     , ref_rlh_max = 100._wp    ! Relative humidity [%]
   REAL(wp), PARAMETER :: ref_slp_min = 80000._wp , ref_slp_max = 110000._wp ! Sea-level atmospheric presssure [Pa]
   REAL(wp), PARAMETER :: ref_wnd_min = 0._wp     , ref_wnd_max = 50._wp     ! Scalar wind speed [m/s]
   REAL(wp), PARAMETER :: ref_rsw_min = 0._wp     , ref_rsw_max = 1500.0_wp  ! Downwelling shortwave radiation [W/m^2]
   REAL(wp), PARAMETER :: ref_rlw_min = 0._wp     , ref_rlw_max =  750.0_wp  ! Downwelling longwave  radiation [W/m^2]

   !! On computed fluxes:
   REAL(wp), PARAMETER :: ref_tau_max = 5._wp ! Wind stress [N/m2]
   
   !! IFS:

   !REAL(wp), PARAMETER :: &
   !&    RKBOL = 1.380658E-23, &
   !&    RNAVO = 6.0221367E+23, &
   !&    R = RNAVO*RKBOL, &
   !&    RMD = 28.9644, &
   !&    RMV = 18.0153, &
   !&    RD = 1000.*R/RMD, &
   !&    RV = 1000.*R/RMV, &
   !&    rCp_dry = 3.5*RD, &
   !&    rLevap=2.5008E+6, &


   






   !! Max and min values for variable (for netcdf files)

   !REAL(wp), PARAMETER :: &
   !&                qlat_min = -1200., qlat_max = 200., &
   !     &                qsen_min = -900. , qsen_max = 300., &
   !     &                taum_min =    0., taum_max =   4.,  &
   !     !!
   !     &                msl_min  = 85000., msl_max = 105000., &
   !     &                tair_min =  223., tair_max = 323.,  &
   !     &                qair_min =    0., qair_max = 0.03,  &
   !     &                w10_min  =    0., w10_max  = 45.,   &
   !     &                sst_min  =  270., sst_max  = 310.,  &
   !     &                ice_min  =    0., ice_max  =   1.,  &
   !     &                cx_min   =    0., cx_max   = 0.01,  &
   !     &                rho_min  =   0.8, rho_max  =  1.5       ! density of air
   !CCSM/ccsm2/models/ice/dice5/flux_ai.F90


   !! input variable names within AeroBulk:
   
   CHARACTER(len=32), PUBLIC :: &
      &   cv_sst    = 'xxx', & ! SST                    [K]
      &   cv_patm   = 'xxx', & ! sea-level pressure     [Pa]
      &   cv_t_air  = 'xxx', & ! absolute temperature   [K]
      &   cv_q_air  = 'xxx', & ! specific humidity      [kg/kg]
      &   cv_rh_air = 'xxx', & ! relative humidity      [%]
      &   cv_dp_air = 'xxx', & ! dew-point temperature  [K]
      &   cv_wndspd = 'xxx', & ! wind speed module      [m/s]
      &   cv_u_wnd  = 'xxx', & ! zonal wind speed comp. [m/s]
      &   cv_v_wnd  = 'xxx', & ! reidional "  "    "    [m/s]
      &   cv_radsw  = 'xxx', & ! downwelling shortw. rad. [W/m^2]
      &   cv_radlw  = 'xxx'    ! downwelling longw.  rad. [W/m^2]

CONTAINS


   SUBROUTINE set_variable_names_default()
      cv_sst    = 'sst'
      cv_patm   = 'msl'
      cv_t_air  = 't_air'
      cv_q_air  = 'q_air'
      cv_rh_air = 'rh_air'
      cv_dp_air = 'dp_air'
      cv_wndspd = 'wndspd'
      cv_u_wnd  = 'u10'
      cv_v_wnd  = 'v10'
      cv_radsw  = 'ssrd'
      cv_radlw  = 'strd'
   END SUBROUTINE set_variable_names_default

   SUBROUTINE set_variable_names_ecmwf()
      cv_sst    = 'sst'
      cv_patm   = 'msl'
      cv_t_air  = 't2m'
      cv_q_air  = 'q2m'
      cv_rh_air = 'rh2m'
      cv_dp_air = 'd2m'
      cv_wndspd = 'wndspd'
      cv_u_wnd  = 'u10'
      cv_v_wnd  = 'v10'
      cv_radsw  = 'ssrd'
      cv_radlw  = 'strd'
   END SUBROUTINE set_variable_names_ecmwf
   
   

   SUBROUTINE ctl_stop( cd1, cd2, cd3, cd4, cd5, cd6, cd7, cd8, cd9, cd10 )
      !!----------------------------------------------------------------------
      !!                  ***  ROUTINE  ctl_stop  ***
      !!
      !! ** Purpose :   print in ocean.outpput file a error message and
      !!                increment the error number (nstop) by one.
      !!----------------------------------------------------------------------
      CHARACTER(len=*), INTENT(in), OPTIONAL ::  cd1, cd2, cd3, cd4, cd5
      CHARACTER(len=*), INTENT(in), OPTIONAL ::  cd6, cd7, cd8, cd9, cd10
      INTEGER, PARAMETER :: numout=6
      !!----------------------------------------------------------------------
      !
      !nstop = nstop + 1

      ! force to open ocean.output file
      !IF( numout == 6 ) CALL ctl_opn( numout, 'ocean.output', 'APPEND', 'FORMATTED', 'SEQUENTIAL', -1, 6, .FALSE. )

      WRITE(numout,cform_err)
      IF( PRESENT(cd1 ) )   WRITE(numout,*) TRIM(cd1)
      IF( PRESENT(cd2 ) )   WRITE(numout,*) TRIM(cd2)
      IF( PRESENT(cd3 ) )   WRITE(numout,*) TRIM(cd3)
      IF( PRESENT(cd4 ) )   WRITE(numout,*) TRIM(cd4)
      IF( PRESENT(cd5 ) )   WRITE(numout,*) TRIM(cd5)
      IF( PRESENT(cd6 ) )   WRITE(numout,*) TRIM(cd6)
      IF( PRESENT(cd7 ) )   WRITE(numout,*) TRIM(cd7)
      IF( PRESENT(cd8 ) )   WRITE(numout,*) TRIM(cd8)
      IF( PRESENT(cd9 ) )   WRITE(numout,*) TRIM(cd9)
      IF( PRESENT(cd10) )   WRITE(numout,*) TRIM(cd10)
      WRITE(numout,*) ''
      !CALL FLUSH(numout    )
      !IF( numstp     /= -1 )   CALL FLUSH(numstp    )
      !IF( numrun     /= -1 )   CALL FLUSH(numrun    )
      !IF( numevo_ice /= -1 )   CALL FLUSH(numevo_ice)
      !
      !IF( cd1 == 'STOP' ) THEN
      !   WRITE(numout,*)  'huge E-R-R-O-R : immediate stop'
      !   CALL mppstop(ld_force_abort = .true.)
      !ENDIF
      STOP
      !
   END SUBROUTINE ctl_stop






END MODULE mod_const




!! In CCSM:
!! from CCSM/ccsm2/models/ice/dice5/flux_ai.F90 :


!      REAL, PARAMETER :: cpair  =  1.005e3         !: Specific heat of dry air
!      REAL, PARAMETER :: cpwv   =  1.81e3          !: Specific heat of water vapor
!      REAL, PARAMETER :: cpvir  =  cpwv/cpair - 1. !: Defined as cpwv/cpair - 1.
!      REAL, PARAMETER :: gravit =  9.80616         !: Acceleration of gravity
!      REAL, PARAMETER :: stebol = 56.7e-9          !: Stefan-Boltzmann's constant
!      REAL, PARAMETER :: xkar   =  0.4             !: Von Karman constant
!      REAL, PARAMETER :: zvir   =  0.606           !: rh2o/rair - 1.0
!      REAL, PARAMETER :: zzsice =  0.0005          !: ice surface roughness
!      REAL, PARAMETER :: latvap =  2.5e6           !: latent heat of evaporation
!      REAL, PARAMETER :: latice =   .334e6         !: latent heat of fusion

! AeroBulk / 2021 / L. Brodeau
!
!   When using AeroBulk to produce scientific work, please acknowledge with the following paper:
!
!   Brodeau, L., B. Barnier, S. Gulev, and C. Woods, 2016: Climatologically
!   significant effects of some approximations in the bulk parameterizations of
!   turbulent air-sea fluxes. J. Phys. Oceanogr., doi:10.1175/JPO-D-16-0169.1.


MODULE mod_common_coare

   USE mod_const,   ONLY: wp, rpi, grav, vkarmn, vkarmn2
   USE  mod_phymbl, ONLY: visc_air, Ri_bulk

   IMPLICIT NONE

   INTERFACE first_guess_coare
      MODULE PROCEDURE first_guess_coare_vctr, first_guess_coare_sclr
   END INTERFACE first_guess_coare

   INTERFACE psi_m_coare
      MODULE PROCEDURE psi_m_coare_vctr, psi_m_coare_sclr
   END INTERFACE psi_m_coare

   INTERFACE psi_h_coare
      MODULE PROCEDURE psi_h_coare_vctr, psi_h_coare_sclr
   END INTERFACE psi_h_coare

CONTAINS


   !===============================================================================================
   SUBROUTINE FIRST_GUESS_COARE_SCLR( zt, zu, psst, t_zt, pssq, q_zt, U_zu, pcharn, &
      &                               pus, pts, pqs, t_zu, q_zu, Ubzu,  pz0 )
      !!----------------------------------------------------------------------
      !!                      ***  ROUTINE  FIRST_GUESS_COARE_SCLR  ***
      !!
      !! ** Purpose :  Computes fairly accurate first guess of u*, theta* and q*
      !!               by means of the method developed by Fairall et al in the
      !!               COARE family of algorithms
      !!               Purpose is to limit the number of itteration needed...
      !!
      !! INPUT :
      !! -------
      !!    *  zt   : height for temperature and spec. hum. of air            [m]
      !!    *  zu   : height for wind speed (usually 10m)                     [m]
      !!    *  psst  : bulk SST                                                [K]
      !!    *  t_zt : potential air temperature at zt                         [K]
      !!    *  pssq  : SSQ aka saturation specific humidity at temp. psst       [kg/kg]
      !!    *  q_zt : specific humidity of air at zt                          [kg/kg]
      !!    *  U_zu : scalar wind speed at zu                                 [m/s]
      !!    *  pcharn: Charnock parameter
      !!
      !! OUTPUT :
      !! --------
      !!    *  pus    : FIRST GUESS of u* aka friction velocity                            [m/s]
      !!    *  pts    : FIRST GUESS of theta*                                               [K]
      !!    *  pqs    : FIRST GUESS of q* aka friction velocity                            [kg/kg]
      !!    *  t_zu   : FIRST GUESS of pot. air temperature adjusted at wind height zu      [K]
      !!    *  q_zu   : FIRST GUESS of specific humidity of air        //                   [kg/kg]
      !!    *  Ubzu   : FIRST GUESS of bulk wind speed at zu                                [m/s]
      !!
      !! ** Author: L. Brodeau, May 2021 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      REAL(wp), INTENT(in)  ::   zt
      REAL(wp), INTENT(in)  ::   zu
      REAL(wp), INTENT(in)  ::   psst
      REAL(wp), INTENT(in)  ::   t_zt
      REAL(wp), INTENT(in)  ::   pssq
      REAL(wp), INTENT(in)  ::   q_zt
      REAL(wp), INTENT(in)  ::   U_zu
      REAL(wp), INTENT(in)  ::   pcharn
      !!
      REAL(wp), INTENT(out) ::   pus
      REAL(wp), INTENT(out) ::   pts
      REAL(wp), INTENT(out) ::   pqs
      REAL(wp), INTENT(out) ::   t_zu
      REAL(wp), INTENT(out) ::   q_zu
      REAL(wp), INTENT(out) ::   Ubzu
      REAL(wp), INTENT(out), OPTIONAL :: pz0    ! roughness length [m]
      !
      LOGICAL :: l_zt_equal_zu = .FALSE.      ! if q and t are given at same height as U
      !
      REAL(wp) :: zdt, zdq, zUb, zCd, zus, zts, zqs, zNu_a, zRib
      REAL(wp) :: zlog_zt_o_zu, zlog_10, zlog_zt, zlog_zu, zlog_z0, zlog_z0t, z1_o_sqrt_Cd10, zcc, zcc_ri, z1_o_Ribcu
      REAL(wp) :: zprf, zc_a, zc_b
      REAL(wp) :: zz0, zz0t, zstab, zzeta_u, zzeta_t
      REAL(wp) :: ztmp
      !
      REAL(wp), PARAMETER :: zzi0=600._wp, zBeta0=1.2_wp ! COARE values, after all it's a coare method...
      !
      CHARACTER(len=40), PARAMETER :: crtnm = 'FIRST_GUESS_COARE_SCLR@mod_common_coare.f90'
      !!----------------------------------------------------------------------------------
      l_zt_equal_zu = ( ABS(zu - zt) < 0.01_wp )

      !! First guess of temperature and humidity at height zu:
      t_zu = MAX( t_zt ,  180._wp )   ! who knows what's given on masked-continental regions...
      q_zu = MAX( q_zt , 1.e-6_wp )   !               "

      zz0 = 0.0001 ! "rough" first guess of roughness length of sea surface...

      !! Constants:
      zlog_10 = LOG(10._wp)
      zlog_zt = LOG(zt)
      zlog_zu = LOG(zu)
      zlog_zt_o_zu = LOG(zt/zu)
      zc_a = 0.035_wp*LOG(10._wp/zz0)/LOG(zu/zz0)   !       "                    "               "
      zc_b = 0.004_wp*zzi0*zBeta0*zBeta0*zBeta0

      !! Air-sea differences (and we don't want them to be 0...)
      zdt = t_zu - psst ;   zdt = SIGN( MAX(ABS(zdt),1.E-6_wp), zdt )
      zdq = q_zu - pssq ;   zdq = SIGN( MAX(ABS(zdq),1.E-9_wp), zdq )

      zNu_a = visc_air(t_zu) ! Air viscosity (m^2/s) at zt given from temperature in (K)

      zUb = SQRT(U_zu*U_zu + 0.5_wp*0.5_wp) ! initial guess for wind gustiness contribution

      zus = zc_a*zUb

      !! Update roughness length:
      zz0     = pcharn*zus*zus/grav + 0.11_wp*zNu_a/zus
      zz0     = MIN( MAX(ABS(zz0), 1.E-8) , 1._wp )      ! (prevents FPE from stupid values from masked region later on)
      zlog_z0 = LOG(zz0)

      !! First guess of Cd
      zCd          = (vkarmn/(zlog_zu - zlog_z0))**2
      z1_o_sqrt_Cd10 =       (zlog_10 - zlog_z0)/vkarmn  ! sum less costly than product: log(a/b) == log(a) - log(b)

      !! Temperature/humidity roughness lengthes:
      zz0t  = 10._wp / EXP( vkarmn/( 0.00115*z1_o_sqrt_Cd10 ) )
      zz0t    = MIN( MAX(ABS(zz0t), 1.E-8) , 1._wp )         ! (prevents FPE from stupid values from masked region later on)
      zlog_z0t = LOG(zz0t)

      !! Bulk Richardson Number (BRN)
      zRib = Ri_bulk( zu, psst, t_zu, pssq, q_zu, zUb )

      !! First estimate of zeta_u, depending on the stability, ie sign of BRN (zRib):
      zcc = vkarmn2/(zCd*(zlog_zt - zlog_z0t))
      zcc_ri  = zcc*zRib
      z1_o_Ribcu = -zc_b/zu
      zstab   = 0.5 + SIGN( 0.5_wp , zRib )
      zzeta_u = (1._wp - zstab) *   zcc_ri / (1._wp + zRib*z1_o_Ribcu) & !  Ri_bulk < 0, Unstable
         &  +        zstab      * ( zcc_ri + 27._wp/9._wp*zRib*zRib )    !  Ri_bulk > 0, Stable


      !! u*, theta*, q* :
      zus  = MAX ( zUb*vkarmn/(zlog_zu - zlog_z0  - psi_m_coare(zzeta_u)) , 1.E-9 ) ! (MAX => prevents FPE from stupid values from masked region later on)
      ztmp = vkarmn/(zlog_zu - zlog_z0t - psi_h_coare(zzeta_u))
      zts  = zdt*ztmp
      zqs  = zdq*ztmp
      
      !! Adjustment of theta and q from zt to zu if relevant:
      IF( .NOT. l_zt_equal_zu ) THEN
         zzeta_t = zt*zzeta_u/zu
         zprf = LOG(zt/zu) + psi_h_coare(zzeta_u) - psi_h_coare(zzeta_t)
         t_zu = t_zt - zts/vkarmn*zprf
         q_zu = q_zt - zqs/vkarmn*zprf
         q_zu = (0.5_wp + SIGN(0.5_wp,q_zu))*q_zu ! prevents negative humidity...
         !!
         !! Update of theta and q air-sea differences and theta*, q* :
         zdt = t_zu - psst  ; zdt = SIGN( MAX(ABS(zdt),1.E-6_wp), zdt )
         zdq = q_zu - pssq  ; zdq = SIGN( MAX(ABS(zdq),1.E-9_wp), zdq )
         zts = zdt*ztmp
         zqs = zdq*ztmp
      ENDIF
      
      !! Output result:
      pus  = zus
      pts  = zts
      pqs  = zqs
      Ubzu = zUb

      IF( PRESENT(pz0) ) THEN
         !! Again, because new zus:
         zz0 = pcharn*zus*zus/grav + 0.11_wp*zNu_a/zus
         pz0 = MIN( MAX(ABS(zz0), 1.E-8) , 1._wp )    ! (prevents FPE from stupid values from masked region later on)
      END IF

   END SUBROUTINE FIRST_GUESS_COARE_SCLR

   SUBROUTINE FIRST_GUESS_COARE_VCTR( zt, zu, psst, t_zt, pssq, q_zt, U_zu, pcharn, &
      &                               pus, pts, pqs, t_zu, q_zu, Ubzu,  qz0 )
      !!----------------------------------------------------------------------------------
      REAL(wp), INTENT(in)                  ::   zt
      REAL(wp), INTENT(in)                  ::   zu
      REAL(wp), INTENT(in),  DIMENSION(:,:) ::   psst
      REAL(wp), INTENT(in),  DIMENSION(:,:) ::   t_zt
      REAL(wp), INTENT(in),  DIMENSION(:,:) ::   pssq
      REAL(wp), INTENT(in),  DIMENSION(:,:) ::   q_zt
      REAL(wp), INTENT(in),  DIMENSION(:,:) ::   U_zu
      REAL(wp), INTENT(in),  DIMENSION(:,:) ::   pcharn
      !!
      REAL(wp), INTENT(out), DIMENSION(:,:) ::   pus
      REAL(wp), INTENT(out), DIMENSION(:,:) ::   pts
      REAL(wp), INTENT(out), DIMENSION(:,:) ::   pqs
      REAL(wp), INTENT(out), DIMENSION(:,:) ::   t_zu
      REAL(wp), INTENT(out), DIMENSION(:,:) ::   q_zu
      REAL(wp), INTENT(out), DIMENSION(:,:) ::   Ubzu
      REAL(wp), INTENT(out), DIMENSION(:,:), OPTIONAL :: qz0    ! roughness length [m]
      !
      INTEGER  :: ji, jj
      REAL(wp) :: zz0
      !!----------------------------------------------------------------------------------
      DO jj = 1, SIZE(psst,2)
         DO ji = 1, SIZE(psst,1)
            CALL FIRST_GUESS_COARE_SCLR( zt, zu, psst(ji,jj), t_zt(ji,jj), pssq(ji,jj), q_zt(ji,jj), U_zu(ji,jj), pcharn(ji,jj), &
               &                         pus(ji,jj), pts(ji,jj), pqs(ji,jj), t_zu(ji,jj), q_zu(ji,jj), Ubzu(ji,jj),  pz0=zz0 )
            IF( PRESENT(qz0) ) qz0(ji,jj) = zz0
         END DO
      END DO
   END SUBROUTINE FIRST_GUESS_COARE_VCTR
   !!==============================================================================================



   !!==============================================================================================
   FUNCTION psi_m_coare_sclr( pzeta )
      !!----------------------------------------------------------------------------------
      !! ** Purpose: compute the universal profile stability function for momentum
      !!             COARE 3.0, Fairall et al. 2003
      !!             pzeta : stability paramenter, z/L where z is altitude
      !!                     measurement and L is M-O length
      !!       Stability function for wind speed and scalars matching Kansas and free
      !!       convection forms with weighting f convective form, follows Fairall et
      !!       al (1996) with profile constants from Grachev et al (2000) BLM stable
      !!       form from Beljaars and Holtslag (1991)
      !!
      !! ** Author: L. Brodeau, June 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      REAL(wp) :: psi_m_coare_sclr
      REAL(wp), INTENT(in) :: pzeta
      !!
      REAL(wp) :: zphi_m, zphi_c, zpsi_k, zpsi_c, zf, zc, zstb
      !!----------------------------------------------------------------------------------
      zphi_m = ABS(1. - 15.*pzeta)**.25    !!Kansas unstable
      !
      zpsi_k = 2.*LOG((1. + zphi_m)/2.) + LOG((1. + zphi_m*zphi_m)/2.)   &
         & - 2.*ATAN(zphi_m) + 0.5*rpi
      !
      zphi_c = ABS(1. - 10.15*pzeta)**.3333                   !!Convective
      !
      zpsi_c = 1.5*LOG((1. + zphi_c + zphi_c*zphi_c)/3.) &
         &     - 1.7320508*ATAN((1. + 2.*zphi_c)/1.7320508) + 1.813799447
      !
      zf = pzeta*pzeta
      zf = zf/(1. + zf)
      zc = MIN(50._wp, 0.35_wp*pzeta)
      zstb = 0.5 + SIGN(0.5_wp, pzeta)
      !
      psi_m_coare_sclr = (1. - zstb) * ( (1. - zf)*zpsi_k + zf*zpsi_c ) & ! (pzeta < 0)
         &           -   zstb  * ( 1. + 1.*pzeta     &                ! (pzeta > 0)
         &                          + 0.6667*(pzeta - 14.28)/EXP(zc) + 8.525 )  !     "
      !!
   END FUNCTION psi_m_coare_sclr

   FUNCTION psi_m_coare_vctr( pzeta )
      !!----------------------------------------------------------------------------------
      !! ** Purpose: compute the universal profile stability function for momentum
      !!             COARE 3.0, Fairall et al. 2003
      !!             pzeta : stability paramenter, z/L where z is altitude
      !!                     measurement and L is M-O length
      !!       Stability function for wind speed and scalars matching Kansas and free
      !!       convection forms with weighting f convective form, follows Fairall et
      !!       al (1996) with profile constants from Grachev et al (2000) BLM stable
      !!       form from Beljaars and Holtslag (1991)
      !!
      !! ** Author: L. Brodeau, June 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      REAL(wp), DIMENSION(:,:), INTENT(in)             :: pzeta
      REAL(wp), DIMENSION(SIZE(pzeta,1),SIZE(pzeta,2)) :: psi_m_coare_vctr
      !
      INTEGER  ::   ji, jj    ! dummy loop indices
      REAL(wp) :: zta, zphi_m, zphi_c, zpsi_k, zpsi_c, zf, zc, zstab
      !!----------------------------------------------------------------------------------
      DO jj = 1, SIZE(pzeta,2)
         DO ji = 1, SIZE(pzeta,1)
            !
            zta = pzeta(ji,jj)
            !
            zphi_m = ABS(1. - 15.*zta)**.25    !!Kansas unstable
            !
            zpsi_k = 2.*LOG((1. + zphi_m)/2.) + LOG((1. + zphi_m*zphi_m)/2.)   &
               & - 2.*ATAN(zphi_m) + 0.5*rpi
            !
            zphi_c = ABS(1. - 10.15*zta)**.3333                   !!Convective
            !
            zpsi_c = 1.5*LOG((1. + zphi_c + zphi_c*zphi_c)/3.) &
               &     - 1.7320508*ATAN((1. + 2.*zphi_c)/1.7320508) + 1.813799447
            !
            zf = zta*zta
            zf = zf/(1. + zf)
            zc = MIN(50._wp, 0.35_wp*zta)
            zstab = 0.5 + SIGN(0.5_wp, zta)
            !
            psi_m_coare_vctr(ji,jj) = (1. - zstab) * ( (1. - zf)*zpsi_k + zf*zpsi_c ) & ! (zta < 0)
               &                -   zstab     * ( 1. + 1.*zta     &                ! (zta > 0)
               &                         + 0.6667*(zta - 14.28)/EXP(zc) + 8.525 )  !     "
         END DO
      END DO
   END FUNCTION psi_m_coare_vctr
   !!==============================================================================================


   !!==============================================================================================
   FUNCTION psi_h_coare_sclr( pzeta )
      !!---------------------------------------------------------------------
      !! Universal profile stability function for temperature and humidity
      !! COARE 3.0, Fairall et al. 2003
      !!
      !! pzeta : stability paramenter, z/L where z is altitude measurement
      !!         and L is M-O length
      !!
      !! Stability function for wind speed and scalars matching Kansas and free
      !! convection forms with weighting f convective form, follows Fairall et
      !! al (1996) with profile constants from Grachev et al (2000) BLM stable
      !! form from Beljaars and Holtslag (1991)
      !!
      !! Author: L. Brodeau, June 2016 / AeroBulk
      !!         (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------
      REAL(wp) :: psi_h_coare_sclr
      REAL(wp), INTENT(in) :: pzeta
      !!
      REAL(wp) :: zphi_h, zphi_c, zpsi_k, zpsi_c, zf, zc, zstb
      !!----------------------------------------------------------------
      zphi_h = (ABS(1. - 15.*pzeta))**.5  !! Kansas unstable   (zphi_h = zphi_m**2 when unstable, zphi_m when stable)
      !
      zpsi_k = 2.*LOG((1. + zphi_h)/2.)
      !
      zphi_c = (ABS(1. - 34.15*pzeta))**.3333   !! Convective
      !
      zpsi_c = 1.5*LOG((1. + zphi_c + zphi_c*zphi_c)/3.) &
         &    -1.7320508*ATAN((1. + 2.*zphi_c)/1.7320508) + 1.813799447
      !
      zf = pzeta*pzeta
      zf = zf/(1. + zf)
      zc = MIN(50._wp,0.35_wp*pzeta)
      zstb = 0.5 + SIGN(0.5_wp, pzeta)
      !
      psi_h_coare_sclr = (1.-zstb) * ( (1. - zf)*zpsi_k + zf*zpsi_c ) &
         &                  -zstb  * ( (ABS(1. + 2.*pzeta/3.))**1.5     &
         &                            + .6667*(pzeta - 14.28)/EXP(zc) + 8.525 )
      !!
   END FUNCTION psi_h_coare_sclr

   FUNCTION psi_h_coare_vctr( pzeta )
      !!---------------------------------------------------------------------
      !! Universal profile stability function for temperature and humidity
      !! COARE 3.0, Fairall et al. 2003
      !!
      !! pzeta : stability paramenter, z/L where z is altitude measurement
      !!         and L is M-O length
      !!
      !! Stability function for wind speed and scalars matching Kansas and free
      !! convection forms with weighting f convective form, follows Fairall et
      !! al (1996) with profile constants from Grachev et al (2000) BLM stable
      !! form from Beljaars and Holtslag (1991)
      !!
      !! Author: L. Brodeau, June 2016 / AeroBulk
      !!         (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------
      REAL(wp), DIMENSION(:,:), INTENT(in)             :: pzeta
      REAL(wp), DIMENSION(SIZE(pzeta,1),SIZE(pzeta,2)) :: psi_h_coare_vctr
      !
      INTEGER  ::   ji, jj     ! dummy loop indices
      REAL(wp) :: zta, zphi_h, zphi_c, zpsi_k, zpsi_c, zf, zc, zstab
      !!----------------------------------------------------------------
      DO jj = 1, SIZE(pzeta,2)
         DO ji = 1, SIZE(pzeta,1)
            !
            zta = pzeta(ji,jj)
            !
            zphi_h = (ABS(1. - 15.*zta))**.5  !! Kansas unstable   (zphi_h = zphi_m**2 when unstable, zphi_m when stable)
            !
            zpsi_k = 2.*LOG((1. + zphi_h)/2.)
            !
            zphi_c = (ABS(1. - 34.15*zta))**.3333   !! Convective
            !
            zpsi_c = 1.5*LOG((1. + zphi_c + zphi_c*zphi_c)/3.) &
               &    -1.7320508*ATAN((1. + 2.*zphi_c)/1.7320508) + 1.813799447
            !
            zf = zta*zta
            zf = zf/(1. + zf)
            zc = MIN(50._wp,0.35_wp*zta)
            zstab = 0.5 + SIGN(0.5_wp, zta)
            !
            psi_h_coare_vctr(ji,jj) = (1. - zstab) * ( (1. - zf)*zpsi_k + zf*zpsi_c ) &
               &                -   zstab     * ( (ABS(1. + 2.*zta/3.))**1.5     &
               &                           + .6667*(zta - 14.28)/EXP(zc) + 8.525 )
         END DO
      END DO
   END FUNCTION psi_h_coare_vctr
   !!==============================================================================================

END MODULE mod_common_coare

MODULE mod_aerobulk_wrapper

  USE mod_const
  USE mod_aerobulk, ONLY: AEROBULK_INIT, AEROBULK_BYE
  USE mod_aerobulk_compute

  IMPLICIT NONE

  PRIVATE

  PUBLIC :: AEROBULK_MODEL_NOSKIN, AEROBULK_MODEL_SKIN

CONTAINS

  SUBROUTINE AEROBULK_MODEL_NOSKIN( Ni, Nj, Nt,          &
     &                       calgo, zt, zu, sst, t_zt,   &
     &                       hum_zt, U_zu, V_zu, slp,    &
     &                       Niter,                      &
     &                       QL, QH, Tau_x, Tau_y, Evap)

    INTEGER,                  INTENT(in)  :: Ni, Nj, Nt
    CHARACTER(len=*),         INTENT(in)  :: calgo
    REAL(8),                 INTENT(in)  :: zt, zu
    REAL(8), DIMENSION(Ni,Nj,Nt), INTENT(in)  :: sst, t_zt, hum_zt, U_zu, V_zu, slp
    INTEGER,                  INTENT(in) :: Niter
    REAL(8), DIMENSION(Ni,Nj,Nt), INTENT(out) :: QL, QH, Tau_x, Tau_y, Evap

    INTEGER n

    nb_iter = Niter

    !! initialize based on first timestep
    CALL AEROBULK_INIT(Nt, calgo, sst(:, :, 1), t_zt(:, :, 1), &
        &              hum_zt(:, :, 1), U_zu(:, :, 1), V_zu(:, :, 1), slp(:, :, 1), &
        &              l_use_skin=.FALSE. )

    DO n = 1, Nt
       CALL AEROBULK_COMPUTE(n, calgo, zt, zu, sst(:, :, n), t_zt(:, :, n), &
          &                  hum_zt(:, :, n), U_zu(:, :, n), V_zu(:, :, n), slp(:, :, n),  &
          &                  QL(:, :, n), QH(:, :, n), Tau_x(:, :, n), Tau_y(:, :, n),     &
          &                  Evp=Evap(:, :, n))
    END DO

    CALL AEROBULK_BYE()

  END SUBROUTINE AEROBULK_MODEL_NOSKIN

  SUBROUTINE AEROBULK_MODEL_SKIN( Ni, Nj, Nt,          &
     &                       calgo, zt, zu, sst, t_zt,   &
     &                       hum_zt, U_zu, V_zu, slp,    &
     &                       rad_sw, rad_lw,             &
     &                       Niter,                      &
     &                       QL, QH, Tau_x, Tau_y, T_s, Evap)

    INTEGER,                  INTENT(in)  :: Ni, Nj, Nt
    CHARACTER(len=*),         INTENT(in)  :: calgo
    REAL(8),                 INTENT(in)  :: zt, zu
    REAL(8), DIMENSION(Ni,Nj,Nt), INTENT(in)  :: sst, t_zt, hum_zt, U_zu, V_zu, slp, rad_sw, rad_lw
    INTEGER,                  INTENT(in) :: Niter
    REAL(8), DIMENSION(Ni,Nj,Nt), INTENT(out) :: QL, QH, Tau_x, Tau_y, T_s, Evap

    INTEGER n

    nb_iter = Niter

    !! initialize based on first timestep
    CALL AEROBULK_INIT(Nt, calgo, sst(:, :, 1), t_zt(:, :, 1), &
        &              hum_zt(:, :, 1), U_zu(:, :, 1), V_zu(:, :, 1), slp(:, :, 1), &
        &              l_use_skin=.TRUE., prsw=rad_sw(:, :, 1), prlw=rad_lw(:, :, 1))

    DO n = 1, Nt
       CALL AEROBULK_COMPUTE(n, calgo, zt, zu, sst(:, :, n), t_zt(:, :, n), &
          &                  hum_zt(:, :, n), U_zu(:, :, n), V_zu(:, :, n), slp(:, :, n),  &
          &                  QL(:, :, n), QH(:, :, n), Tau_x(:, :, n), Tau_y(:, :, n),     &
          &                  rad_sw=rad_sw(:, :, n), rad_lw=rad_lw(:, :, n), T_s=T_s(:, :, n), Evp=Evap(:, :, n))
    END DO

    CALL AEROBULK_BYE()

  END SUBROUTINE AEROBULK_MODEL_SKIN

END MODULE mod_aerobulk_wrapper

! AeroBulk / 2016 / L. Brodeau
!
!   When using AeroBulk to produce scientific work, please acknowledge with the following citation:
!
!   Brodeau, L., B. Barnier, S. Gulev, and C. Woods, 2016: Climatologically
!   significant effects of some approximations in the bulk parameterizations of
!   turbulent air-sea fluxes. J. Phys. Oceanogr., doi:10.1175/JPO-D-16-0169.1.
!
!
MODULE mod_aerobulk

   USE mod_const
   USE mod_phymbl, ONLY: type_of_humidity, check_unit_consistency
   USE mod_aerobulk_compute

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: AEROBULK_INIT, AEROBULK_MODEL, AEROBULK_BYE

CONTAINS

   SUBROUTINE AEROBULK_INIT( Nt, calgo, psst, pta, pha, pU, pV, pslp,  l_use_skin, prsw, prlw )
      !!===========================================================================================
      !! 1. Set the official 2D shape of the problem based on the `psst` array =>[Ni,Nj]
      !! 2. Check on size agreement between input arrays (must all be [Ni,Nj])
      !! 3. Allocate and fill the `imask` array to disregar "apparent problematic" regions...
      !! 4. Decide the type of humidity in use: specific? relative? dew-point? (saved and shared via mod_const)
      !!
      INTEGER,                  INTENT(in)  :: Nt    !: number of time records to go for...
      CHARACTER(len=*),         INTENT(in)  :: calgo !: what bulk algorithm to use => 'coare'/'ncar'/'ecmwf'/'andreas'
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: psst  !: sea surface temperature             [K]
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pta   !: absolute air temperature at z=zt    [K]
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pha   !: air humidity at z=zt, can be:
      !!                                                - specific humidity                 [kg/kg]
      !!                                                - dew-point temperature             [K]
      !!                                                - relative humidity                 [%]
      !!                                               => type is normally be recognized based on value range
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pU, pV !: wind vector components at z=zu     [m/s]
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pslp   !: sea-level atmospheric pressure     [Pa]
      !!
      !! OPTIONAL Input
      LOGICAL,                  INTENT(in), OPTIONAL :: l_use_skin
      REAL(wp), DIMENSION(:,:), INTENT(in), OPTIONAL :: prsw   !: downwelling shortwave radiation  [W/m^2]
      REAL(wp), DIMENSION(:,:), INTENT(in), OPTIONAL :: prlw   !: downwelling  longwave radiation  [W/m^2]
      !!==================================================================================================
      LOGICAL :: lsrad, lskin
      INTEGER :: Ni, Nj, np
      CHARACTER(len=64) :: chum_ln
      INTEGER(1), DIMENSION(:,:), ALLOCATABLE :: imask   !: mask array: masked=>0, elsewhere=>1
      !!==================================================================================================
      lsrad = .FALSE.
      lsrad = ( PRESENT(prsw) .AND. PRESENT(prlw) )

      lskin = .FALSE.
      IF( PRESENT(l_use_skin) ) lskin = l_use_skin

      WRITE(6,*)''
      WRITE(6,*)'==================================================================='
      WRITE(6,*)'                   ----- AeroBulk_init -----'
      WRITE(6,*)''

      WRITE(6,*)'    *** Bulk parameterization to be used => "', TRIM(calgo), '"'

      ! 1. Check if scheme use compatible with chosen algorithm and presence of radiative fields
      IF( lskin ) THEN

         IF( .NOT.((TRIM(calgo(1:4)) == 'coar').OR.(TRIM(calgo) == 'ecmwf')) ) &
            & CALL ctl_stop(' AEROBULK_INIT => Only `COARE*` and `ECMWF` algorithms support cool-skin & warm/layer schemes')

         IF( .NOT.(lsrad) ) CALL ctl_stop(' AEROBULK_INIT => provide SW and LW rad. input if you want to use skin schemes')

         l_use_skin_schemes = .TRUE. ! if we go here it's fine!
         WRITE(6,*)'       ==> will use the Cool-skin & Warm-ayer scheme of `'//TRIM(calgo)//'` !'

      ELSE
         WRITE(6,*)'    *** Cool-skin & Warm-layer schemes will NOT be used!'
      END IF


      ! 2.
      Ni = SIZE(psst,1)
      Nj = SIZE(psst,2)

      ! 3.
      IF( ANY(SHAPE(pta) /=(/Ni,Nj/)) ) CALL ctl_stop(' AEROBULK_INIT => SST and t_air arrays do not agree in shape!')
      IF( ANY(SHAPE(pha) /=(/Ni,Nj/)) ) CALL ctl_stop(' AEROBULK_INIT => SST and hum_air arrays do not agree in shape!')
      IF( ANY(SHAPE(pU)  /=(/Ni,Nj/)) ) CALL ctl_stop(' AEROBULK_INIT => SST and U arrays do not agree in shape!')
      IF( ANY(SHAPE(pV)  /=(/Ni,Nj/)) ) CALL ctl_stop(' AEROBULK_INIT => SST and V arrays do not agree in shape!')
      IF( ANY(SHAPE(pslp)/=(/Ni,Nj/)) ) CALL ctl_stop(' AEROBULK_INIT => SST and SLP arrays do not agree in shape!')
      IF( lsrad ) THEN
         IF( ANY(SHAPE(prsw)/=(/Ni,Nj/)) ) CALL ctl_stop(' AEROBULK_INIT => SST and Rad_SW arrays do not agree in shape!')
         IF( ANY(SHAPE(prlw)/=(/Ni,Nj/)) ) CALL ctl_stop(' AEROBULK_INIT => SST and Rad_LW arrays do not agree in shape!')
      END IF

      WRITE(6,'("     *** Computational domain shape: Ni x Nj = ",i5.5," x ",i5.5)') Ni, Nj

      nitend = Nt   ! important: nitend is a global variable shared by `mod_const.f90`
      WRITE(6,*)'    *** Number of time records that will be treated:', nitend

      WRITE(6,*)'    *** Number of iterations in bulk algos: nb_iter  =', INT(nb_iter,1)

      ! 4. Allocation and creation of the mask
      ALLOCATE( imask(Ni,Nj) )
      WRITE(6,*)'    *** Filling the `mask` array...'
      imask(:,:) = 1
      WHERE( (psst < ref_sst_min) .OR. (psst > ref_sst_max) ) imask = 0 ! silly SST
      WHERE( ( pta < ref_taa_min) .OR. (pta  > ref_taa_max) ) imask = 0 ! silly air temperature
      WHERE( (pslp < ref_slp_min) .OR. (pslp > ref_slp_max) ) imask = 0 ! silly atmospheric pressure
      WHERE(     SQRT( pU*pU + pV*pV )       > ref_wnd_max  ) imask = 0 ! silly scalar wind speed
      IF( lsrad ) THEN
         WHERE( ( prsw < ref_rsw_min) .OR. (prsw  > ref_rsw_max) ) imask = 0 ! silly air temperature
         WHERE( ( prlw < ref_rlw_min) .OR. (prlw  > ref_rlw_max) ) imask = 0 ! silly air temperature
      END IF
      np = SUM(INT(imask,4))  ! number of valid points (convert to INT(4) before SUM otherwize SUM is INT(1) => overflow!!!)
      IF( np == Ni*Nj ) THEN
         WRITE(6,*)'        ==> no points need to be masked! :)'
      ELSEIF ( np > 0 ) THEN
         WRITE(6,*)'        ==> number of points to mask: ', Ni*Nj-np, ' (out of ',Ni*Nj,')'
      ELSE
         CALL ctl_stop( 'the whole domain is masked!', 'check unit consistency of input fields')
         !STOP
      END IF

      ! 5. Type of humidity provided?
      ctype_humidity = type_of_humidity( pha, mask=imask )
      SELECT CASE(ctype_humidity)
      CASE('sh')
         chum_ln = 'specific humidity [kg/kg]'
      CASE('rh')
         chum_ln = 'relative humidity [%]'
      CASE('dp')
         chum_ln = 'dew-point temperature [K]'
      CASE DEFAULT
         CALL ctl_stop( ' AEROBULK_INIT => humidty type "',ctype_humidity,'" is unknown!!!' )
      END SELECT


      WRITE(6,'("     *** Type of prescribed air humidity  `",a,"`")') TRIM(chum_ln)

      ! 6. Check unit consistency of input fields:
      CALL check_unit_consistency( 'sst',   psst, mask=imask )
      CALL check_unit_consistency( 't_air', pta,  mask=imask )
      CALL check_unit_consistency( 'slp',   pslp, mask=imask )
      CALL check_unit_consistency( 'u10',   pU,   mask=imask )
      CALL check_unit_consistency( 'v10',   pV,   mask=imask )
      CALL check_unit_consistency( 'wnd',   SQRT(pU*pU + pV*pV), mask=imask )
      CALL check_unit_consistency( ctype_humidity, pha,          mask=imask )
      IF( lsrad ) THEN
         CALL check_unit_consistency( 'rad_sw',   prsw, mask=imask )
         CALL check_unit_consistency( 'rad_lw',   prlw, mask=imask )
      END IF

      DEALLOCATE( imask )

      WRITE(6,*)'==================================================================='
      !WRITE(6,*)''

   END SUBROUTINE AEROBULK_INIT



   SUBROUTINE AEROBULK_BYE()
      WRITE(6,*)'==================================================================='
      WRITE(6,*)'                   ----- AeroBulk_bye -----'
      !DEALLOCATE( imask )
      WRITE(6,*)'==================================================================='
      WRITE(6,*)''
   END SUBROUTINE AEROBULK_BYE





   SUBROUTINE AEROBULK_MODEL( jt, Nt, &
      &                       calgo, zt, zu, sst, t_zt,   &
      &                       hum_zt, U_zu, V_zu, slp,    &
      &                       QL, QH, Tau_x, Tau_y, Evap, &
      &                       Niter, l_use_skin, rad_sw, rad_lw, T_s  )
      !!======================================================================================
      !!
      !! INPUT :
      !! -------
      !!    *  jt,Nt  : current time snaphot and total number of time snaphots to go for
      !!    *  calgo  : what bulk algorithm to use => 'coare'/'ncar'/'ecmwf'
      !!    *  zt     : height for temp. & spec. hum. of air (usually 2 or 10) [m]
      !!    *  zu     : height for wind (usually 10)                           [m]
      !!    *  sst    : SST                                                    [K]
      !!    *  t_zt   : ABSOLUTE air temperature at zt                         [K]
      !!    *  hum_zt : air humidity at zt, can be given as:
      !!                - specific humidity                                [kg/kg]
      !!                - dew-point temperature                                [K]
      !!                - relative humidity                                    [%]
      !!               => type should normally be recognized based on value range
      !!    *  U_zu   : zonal wind speed at zu                                 [m/s]
      !!    *  V_zu   : meridional wind speed at zu                            [m/s]
      !!    *  slp    : mean sea-level pressure                                [Pa] ~101000 Pa
      !!
      !! OUTPUT :
      !! --------
      !!    *  QL     : Latent heat flux                                     [W/m^2]
      !!    *  QH     : Sensible heat flux                                   [W/m^2]
      !!    *  Tau_x  : zonal wind stress                                    [N/m^2]
      !!    *  Tau_y  : zonal wind stress                                    [N/m^2]
      !!    *  Evap    : Evaporation                                          [mm/s] aka [kg/m^2/s] (usually <0, as ocean loses water!)
      !!
      !! OPTIONAL Input:
      !! ---------------
      !!    *  Niter  : number of itterattions in the bulk algorithm (default is 4)
      !!    *  l_use_skin: should we use the cool-skin & warm-layer schemes fot skin temperature ?
      !!    *  rad_sw : downwelling shortwave radiation at the surface (>0)   [W/m^2]
      !!    *  rad_lw : downwelling longwave radiation at the surface  (>0)   [W/m^2]
      !!
      !! OPTIONAL Output:
      !! ---------------
      !!    *  T_s    : skin temperature                                      [K]
      !!
      !!====================================================================================================
      INTEGER,                  INTENT(in)  :: jt, Nt
      CHARACTER(len=*),         INTENT(in)  :: calgo
      REAL(wp),                 INTENT(in)  :: zt, zu
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: sst, t_zt, hum_zt, U_zu, V_zu, slp
      REAL(wp), DIMENSION(:,:), INTENT(out) :: QL, QH, Tau_x, Tau_y, Evap
      !! Optional input:
      INTEGER,                  INTENT(in), OPTIONAL :: Niter
      LOGICAL,                  INTENT(in), OPTIONAL :: l_use_skin
      REAL(wp), DIMENSION(:,:), INTENT(in), OPTIONAL :: rad_sw, rad_lw
      !! Optional output:
      REAL(wp), DIMENSION(:,:), INTENT(out),OPTIONAL :: T_s
      !!
      !! Local:
      LOGICAL :: lskin, lsrad
      !!====================================================================================================

      IF( PRESENT(Niter) )      nb_iter = Niter  ! Updating number of itterations (define in mod_const)

      lskin = .FALSE.
      IF( PRESENT(l_use_skin) ) lskin = l_use_skin

      lsrad = .FALSE.
      lsrad = ( PRESENT(rad_sw) .AND. PRESENT(rad_lw) ) ! if theser 2 are provided we NORMALLY plan to use the CSWL schemes!

      IF( jt <1 ) CALL ctl_stop('AEROBULK_MODEL => jt < 1 !??', 'we are in a Fortran world here...')

      IF( lsrad ) THEN

         IF( jt==1 ) CALL AEROBULK_INIT( Nt, calgo, sst, t_zt, hum_zt, U_zu, V_zu, slp,  l_use_skin=lskin, prsw=rad_lw, prlw=rad_lw )

         CALL AEROBULK_COMPUTE( jt, calgo, zt, zu, sst, t_zt, &
            &                   hum_zt, U_zu, V_zu, slp,      &
            &                   QL, QH, Tau_x, Tau_y,         &
            &                   rad_sw=rad_sw, rad_lw=rad_lw, T_s=T_s, Evp=Evap )

      ELSE

         IF( jt==1 ) CALL AEROBULK_INIT( Nt, calgo, sst, t_zt, hum_zt, U_zu, V_zu, slp,  l_use_skin=lskin )

         CALL AEROBULK_COMPUTE( jt, calgo, zt, zu, sst, t_zt, &
            &                   hum_zt, U_zu, V_zu, slp,  &
            &                   QL, QH, Tau_x, Tau_y,     &
            &                   Evp=Evap)

      END IF


      IF( jt==Nt ) CALL AEROBULK_BYE()

   END SUBROUTINE AEROBULK_MODEL

END MODULE mod_aerobulk

! AeroBulk / 2016 / L. Brodeau
!
!   When using AeroBulk to produce scientific work, please acknowledge with the following citation:
!
!   Brodeau, L., B. Barnier, S. Gulev, and C. Woods, 2016: Climatologically
!   significant effects of some approximations in the bulk parameterizations of
!   turbulent air-sea fluxes. J. Phys. Oceanogr., doi:10.1175/JPO-D-16-0169.1.
!
!
MODULE mod_skin_coare
   !!====================================================================================
   !!       Cool-Skin and warm-layer correction of SST
   !!    Cool-skin and warm-layer parametrization (Fairall et al. 1996)
   !!
   !!       Routine "cs_coare" and "wl_coare" maintained and developed in AeroBulk
   !!                     (https://github.com/brodeau/aerobulk/)
   !!
   !!            Author: Laurent Brodeau, 2019
   !!
   !!====================================================================================
   USE mod_const   !: physical and othe constants
   USE mod_phymbl  !: thermodynamics

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: CS_COARE, WL_COARE

   !! Warm-layer related arrays:
   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:), PUBLIC :: &
      &                        dT_wl,     &  !: dT due to warm-layer effect => difference between "almost surface (right below viscous layer, z=delta)
                                !!                                     !: and depth of bulk SST (z=gdept_1d(1))
      &                        Hz_wl,     &  !: depth of warm-layer [m]
      &                        Qnt_ac,    &  !: time integral / accumulated heat stored by the warm layer Qxdt => [J/m^2] (reset to zero every midnight)
      &                        Tau_ac        !: time integral / accumulated momentum Tauxdt => [N.s/m^2] (reset to zero every midnight)

   REAL(wp), PARAMETER, PUBLIC :: Hwl_max = 20._wp    !: maximum depth of warm layer (adjustable)
   !
   REAL(wp), PARAMETER :: Rich0   = 0.65_wp   !: critical Richardson number
   !
   REAL(wp), PARAMETER :: zfr0   = 0.5_wp     !: initial value of solar flux absorption
   !
   !!----------------------------------------------------------------------

CONTAINS
   
   SUBROUTINE CS_COARE( pQsw, pQnsol, pustar, pSST, pQlat, pdT_cs )
      !!---------------------------------------------------------------------
      !!
      !! Cool-skin parameterization, based on Fairall et al., 1996, revisited for COARE 3.6 (Fairall et al., 2019)
      !!
      !! Fairall, C. W., Bradley, E. F., Godfrey, J. S., Wick, G. A.,
      !! Edson, J. B., and Young, G. S. ( 1996), Cool‐skin and warm‐layer
      !! effects on sea surface temperature, J. Geophys. Res., 101( C1), 1295-1308,
      !! doi:10.1029/95JC03190.
      !!
      !!------------------------------------------------------------------
      !!
      !!  **   INPUT:
      !!     *pQsw*       surface net solar radiation into the ocean     [W/m^2] => >= 0 !
      !!     *pQnsol*     surface net non-solar heat flux into the ocean [W/m^2] => normally < 0 !
      !!     *pustar*     friction velocity u*                           [m/s]
      !!     *pSST*       bulk SST (taken at depth gdept_1d(1))          [K]
      !!     *pQlat*      surface latent heat flux                       [K]
      !!------------------------------------------------------------------
      REAL(wp), INTENT(in) :: pQsw   ! net solar a.k.a shortwave radiation into the ocean (after albedo) [W/m^2]
      REAL(wp), INTENT(in) :: pQnsol ! non-solar heat flux to the ocean [W/m^2]
      REAL(wp), INTENT(in) :: pustar ! friction velocity, temperature and humidity (u*,t*,q*)
      REAL(wp), INTENT(in) :: pSST   ! bulk SST [K]
      REAL(wp), INTENT(in) :: pQlat  ! latent heat flux [W/m^2]
      REAL(wp), INTENT(out):: pdT_cs !: dT due to cool-skin effect => temperature difference between 
      !!                             !: air-sea interface (z=0) and right below viscous layer (z=delta)
      !!---------------------------------------------------------------------
      INTEGER  :: jc
      REAL(wp) :: zQabs, zdelta, zfr
      !!---------------------------------------------------------------------
      zQabs = pQnsol ! first guess of heat flux absorbed within the viscous sublayer of thicknes delta,
      !              !   => we DO not miss a lot assuming 0 solar flux absorbed in the tiny layer of thicknes zdelta...

      zdelta = delta_skin_layer_sclr( alpha_sw(pSST), zQabs, pustar,  Qlat=pQlat )

      DO jc = 1, 4 ! because implicit in terms of zdelta...
         ! Solar absorption, Eq.16 (Fairall al. 1996b):
         zfr = MAX( 0.137_wp + 11._wp*zdelta - 6.6E-5_wp/zdelta*(1._wp - EXP(-zdelta/8.E-4_wp)) , 0.01_wp )
         !!              !LB: why 0.065 and not 0.137 like in the paper??? Beljaars & Zeng use 0.065, not 0.137 !
         zQabs = pQnsol + zfr*pQsw
         zdelta = delta_skin_layer_sclr( alpha_sw(pSST), zQabs, pustar,  Qlat=pQlat )
      END DO

      pdT_cs = zQabs*zdelta/rk0_w   ! temperature increment, yes dT_cs can actually > 0, if Qabs > 0 (rare but possible!)

   END SUBROUTINE CS_COARE



   SUBROUTINE WL_COARE( ki, kj, pQsw, pQnsol, pTau, pSST, plon, isd, iwait )
      !!---------------------------------------------------------------------
      !!
      !!  Warm-Layer scheme according to COARE 3.6 (Fairall et al, 2019)
      !!     ------------------------------------------------------------------
      !!
      !!  **   INPUT:
      !!     *pQsw*       surface net solar radiation into the ocean     [W/m^2] => >= 0 !
      !!     *pQnsol*     surface net non-solar heat flux into the ocean [W/m^2] => normally < 0 !
      !!     *pTau*       surface wind stress                            [N/m^2]
      !!     *pSST*       bulk SST  (taken at depth gdept_1d(1))         [K]
      !!     *plon*       longitude                                      [deg.E]
      !!     *isd*        current UTC time, counted in second since 00h of the current day
      !!     *iwait*      if /= 0 then wait before updating accumulated fluxes, we are within a converging itteration loop...
      !!---------------------------------------------------------------------
      INTEGER , INTENT(in) :: ki, kj
      REAL(wp), INTENT(in) :: pQsw     ! surface net solar radiation into the ocean [W/m^2]     => >= 0 !
      REAL(wp), INTENT(in) :: pQnsol   ! surface net non-solar heat flux into the ocean [W/m^2] => normally < 0 !
      REAL(wp), INTENT(in) :: pTau     ! wind stress [N/m^2]
      REAL(wp), INTENT(in) :: pSST     ! bulk SST at depth gdept_1d(1) [K]
      REAL(wp), INTENT(in) :: plon     ! longitude [deg.E]
      INTEGER , INTENT(in) :: isd      ! current UTC time, counted in second since 00h of the current day
      INTEGER , INTENT(in) :: iwait    ! if /= 0 then wait before updating accumulated fluxes
      !
      REAL(wp) :: zdTwl, zHwl, zQabs, zfr
      REAL(wp) :: zqac, ztac
      REAL(wp) :: zalpha, zcd1, zcd2, flg
      REAL(wp) :: rlag_gw_h, &  ! local solar time lag in hours   / Greenwich meridian (lon==0) => ex: ~ -10.47 hours for Hawai
         &        rhr_sol       ! local solar time in hours since midnight
      INTEGER  :: ilag_gw_s, &  ! local solar time LAG in seconds / Greenwich meridian (lon==0) => ex: ~ INT( -10.47*3600. ) seconds for Hawai
         &        isd_sol,   &  ! local solar time in number of seconds since local solar midnight
         &        jl
      LOGICAL :: l_exit, l_destroy_wl
      !!---------------------------------------------------------------------

      !! INITIALIZATION:
      zQabs  = 0._wp       ! total heat flux absorped in warm layer
      zfr    = zfr0        ! initial value of solar flux absorption !LOLO: save it and use previous value !!!

      l_exit       = .FALSE.
      l_destroy_wl = .FALSE.

      zdTwl =          dT_wl(ki,kj)                    ! value of previous time step as first guess
      zHwl  = MAX( MIN(Hz_wl(ki,kj),Hwl_max),0.1_wp)   !   "                  "           "

      zqac = Qnt_ac(ki,kj) ! previous time step Qnt_ac
      ztac = Tau_ac(ki,kj)

      !! Need to know the local solar time from longitude and isd:
      rlag_gw_h = -1._wp * MODULO( ( 360._wp - MODULO(plon,360._wp) ) / 15._wp , 24._wp )
      rlag_gw_h = -1._wp * SIGN( MIN(ABS(rlag_gw_h) , ABS(MODULO(rlag_gw_h,24._wp))), rlag_gw_h + 12._wp )
      ilag_gw_s = INT( rlag_gw_h*3600._wp )
      isd_sol = MODULO( isd + ilag_gw_s , 24*3600 )
      rhr_sol = REAL( isd_sol , wp) / 3600._wp

      !*****  variables for warm layer  ***
      zalpha = alpha_sw( pSST ) ! thermal expansion coefficient of sea-water (SST accurate enough!)

      zcd1 = SQRT(2._wp*Rich0*rCp0_w/(zalpha*grav*rho0_w))        !mess-o-constants 1
      zcd2 = SQRT(2._wp*zalpha*grav/(Rich0*rho0_w))/(rCp0_w**1.5) !mess-o-constants 2


      IF ( (rhr_sol > 4._wp).AND.(rhr_sol <= 6.5_wp) ) THEN
         ! Dawn reset to 0!
         l_exit       = .TRUE.
         l_destroy_wl = .TRUE.
      END IF

      IF ( .NOT. l_exit ) THEN
         !! Initial test on initial guess of absorbed heat flux in warm-layer:
         zfr = 1._wp - ( 0.28*0.014*(1. - EXP(-zHwl/0.014)) + 0.27*0.357*(1. - EXP(-zHwl/0.357)) &
            &        + 0.45*12.82*(1-EXP(-zHwl/12.82)) ) / zHwl
         zQabs = zfr*pQsw + pQnsol ! first guess of tot. heat flux absorbed in warm layer !LOLO: depends of zfr, which is wild guess... Wrong!!!

         IF ( (ABS(zdTwl) < 1.E-6_wp) .AND. (zQabs <= 0._wp) ) THEN
            ! We have not started to build a WL yet (dT==0) and there's no way it can occur now
            ! since zQabs <= 0._wp
            ! => no need to go further
            l_exit = .TRUE.
         END IF

      END IF

      ! Okay test on updated absorbed flux:
      !LOLO: remove??? has a strong influence !!!
      IF ( (.NOT.(l_exit)) .AND. (Qnt_ac(ki,kj) + zQabs*rdt <= 0._wp) ) THEN
         l_exit       = .TRUE.
         l_destroy_wl = .TRUE.
      END IF


      IF ( .NOT. l_exit) THEN

         ! Two possibilities at this point:
         ! 1/ A warm layer already exists (dT>0) but it is cooling down because Qabs<0
         ! 2/ Regardless of WL formed (dT==0 or dT>0), we are in the process to initiate one or warm further it !

         !PRINT *, '#LBD:======================================================'
         !PRINT *, '#LBD: WL action makes sense now! => zQabs,dT_wl=', REAL(zQabs,4), REAL(zdTwl,4)
         !PRINT *, '#LBD:======================================================'
         !PRINT *, '#LBD: current values for Qac and Tac=', REAL(Qnt_ac(ki,kj),4), REAL(Tau_ac(ki,kj),4)

         ztac = Tau_ac(ki,kj) + MAX(.002_wp , pTau)*rdt      ! updated momentum integral
         !PRINT *, '#LBD: updated value for Tac=',  REAL(ztac,4)

         !! We update the value of absorbtion and zQabs:
         !! some part is useless if Qsw=0 !!!
         DO jl = 1, 5
            zfr = 1. - ( 0.28*0.014*(1. - EXP(-zHwl/0.014)) + 0.27*0.357*(1. - EXP(-zHwl/0.357)) &
               &        + 0.45*12.82*(1-EXP(-zHwl/12.82)) ) / zHwl
            zQabs = zfr*pQsw + pQnsol
            zqac  = Qnt_ac(ki,kj) + zQabs*rdt ! updated heat absorbed
            IF ( zqac <= 0._wp ) EXIT
            zHwl = MAX( MIN( Hwl_max , zcd1*ztac/SQRT(zqac)) , 0.1_wp ) ! Warm-layer depth
         END DO
         !PRINT *, '#LBD: updated absorption and WL depth=',  REAL(zfr,4), REAL(zHwl,4)
         !PRINT *, '#LBD: updated value for Qabs=',  REAL(zQabs,4), 'W/m2'
         !PRINT *, '#LBD: updated value for Qac =',  REAL(zqac,4), 'J'

         IF ( zqac <= 0._wp ) THEN
            l_destroy_wl = .TRUE.
            l_exit       = .TRUE.
         ELSE
            zdTwl = zcd2*zqac**1.5/ztac * MAX(zqac/ABS(zqac),0._wp)  !! => IF(zqac>0._wp): zdTwl=zcd2*zqac**1.5/ztac ; ELSE: zdTwl=0. / ! normally: zqac > 0 !
            !PRINT *, '#LBD: updated preliminary value for dT_wl=',  REAL(zdTwl,4)
            ! Warm layer correction
            flg = 0.5_wp + SIGN( 0.5_wp , gdept_1d(1)-zHwl )               ! => 1 when gdept_1d(1)>zHwl (zdTwl = zdTwl) | 0 when gdept_1d(1)<zHwl (zdTwl = zdTwl*gdept_1d(1)/zHwl)
            zdTwl = zdTwl * ( flg + (1._wp-flg)*gdept_1d(1)/zHwl )
         END IF

      END IF !IF ( .NOT. l_exit)

      IF ( l_destroy_wl ) THEN
         zdTwl = 0._wp
         zfr   = 0.75_wp
         zHwl  = Hwl_max
         zqac  = 0._wp
         ztac  = 0._wp
      END IF

      !PRINT *, '#LBD: exit values for Qac & Tac:', REAL(zqac,4), REAL(ztac,4)

      IF ( iwait == 0 ) THEN
         !! Iteration loop within bulk algo is over, time to update what needs to be updated:
         dT_wl(ki,kj)  = zdTwl
         Hz_wl(ki,kj)  = zHwl
         !PRINT *, '#LBD: FINAL EXIT values for dT_wl & Hz_wl:', REAL(dT_wl(ki,kj),4), REAL(Hz_wl(ki,kj),4)
         Qnt_ac(ki,kj) = zqac ! Updating Qnt_ac, heat integral
         Tau_ac(ki,kj) = ztac
         !PRINT *, '#LBD: FINAL EXIT values for Qac & Tac:', REAL(Qnt_ac(ki,kj),4), REAL(Tau_ac(ki,kj),4)
         !PRINT *, '#LBD'
      END IF

   END SUBROUTINE WL_COARE

   !!======================================================================
END MODULE mod_skin_coare

! AeroBulk / 2015 / L. Brodeau

MODULE mod_blk_neutral_10m

   !!====================================================================================
   !!
   !!   Momentum, Latent and sensible heat exchange coefficients
   !!          In neutral conditions / at 10m
   !!
   !!            Author: Laurent Brodeau, 2016
   !!
   !!====================================================================================

   USE mod_const   !: physical and othe constants
   USE mod_phymbl,       ONLY: z0_from_Cd
   USE mod_blk_ncar,     ONLY: CD_N10_NCAR, CH_N10_NCAR, CE_N10_NCAR
   USE mod_blk_coare3p0, ONLY: charn_coare3p0
   USE mod_blk_coare3p6, ONLY: charn_coare3p6
   USE mod_blk_ecmwf,    ONLY: charn0_ecmwf
   USE mod_blk_andreas,  ONLY: u_star_andreas

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: TURB_NEUTRAL_10M

   REAL(wp), PARAMETER :: zu  = 10._wp     ! we're at 10m !


CONTAINS

   SUBROUTINE turb_neutral_10m( calgo, U_N10, CdN10, ChN10, CeN10, pz0 )
      !!----------------------------------------------------------------------
      !!                      ***  ROUTINE  turb_neutral_10m  ***
      !!
      !!            2015: L. Brodeau
      !!
      !! ** Purpose :   Computes turbulent neutra transfert coefficients at 10m
      !!                from the neutral wind speed at 10m
      !!                according to ...
      !!
      !!======================================================================================
      !!
      !! INPUT :
      !! -------
      !!    *  calgo : name of the algo to use
      !!    *  U_N10 : scalar wind speed at 10m                                [m/s]
      !!
      !! OUTPUT :
      !! --------
      !!    *  CdN10     : drag coefficient
      !!    *  ChN10     : sensible heat coefficient
      !!    *  CeN10     : evaporation coefficient
      !!
      !!============================================================================


      CHARACTER(len=*),         INTENT(in)    ::   calgo
      REAL(wp), DIMENSION(:,:), INTENT(in   ) ::   U_N10       ! relative wind module at zu            [m/s]
      REAL(wp), DIMENSION(:,:), INTENT(  out) ::   CdN10       ! transfer coefficient for momentum         (tau)
      REAL(wp), DIMENSION(:,:), INTENT(  out) ::   ChN10       ! transfer coefficient for sensible heat (Q_sens)
      REAL(wp), DIMENSION(:,:), INTENT(  out) ::   CeN10       ! transfert coefficient for evaporation   (Q_lat)
      REAL(wp), DIMENSION(:,:), INTENT(  out) ::   pz0          ! roughness length [m]

      INTEGER :: Ni, Nj, jit

      REAL(wp), DIMENSION(:,:), ALLOCATABLE  :: u_star, z0t, z0q, Ub, ztmp0, ztmp1
      !!===================================================================================

      Ni = SIZE(U_N10,1)
      Nj = SIZE(U_N10,2)

      ALLOCATE ( u_star(Ni,Nj),   z0t(Ni,Nj), z0q(Ni,Nj), Ub(Ni,Nj),  &
         &        ztmp0(Ni,Nj), ztmp1(Ni,Nj) )

      Ub = MAX(U_N10, 0.1_wp)

      IF ( (TRIM(calgo) == 'coare3p0').OR.(TRIM(calgo) == 'coare3p6').OR.(TRIM(calgo) == 'ecmwf') ) THEN

         !! First guess of CdN10
         CdN10 = 8.575E-5*Ub + 0.657E-3  ! from my curves

         !! ITERATION BLOCK
         DO jit = 1, nb_iter

            !! Need to know u*
            !! --------------
            u_star = Ub*SQRT(CdN10)


            !! Charnock Parameter
            !! ------------------
            IF (     TRIM(calgo) == 'coare3p6' ) THEN
               ztmp0 = charn_coare3p6(Ub)

            ELSEIF ( TRIM(calgo) == 'coare3p0' ) THEN
               ztmp0 = charn_coare3p0(Ub)

            ELSEIF ( TRIM(calgo) == 'ecmwf' ) THEN
               ztmp0 = charn0_ecmwf

            ELSE
               PRINT *, TRIM(calgo)//' => Unknow algo !' ; STOP
            END IF

            !! Roughness lengthes z0, momentum: z0t (z0q = z0t) :
            pz0   = ztmp0*u_star*u_star/grav + 0.11*rnu0_air/u_star ! Roughness length (eq.6)


            !! Compute drag coefficient at 10m
            !! -------------------------------

            ztmp0 = LOG(zu/pz0)

            CdN10 = vkarmn2 / ( ztmp0*ztmp0 )

            !IF ( (Ni==1).AND.(Nj==1) ) PRINT *, '   *** CdN10 =', CdN10*1000.
            IF ( (Ni==1).AND.(Nj==1) ) PRINT *, ''

         END DO


         IF ( TRIM(calgo) == 'coare3p0' ) THEN

            ! Re_r: roughness Reynolds number:
            ztmp1 = pz0*u_star/rnu0_air

            !! Scalar roughness length z0t:
            z0t = MIN( 1.1E-4_wp , 5.5E-5_wp*ztmp1**(-0.6_wp) )     ! Scalar roughness for Theta and q (Fairall al 2003, eq.28)
            z0q = z0t

         END IF

         IF ( TRIM(calgo) == 'coare3p6' ) THEN

            ! Re_r: roughness Reynolds number:
            ztmp1 = pz0*u_star/rnu0_air

            !! Scalar roughness length z0t:
            !! Chris Fairall, Jim Edscon, private communication, March 2016 / COARE 3.5 :
            z0t   = MIN( 1.6e-4_wp , 5.8E-5_wp*ztmp1**(-0.72_wp) ) ! These thermal roughness lengths give Stanton and
            !!                                            ! Dalton numbers that closely approximate COARE3.0
            z0q = z0t

         END IF


         IF ( TRIM(calgo) == 'ecmwf' ) THEN
            ztmp1  = rnu0_air/u_star
            z0t    = 0.40*ztmp1                              ! eq.3.26, Chap.3, p.34, IFS doc - Cy31r1
            z0q    = 0.62*ztmp1
         END IF




         PRINT *, ' *** Algo = ',trim(calgo)

         ztmp1 = LOG(zu/z0t)
         ChN10 = vkarmn2 / ( ztmp0*ztmp1 )     ! (ztmp0 = LOG(zu/z0))

         ztmp1 = LOG(zu/z0q)
         CeN10 = vkarmn2 / ( ztmp0*ztmp1 )     ! (ztmp0 = LOG(zu/z0))



      ELSEIF ( TRIM(calgo) == 'ncar' ) THEN

         PRINT *, ' *** Algo = ',TRIM(calgo)

         Ub = MAX(U_N10, 0.5_wp)

         CdN10  = CD_N10_NCAR( Ub )

         ztmp0 = SQRT(CdN10)

         ChN10 = CH_N10_NCAR( ztmp0 , Ub*0. ) ! 0 => UNSTABLE CASE !!!      L&Y 2004 eq. (6c-6d)
         CeN10 = CE_N10_NCAR( ztmp0 )

         pz0    = MAX( z0_from_Cd( 10._wp , CdN10 ) , 0.0001_wp )
         pz0    = MIN( pz0, 0.1_wp )


      ELSEIF ( TRIM(calgo) == 'andreas' ) THEN

         PRINT *, ' *** Algo = ',TRIM(calgo)

         Ub = MAX(U_N10, 0.5_wp)
         ztmp0 = u_star_andreas( Ub ) ; ! => u*

         PRINT *, ' ===> YET TO BE CODED!!!!'
         STOP

      ELSE

         PRINT *, 'ERROR: algorithm '//TRIM(calgo)//' is not supported yet!'
         PRINT *, ''
         STOP

      END IF

      DEALLOCATE ( u_star, z0t, z0q, Ub, ztmp0, ztmp1 )

   END SUBROUTINE turb_neutral_10m

END MODULE mod_blk_neutral_10m

! AeroBulk / 2015 / L. Brodeau

MODULE mod_aerobulk_compute

   USE mod_const        !: physical constants
   USE mod_phymbl       !: thermodynamics functions

   USE mod_blk_coare3p0 !: COARE v3.0 algorithm
   USE mod_blk_coare3p6 !: COARE v3.6 algorithm
   USE mod_blk_ncar     !: Large & Yeager algorithm
   USE mod_blk_ecmwf    !: following ECMWF doc...
   USE mod_blk_andreas  !: Andreas et al.

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: aerobulk_compute

CONTAINS
   
   SUBROUTINE aerobulk_compute( jt, calgo, zt, zu, sst, t_zt, &
      &                         hum_zt, U_zu, V_zu, slp,  &
      &                         QL, QH, Tau_x, Tau_y,     &
      &                         rad_sw, rad_lw, T_s, Evp )
      !!======================================================================================
      !!
      !! INPUT :
      !! -------
      !!    *    jt   : current time record (<=nitend)
      !!    *  calgo  : what bulk algorithm to use => 'coare3p6'/'ncar'/'ecmwf'
      !!    *  zt     : height for temperature and spec. hum. of air           [m]
      !!    *  zu     : height for wind (10m = traditional anemometric height  [m]
      !!    *  sst    : bulk SST                                               [K]
      !!    *  t_zt   : ABSOLUTE air temperature at zt                         [K]
      !!    *  hum_zt : air humidity at zt, can be given as:
      !!                - specific humidity                                [kg/kg]
      !!                - dew-point temperature                                [K]
      !!                - relative humidity                                    [%]
      !!               => type should normally be recognized based on value range
      !!    *  U_zu   : zonal wind speed at zu                                 [m/s]
      !!    *  V_zu   : meridional wind speed at zu                            [m/s]
      !!    *  slp    : mean sea-level pressure                                [Pa] ~101000 Pa
      !!
      !! OPTIONAL INPUT
      !! --------------  (these 2 are only needed when using CSWL schemes...)
      !!    *  rad_sw : downwelling shortwave radiation at the surface (>0)   [W/m^2]
      !!    *  rad_lw : downwelling longwave radiation at the surface  (>0)   [W/m^2]
      !!
      !! OUTPUT :
      !! --------
      !!    *  QL     : Latent heat flux                                     [W/m^2]
      !!    *  QH     : Sensible heat flux                                   [W/m^2]
      !!    *  Tau_x  : zonal wind stress                                    [N/m^2]
      !!    *  Tau_y  : zonal wind stress                                    [N/m^2]
      !!
      !! OPTIONAL OUTPUT
      !! ---------------
      !!    *  T_s  : skin temperature    [K]    (only when l_use_skin_schemes=TRUE)
      !!    *  Evp : evaporation         [mm/s] aka [kg/m^2/s] (usually <0, as ocean loses water!)
      !!
      !!
      !!============================================================================
      !!
      !! I/O ARGUMENTS:
      INTEGER,                    INTENT(in)  :: jt
      CHARACTER(len=*),           INTENT(in)  :: calgo
      REAL(wp),                   INTENT(in)  :: zt, zu
      REAL(wp),   DIMENSION(:,:), INTENT(in)  :: sst, t_zt, hum_zt, U_zu, V_zu, slp
      REAL(wp),   DIMENSION(:,:), INTENT(out) :: QL, QH, Tau_x, Tau_y
      REAL(wp),   DIMENSION(:,:), INTENT(in), OPTIONAL :: rad_sw, rad_lw
      REAL(wp),   DIMENSION(:,:), INTENT(out),OPTIONAL :: T_s, Evp
      !!
      REAL(wp),   DIMENSION(:,:), ALLOCATABLE  ::  &
         &     zWzu,            & !: Scalar wind speed at zu m
         &   zSSQ,              & !: Specific humidiyt at the air-sea interface
         &   zCd, zCh, zCe,     & !: bulk transfer coefficients
         &  zThtzt, zQzt,       & !: POTENTIAL air temperature and specific humidity at zt meters
         &  zThtzu, zQzu,       & !: POTENTIAL air temperature and specific humidity at zu meters
         &  zTs, zqs, zEvap,    & !:
         &  zTaum,              & !: wind stress module
         &  zUblk,              & !: Bulk scalar wind speed (zWzu corrected for low wind and unstable conditions)
         &  ztmp                  !: temporary array
      !
      INTEGER          :: Ni, Nj
      !!------------------------------------------------------------------------------

      Ni = SIZE(sst,1)
      Nj = SIZE(sst,2)

      ALLOCATE ( zWzu(Ni,Nj),   zSSQ(Ni,Nj),                &
         &        zCd(Ni,Nj),    zCh(Ni,Nj),   zCe(Ni,Nj),  &
         &       zThtzt(Ni,Nj), zQzt(Ni,Nj),                &
         &       zThtzu(Ni,Nj), zQzu(Ni,Nj),                &
         &       zUblk(Ni,Nj),  zTs(Ni,Nj),    zqs(Ni,Nj),  &
         &       zEvap(Ni,Nj),  zTaum(Ni,Nj),  ztmp(Ni,Nj)  )
      
      ! Conversion to specific humidity when needed:
      SELECT CASE(ctype_humidity)
      CASE('sh')
         zQzt(:,:) =           hum_zt(:,:)                        ! already specific humidity!
      CASE('dp')
         zQzt(:,:) = q_air_dp( hum_zt(:,:),            MAX(slp(:,:),50000._wp) ) ! dew-point to specific humidity
      CASE('rh')
         zQzt(:,:) = q_air_rh( hum_zt(:,:), t_zt(:,:), MAX(slp(:,:),50000._wp) ) ! relative to specific humidity
      CASE DEFAULT
         WRITE(6,*) 'ERROR: mod_aerobulk_compute.f90 => humidty type "',ctype_humidity,'" is unknown!!!' ; STOP
      END SELECT
      
      !! Scalar wind:
      zWzu = sqrt( U_zu*U_zu + V_zu*V_zu )

      !! Computing specific humidity at saturation at sea surface temperature :
      zSSQ (:,:) = rdct_qsat_salt*q_sat(sst, slp)

      !! Approximate potential temperarure at zt meters above sea surface:
      !zThtzt = t_zt + gamma_moist(t_zt, zQzt)*zt  !BAD! and should have used `gamma_dry` anyway...
      zThtzt = Theta_from_z_P0_T_q( zt, slp, t_zt, zQzt )

      !! Mind that TURB_COARE* and TURB_ECMWF will modify SST and SSQ if their
      !! respective Cool Skin Warm Layer parameterization is used
      zTs = sst
      zqs = zSSQ


      ztmp(:,:) = 0._wp   ! longitude fixed to 0, (for COAREx when using cool-skin/warm-layer)


      SELECT CASE(TRIM(calgo))
         !!
      CASE('coare3p0')
         IF( l_use_skin_schemes ) THEN
            CALL TURB_COARE3P0 ( jt, zt, zu, zTs, zThtzt, zqs, zQzt, zWzu, .TRUE., .TRUE., &
               &                zCd, zCh, zCe, zThtzu, zQzu, zUblk,            &
               &                Qsw=(1._wp - roce_alb0)*rad_sw, rad_lw=rad_lw, slp=slp, isecday_utc=12, plong=ztmp  )
         ELSE
            CALL TURB_COARE3P0 ( jt, zt, zu, zTs, zThtzt, zqs, zQzt, zWzu, .FALSE., .FALSE.,  &
               &                zCd, zCh, zCe, zThtzu, zQzu, zUblk )
         END IF
         !!
      CASE('coare3p6')
         IF( l_use_skin_schemes ) THEN
            CALL TURB_COARE3P6 ( jt, zt, zu, zTs, zThtzt, zqs, zQzt, zWzu, .TRUE., .TRUE., &
               &                zCd, zCh, zCe, zThtzu, zQzu, zUblk,            &
               &                Qsw=(1._wp - roce_alb0)*rad_sw, rad_lw=rad_lw, slp=slp, isecday_utc=12, plong=ztmp  )
         ELSE
            CALL TURB_COARE3P6 ( jt, zt, zu, zTs, zThtzt, zqs, zQzt, zWzu, .FALSE., .FALSE.,  &
               &                 zCd, zCh, zCe, zThtzu, zQzu, zUblk )
         END IF
         !!
      CASE('ncar')
         CALL TURB_NCAR( zt, zu, zTs, zThtzt, zqs, zQzt, zWzu, &
            &            zCd, zCh, zCe, zThtzu, zQzu, zUblk)
         !!
         !!
      CASE('ecmwf')
         IF( l_use_skin_schemes ) THEN
            CALL TURB_ECMWF ( jt, zt, zu, zTs, zThtzt, zqs, zQzt, zWzu, .TRUE., .TRUE.,  &
               &              zCd, zCh, zCe, zThtzu, zQzu, zUblk,      &
               &              Qsw=(1._wp - roce_alb0)*rad_sw, rad_lw=rad_lw, slp=slp  )
         ELSE
            CALL TURB_ECMWF ( jt, zt, zu, zTs, zThtzt, zqs, zQzt, zWzu, .FALSE., .FALSE.,  &
               &              zCd, zCh, zCe, zThtzu, zQzu, zUblk)
         END IF
         !!
         !!
      CASE('andreas')
         CALL TURB_ANDREAS( zt, zu, zTs, zThtzt, zqs, zQzt, zWzu, &
            &               zCd, zCh, zCe, zThtzu, zQzu, zUblk)
         !!
         !!
      CASE DEFAULT
         WRITE(6,*) 'ERROR: mod_aerobulk_compute.f90 => bulk algorithm ', trim(calgo), ' is unknown!!!'
         STOP
      END SELECT




      !! Skin temperature:
      !! IF( l_use_skin_schemes ) => zTs and zqs have been updated from SST to skin temperature !
      
      CALL BULK_FORMULA( zu, zTs, zqs, zThtzu, zQzu, zCd, zCh, zCe, zWzu, zUblk, slp, &
         &                                 zTaum, QH, QL, pEvap=zEvap )

      !! Wind stress vector from wind stress module
      !!    (zTaum = rho * Cd * zUblk * zWzu)
      Tau_x(:,:) = 0._wp
      Tau_y(:,:) = 0._wp
      WHERE( zWzu > 1.E-3 )
         Tau_x = zTaum / zWzu * U_zu
         Tau_y = zTaum / zWzu * V_zu
      END WHERE

      !PRINT *, 'LOLO DEBUG INTO mod_aerobulk_compute !!! ', TRIM(calgo)
      !PRINT *, 'zCe =', zCe
      !PRINT *, 'Qlat =', QL
      !PRINT *, 'Ublk =', zUblk
      !PRINT *, 'zCe/Ublk =', zCe/zUblk
      !PRINT *, 't_zu =', zThtzu
      !PRINT *, 'q_zu =', zQzu
      !PRINT *, 'ssq =', zSSQ
      !PRINT *, ''

      IF( PRESENT(T_s) ) T_s(:,:)   = zTs(:,:)

      IF( PRESENT(Evp) ) Evp(:,:) = zEvap(:,:)

      DEALLOCATE ( zWzu, zSSQ, zCd, zCh, zCe, zThtzt, zQzt, zThtzu, zQzu, &
         &         zUblk, zTs, zqs, zEvap, zTaum, ztmp  )
      
   END SUBROUTINE aerobulk_compute

END MODULE mod_aerobulk_compute

! AeroBulk / 2019 / L. Brodeau
!
!   When using AeroBulk to produce scientific work, please acknowledge with the following citation:
!
!   Brodeau, L., B. Barnier, S. Gulev, and C. Woods, 2016: Climatologically
!   significant effects of some approximations in the bulk parameterizations of
!   turbulent air-sea fluxes. J. Phys. Oceanogr., doi:10.1175/JPO-D-16-0169.1.
!
!
MODULE mod_blk_ecmwf
   !!====================================================================================
   !!       Computes turbulent components of surface fluxes
   !!         according to IFS of the ECMWF
   !!
   !!       With Cool-Skin and Warm-Layer correction of SST (if needed)
   !!
   !!   * bulk transfer coefficients C_D, C_E and C_H
   !!   * air temp. and spec. hum. adjusted from zt (usually 2m) to zu (usually 10m) if needed
   !!   * the "effective" bulk wind speed at zu: Ubzu
   !!   => all these are used in bulk formulas in sbcblk.F90
   !!
   !!    Using the bulk formulation/param. of ECMWF
   !!      + consideration of cool-skin warm layer parametrization (CS: Fairall et al. 1996; WL: Zeng & Beljaars, 2005 )
   !!
   !!       Routine turb_ecmwf maintained and developed in AeroBulk
   !!                     (https://github.com/brodeau/aerobulk/)
   !!
   !!            Author: Laurent Brodeau, July 2019
   !!
   !!====================================================================================
   USE mod_const       !: physical and othe constants
   USE mod_phymbl      !: thermodynamics
   USE mod_skin_ecmwf  !: cool-skin & warm-layer parameterizations of
   !                   !: Zeng and Beljaars, 1995 WITH update from Takaya et al. 2010...
   USE mod_common_coare, ONLY : FIRST_GUESS_COARE

   IMPLICIT NONE

   INTERFACE psi_m_ecmwf
      MODULE PROCEDURE psi_m_ecmwf_vctr, psi_m_ecmwf_sclr
   END INTERFACE psi_m_ecmwf

   INTERFACE psi_h_ecmwf
      MODULE PROCEDURE psi_h_ecmwf_vctr, psi_h_ecmwf_sclr
   END INTERFACE psi_h_ecmwf

   PRIVATE

   PUBLIC :: ECMWF_INIT, TURB_ECMWF, psi_m_ecmwf, psi_h_ecmwf

   !! ECMWF own values for given constants, taken form IFS documentation...
   REAL(wp), PARAMETER, PUBLIC :: charn0_ecmwf = 0.018_wp    ! Charnock constant (pretty high value here !!!
   !                                          !    =>  Usually 0.011 for moderate winds)
   REAL(wp), PARAMETER ::   zi0     = 1000.   ! scale height of the atmospheric boundary layer...1
   REAL(wp), PARAMETER ::   Beta0    = 1.     ! gustiness parameter ( = 1.25 in COAREv3)
   REAL(wp), PARAMETER ::   alpha_M = 0.11    ! For roughness length (smooth surface term)
   REAL(wp), PARAMETER ::   alpha_H = 0.40    ! (Chapter 3, p.34, IFS doc Cy31r1)
   REAL(wp), PARAMETER ::   alpha_Q = 0.62    !


   !!----------------------------------------------------------------------
CONTAINS


   SUBROUTINE ECMWF_INIT(nx, ny, l_use_wl)
      !!---------------------------------------------------------------------
      !!                  ***  FUNCTION ecmwf_init  ***
      !!
      !! INPUT :
      !! -------
      !!    * l_use_wl : use the warm-layer parameterization
      !!---------------------------------------------------------------------
      INTEGER, INTENT(in) :: nx, ny   ! shape of the domain
      LOGICAL, INTENT(in) :: l_use_wl ! use the warm-layer parameterization
      INTEGER :: ierr
      !!---------------------------------------------------------------------
      IF( l_use_wl ) THEN
         ierr = 0
         ALLOCATE ( dT_wl(nx,ny), Hz_wl(nx,ny), STAT=ierr )
         IF( ierr > 0 ) CALL ctl_stop( ' ECMWF_INIT => allocation of dT_wl & Hz_wl failed!' )
         dT_wl(:,:)  = 0._wp
         Hz_wl(:,:)  = rd0 ! (rd0, constant, = 3m is default for Zeng & Beljaars)
      ENDIF
      !IF( l_use_cs ) THEN
      !   ierr = 0
      !   ALLOCATE ( dT_cs(nx,ny), STAT=ierr )
      !   IF( ierr > 0 ) CALL ctl_stop( ' ECMWF_INIT => allocation of dT_cs failed!' )
      !   dT_cs(:,:) = -0.25_wp  ! First guess of skin correction
      !ENDIF
   END SUBROUTINE ECMWF_INIT

   SUBROUTINE ECMWF_EXIT(l_use_wl)
      !!---------------------------------------------------------------------
      !!                  ***  FUNCTION ecmwf_exit  ***
      !!
      !! INPUT :
      !! -------
      !!    * l_use_wl : use the warm-layer parameterization
      !!---------------------------------------------------------------------
      LOGICAL , INTENT(in) ::   l_use_wl ! use the warm-layer parameterization
      INTEGER :: ierr
      !!---------------------------------------------------------------------
      IF( l_use_wl ) THEN
         ierr = 0
         DEALLOCATE ( dT_wl, Hz_wl, STAT=ierr )
         IF( ierr > 0 ) CALL ctl_stop( ' ECMWF_EXIT => deallocation of Tau_ac, Qnt_ac, dT_wl & Hz_wl failed!' )
      ENDIF
      !IF( l_use_cs ) THEN
      !   ierr = 0
      !   DEALLOCATE ( dT_cs, STAT=ierr )
      !   IF( ierr > 0 ) CALL ctl_stop( ' ECMWF_EXIT => deallocation of dT_cs failed!' )
      !ENDIF
   END SUBROUTINE ECMWF_EXIT




   SUBROUTINE TURB_ECMWF( kt, zt, zu, T_s, t_zt, q_s, q_zt, U_zu, l_use_cs, l_use_wl, &
      &                      Cd, Ch, Ce, t_zu, q_zu, Ubzu,                               &
      &                      Qsw, rad_lw, slp, pdT_cs,                                   & ! optionals for cool-skin (and warm-layer)
      &                      pdT_wl, pHz_wl,                                             & ! optionals for warm-layer only
      &                      CdN, ChN, CeN, xz0, xu_star, xL, xUN10 )
      !!----------------------------------------------------------------------
      !!                      ***  ROUTINE  turb_ecmwf  ***
      !!
      !! ** Purpose :   Computes turbulent transfert coefficients of surface
      !!                fluxes according to IFS doc. (cycle 45r1)
      !!                If relevant (zt /= zu), adjust temperature and humidity from height zt to zu
      !!                Returns the effective bulk wind speed at zu to be used in the bulk formulas
      !!
      !!                Applies the cool-skin warm-layer correction of the SST to T_s
      !!                if the net shortwave flux at the surface (Qsw), the downwelling longwave
      !!                radiative fluxes at the surface (rad_lw), and the sea-leve pressure (slp)
      !!                are provided as (optional) arguments!
      !!
      !! INPUT :
      !! -------
      !!    *  kt   : current time step (starts at 1)
      !!    *  zt   : height for temperature and spec. hum. of air            [m]
      !!    *  zu   : height for wind speed (usually 10m)                     [m]
      !!    *  t_zt : potential air temperature at zt                         [K]
      !!    *  q_zt : specific humidity of air at zt                          [kg/kg]
      !!    *  U_zu : scalar wind speed at zu                                 [m/s]
      !!    * l_use_cs : use the cool-skin parameterization
      !!    * l_use_wl : use the warm-layer parameterization
      !!
      !! INPUT/OUTPUT:
      !! -------------
      !!    *  T_s  : always "bulk SST" as input                              [K]
      !!              -> unchanged "bulk SST" as output if CSWL not used      [K]
      !!              -> skin temperature as output if CSWL used              [K]
      !!
      !!    *  q_s  : SSQ aka saturation specific humidity at temp. T_s       [kg/kg]
      !!              -> doesn't need to be given a value if skin temp computed (in case l_use_cs=True or l_use_wl=True)
      !!              -> MUST be given the correct value if not computing skint temp. (in case l_use_cs=False or l_use_wl=False)
      !!
      !! OPTIONAL INPUT:
      !! ---------------
      !!    *  Qsw    : net solar flux (after albedo) at the surface (>0)     [W/m^2]
      !!    *  rad_lw : downwelling longwave radiation at the surface  (>0)   [W/m^2]
      !!    *  slp    : sea-level pressure                                    [Pa]
      !!
      !! OPTIONAL OUTPUT:
      !! ----------------
      !!    * pdT_cs  : SST increment "dT" for cool-skin correction           [K]
      !!    * pdT_wl  : SST increment "dT" for warm-layer correction          [K]
      !!    * pHz_wl  : thickness of warm-layer                               [m]
      !!
      !! OUTPUT :
      !! --------
      !!    *  Cd     : drag coefficient
      !!    *  Ch     : sensible heat coefficient
      !!    *  Ce     : evaporation coefficient
      !!    *  t_zu   : pot. air temperature adjusted at wind height zu       [K]
      !!    *  q_zu   : specific humidity of air        //                    [kg/kg]
      !!    *  Ubzu  : bulk wind speed at zu                                 [m/s]
      !!
      !! OPTIONAL OUTPUT:
      !! ----------------
      !!    * CdN      : neutral-stability drag coefficient
      !!    * ChN      : neutral-stability sensible heat coefficient
      !!    * CeN      : neutral-stability evaporation coefficient
      !!    * xz0      : return the aerodynamic roughness length (integration constant for wind stress) [m]
      !!    * xu_star  : return u* the friction velocity                    [m/s]
      !!    * xL       : return the Obukhov length                          [m]
      !!    * xUN10    : neutral wind speed at 10m                          [m/s]
      !!
      !! ** Author: L. Brodeau, June 2019 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      INTEGER,  INTENT(in   )                 ::   kt       ! current time step
      REAL(wp), INTENT(in   )                 ::   zt       ! height for t_zt and q_zt                    [m]
      REAL(wp), INTENT(in   )                 ::   zu       ! height for U_zu                             [m]
      REAL(wp), INTENT(inout), DIMENSION(:,:) ::   T_s      ! sea surface temperature                [Kelvin]
      REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   t_zt     ! potential air temperature              [Kelvin]
      REAL(wp), INTENT(inout), DIMENSION(:,:) ::   q_s      ! sea surface specific humidity           [kg/kg]
      REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   q_zt     ! specific air humidity at zt             [kg/kg]
      REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   U_zu     ! relative wind module at zu                [m/s]
      LOGICAL , INTENT(in   )                 ::   l_use_cs ! use the cool-skin parameterization
      LOGICAL , INTENT(in   )                 ::   l_use_wl ! use the warm-layer parameterization
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   Cd       ! transfer coefficient for momentum         (tau)
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   Ch       ! transfer coefficient for sensible heat (Q_sens)
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   Ce       ! transfert coefficient for evaporation   (Q_lat)
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   t_zu     ! pot. air temp. adjusted at zu               [K]
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   q_zu     ! spec. humidity adjusted at zu           [kg/kg]
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   Ubzu    ! bulk wind speed at zu                     [m/s]
      !
      REAL(wp), INTENT(in   ), OPTIONAL, DIMENSION(:,:) ::   Qsw      !             [W/m^2]
      REAL(wp), INTENT(in   ), OPTIONAL, DIMENSION(:,:) ::   rad_lw   !             [W/m^2]
      REAL(wp), INTENT(in   ), OPTIONAL, DIMENSION(:,:) ::   slp      !             [Pa]
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   pdT_cs
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   pdT_wl   !             [K]
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   pHz_wl   !             [m]
      !
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   CdN
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   ChN
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   CeN
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   xz0  ! Aerodynamic roughness length   [m]
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   xu_star  ! u*, friction velocity
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   xL  ! zeta (zu/L)
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   xUN10  ! Neutral wind at zu
      !
      INTEGER :: Ni, Nj, ji, jj, jit
      LOGICAL :: l_zt_equal_zu = .FALSE.      ! if q and t are given at same height as U
      !
      REAL(wp), DIMENSION(:,:), ALLOCATABLE :: xSST     ! to back up the initial bulk SST
      !
      REAL(wp) :: zdt, zdq, zus, zus2, zUzu, zts, zqs, zNu_a, z1oL, zdT_cs
      REAL(wp) :: zRib, zpsi_m_u, zpsi_h_u, zpsi_h_t
      REAL(wp) :: zz0, zz0t, zz0q, zpsi_h_z0t, zpsi_h_z0q, zpsi_m_z0, zzeta_u, zzeta_t
      REAL(wp) :: zlog_10, zlog_ztu, zlog_z0, zlog_zu, zlog_z0t, zlog_z0q
      REAL(wp) :: zFm, zFh, zFq, zQns
      REAL(wp) :: ztmp0, ztmp1
      !
      LOGICAL ::  lreturn_cdn=.FALSE., lreturn_chn=.FALSE., lreturn_cen=.FALSE., &
         &        lreturn_z0=.FALSE., lreturn_ustar=.FALSE., lreturn_L=.FALSE., lreturn_UN10=.FALSE.
      CHARACTER(len=40), PARAMETER :: crtnm = 'turb_ecmwf@mod_blk_ecmwf.f90'
      !!----------------------------------------------------------------------------------
      Ni = SIZE(T_s,1)
      Nj = SIZE(T_s,2)

      IF( kt == nit000 ) CALL ECMWF_INIT( Ni, Nj,  l_use_wl )

      lreturn_cdn   =  PRESENT(CdN)
      lreturn_chn   =  PRESENT(ChN)
      lreturn_cen   =  PRESENT(CeN)
      lreturn_z0    =  PRESENT(xz0)
      lreturn_ustar =  PRESENT(xu_star)
      lreturn_L     =  PRESENT(xL)
      lreturn_UN10  =  PRESENT(xUN10)

      l_zt_equal_zu = ( ABS(zu - zt) < 0.01_wp )

      !! Initializations for cool skin and warm layer:
      IF( l_use_cs .AND. (.NOT.(PRESENT(Qsw) .AND. PRESENT(rad_lw) .AND. PRESENT(slp))) ) &
         &   CALL ctl_stop( '['//TRIM(crtnm)//'] => ' , 'you need to provide Qsw, rad_lw & slp to use cool-skin param!' )

      IF( l_use_wl .AND. (.NOT.(PRESENT(Qsw) .AND. PRESENT(rad_lw) .AND. PRESENT(slp))) ) &
         &   CALL ctl_stop( '['//TRIM(crtnm)//'] => ' , 'you need to provide Qsw, rad_lw & slp to use warm-layer param!' )

      IF( l_use_cs .OR. l_use_wl ) THEN
         ALLOCATE ( xSST(Ni,Nj) )
         xSST = T_s ! backing up the bulk SST
         IF( l_use_cs ) T_s = T_s - 0.25_wp   ! First guess of correction
         q_s    = rdct_qsat_salt*q_sat(MAX(T_s, 200._wp), slp) ! First guess of q_s
      ENDIF

      !! Constants:
      zlog_10  = LOG(10._wp)
      zlog_zu  = LOG(zu)
      zlog_ztu = LOG(zt/zu)

      DO jj = 1, Nj
         DO ji = 1, Ni

            zUzu = U_zu(ji,jj)

            CALL FIRST_GUESS_COARE( zt, zu, T_s(ji,jj), t_zt(ji,jj), q_s(ji,jj), q_zt(ji,jj), zUzu, &
               &                    charn0_ecmwf,  zus, zts, zqs, &
               &                    t_zu(ji,jj), q_zu(ji,jj), Ubzu(ji,jj),  pz0=zz0 )

            zlog_z0 = LOG(zz0)
            znu_a   = visc_air(t_zt(ji,jj)) ! Air viscosity (m^2/s) at zt given from temperature in (K)

            !! Pot. temp. difference (and we don't want it to be 0!)
            zdt = t_zu(ji,jj) - T_s(ji,jj) ;   zdt = SIGN( MAX(ABS(zdt),1.E-6_wp), zdt )
            zdq = q_zu(ji,jj) - q_s(ji,jj) ;   zdq = SIGN( MAX(ABS(zdq),1.E-9_wp), zdq )

            !! First guess of inverse of Obukov length (1/L) :
            z1oL    = One_on_L( t_zu(ji,jj), q_zu(ji,jj), zus, zts, zqs )
            zzeta_u = zu*z1oL
            zzeta_t = zt*z1oL

            zz0t    = MIN( MAX(ABS(  1._wp / ( 0.1_wp*EXP(vkarmn/(0.00115/( vkarmn/(zlog_10-zlog_z0) ))) )   ), 1.E-9) , 1._wp )
            zlog_z0t = LOG(zz0t)

            !! Functions such as  u* = Ubzu*vkarmn/zFm
            zFm = zlog_zu - zlog_z0  - psi_m_ecmwf_sclr(zzeta_u) + psi_m_ecmwf_sclr( zz0*z1oL)
            zpsi_h_u = psi_h_ecmwf_sclr(zzeta_u)
            zFh = zlog_zu - zlog_z0t - zpsi_h_u + psi_h_ecmwf_sclr(zz0t*z1oL)

            !! ITERATION BLOCK
            DO jit = 1, nb_iter

               !! Bulk Richardson Number at z=zu (Eq. 3.25)
               zRib = Ri_bulk( zu, T_s(ji,jj), t_zu(ji,jj), q_s(ji,jj), q_zu(ji,jj), Ubzu(ji,jj) ) ! Bulk Richardson Number (BRN)

               !! New estimate of the inverse of the Obukhon length (z1oL == zeta/zu) :
               z1oL = zRib*zFm*zFm/zFh / zu     ! From Eq. 3.23, Chap.3.2.3, IFS doc - Cy40r1
               !! Note: it is slightly different that the L we would get with the usual
               z1oL   = SIGN( MIN(ABS(z1oL),200._wp), z1oL ) ! (prevent FPE from stupid values from masked region later on...)

               zzeta_u  = zu*z1oL
               zpsi_m_u = psi_m_ecmwf_sclr(zzeta_u)
               zpsi_h_u = psi_h_ecmwf_sclr(zzeta_u)

               zzeta_t  = zt*z1oL
               zpsi_h_t = psi_h_ecmwf_sclr(zzeta_t)

               !! Update zFm with new z1oL:
               zFm = zlog_zu -zlog_z0 - zpsi_m_u + psi_m_ecmwf_sclr(zz0*z1oL) ! LB: should be "zu+z0" rather than "zu" alone, but z0 is tiny wrt zu!

               !! Need to update roughness lengthes:
               zus = Ubzu(ji,jj)*vkarmn/zFm
               zus2  = zus*zus
               ztmp0  = znu_a/zus
               zz0     = MIN( ABS( alpha_M*ztmp0 + charn0_ecmwf*zus2/grav ) , 0.001_wp)
               zz0t    = MIN( ABS( alpha_H*ztmp0                           ) , 0.001_wp)   ! eq.3.26, Chap.3, p.34, IFS doc - Cy31r1
               zz0q    = MIN( ABS( alpha_Q*ztmp0                           ) , 0.001_wp)

               zlog_z0  = LOG(zz0 )
               zlog_z0t = LOG(zz0t)
               zlog_z0q = LOG(zz0q)

               zpsi_m_z0   = psi_m_ecmwf_sclr(zz0 *z1oL)  ! LB: should be "zu+z0" rather than "zu" alone, but z0 is tiny wrt zu!
               zpsi_h_z0t  = psi_h_ecmwf_sclr(zz0t*z1oL)  !              "                           "
               zpsi_h_z0q  = psi_h_ecmwf_sclr(zz0q*z1oL)  !              "                           "


               !! Update wind at zu with convection-related wind gustiness in unstable conditions (Chap. 3.2, IFS doc - Cy40r1, Eq.3.17 and Eq.3.18 + Eq.3.8)
               ztmp0 = Beta0*Beta0*zus2*(MAX(-zi0*z1oL/vkarmn,0._wp))**(2._wp/3._wp) ! square of wind gustiness contribution  (combining Eq. 3.8 and 3.18, hap.3, IFS doc - Cy31r1)
               !!   ! Only true when unstable (L<0) => when zRib < 0 => explains "-" before zi0
               Ubzu(ji,jj) = MAX(SQRT(U_zu(ji,jj)*U_zu(ji,jj) + ztmp0), 0.2_wp)        ! include gustiness in bulk wind speed
               ! => 0.2 prevents Ubzu to be 0 in stable case when U_zu=0.


               !! Need to update "theta" and "q" at zu in case they are given at different heights
               !! as well the air-sea differences:
               IF( .NOT. l_zt_equal_zu ) THEN
                  ztmp0  = zpsi_h_u - zpsi_h_z0t
                  ztmp1  = vkarmn/(zlog_zu - zlog_z0t - ztmp0)
                  zts = zdt*ztmp1
                  ztmp1  = zlog_ztu + ztmp0 - zpsi_h_t + zpsi_h_z0t
                  t_zu(ji,jj)   = t_zt(ji,jj) - zts/vkarmn*ztmp1

                  zpsi_h_z0q  = zpsi_h_z0q
                  ztmp0  = zpsi_h_u - zpsi_h_z0q
                  ztmp1  = vkarmn/(zlog_zu - zlog_z0q - ztmp0)
                  zqs = zdq*ztmp1
                  ztmp1  = zlog_ztu + ztmp0 - zpsi_h_t + zpsi_h_z0q
                  q_zu(ji,jj)   = q_zt(ji,jj) - zqs/vkarmn*ztmp1
               ENDIF

               !! Updating because of updated z0 and z0t and new z1oL...
               zFm = zlog_zu - zlog_z0  - zpsi_m_u + zpsi_m_z0
               zFh = zlog_zu - zlog_z0t - zpsi_h_u + zpsi_h_z0t

               IF( l_use_cs ) THEN
                  !! Cool-skin contribution
                  CALL UPDATE_QNSOL_TAU( zu, T_s(ji,jj), q_s(ji,jj), t_zu(ji,jj), q_zu(ji,jj), zus, zts, zqs, &
                     &                   U_zu(ji,jj), Ubzu(ji,jj), slp(ji,jj), rad_lw(ji,jj), zQns, ztmp0 )  ! Tau -> ztmp0

                  CALL CS_ECMWF( Qsw(ji,jj), zQns, zus, xSST(ji,jj), zdT_cs )
                  IF( PRESENT(pdT_cs) ) pdT_cs(ji,jj) = zdT_cs
                  T_s(ji,jj) = xSST(ji,jj) + zdT_cs
                  IF( l_use_wl ) T_s(ji,jj) = T_s(ji,jj) + dT_wl(ji,jj)
                  q_s(ji,jj) = rdct_qsat_salt*q_sat(MAX(T_s(ji,jj), 200._wp), slp(ji,jj))
               ENDIF

               IF( l_use_wl ) THEN
                  !! Warm-layer contribution
                  CALL UPDATE_QNSOL_TAU( zu, T_s(ji,jj), q_s(ji,jj), t_zu(ji,jj), q_zu(ji,jj), zus, zts, zqs, U_zu(ji,jj), Ubzu(ji,jj), &
                     &                   slp(ji,jj), rad_lw(ji,jj), zQns, ztmp0)  ! Tau -> ztmp0
                  CALL WL_ECMWF( ji, jj, Qsw(ji,jj), zQns, zus, xSST(ji,jj) )
                  !! Updating T_s and q_s !!!
                  T_s(ji,jj) = xSST(ji,jj) + dT_wl(ji,jj)
                  IF( l_use_cs ) T_s(ji,jj) = T_s(ji,jj) + zdT_cs
                  q_s(ji,jj) = rdct_qsat_salt*q_sat(MAX(T_s(ji,jj), 200._wp), slp(ji,jj))
               ENDIF

               IF( l_use_cs .OR. l_use_wl .OR. (.NOT. l_zt_equal_zu) ) THEN
                  zdt = t_zu(ji,jj) - T_s(ji,jj) ;  zdt = SIGN( MAX(ABS(zdt),1.E-6_wp), zdt )
                  zdq = q_zu(ji,jj) - q_s(ji,jj) ;  zdq = SIGN( MAX(ABS(zdq),1.E-9_wp), zdq )
               ENDIF

            END DO !DO jit = 1, nb_iter

            ! compute transfer coefficients at zu :
            zFq = zlog_zu - zlog_z0q - zpsi_h_u + zpsi_h_z0q

            Cd(ji,jj) = MAX( vkarmn2/(zFm*zFm) , Cx_min )
            Ch(ji,jj) = MAX( vkarmn2/(zFm*zFh) , Cx_min )
            Ce(ji,jj) = MAX( vkarmn2/(zFm*zFq) , Cx_min )

            !! Optional output
            IF( lreturn_cdn .OR. lreturn_chn .OR. lreturn_cen ) ztmp0 = 1._wp/(zlog_zu - zlog_z0)
            IF( lreturn_cdn )   CdN(ji,jj) = MAX( vkarmn2*ztmp0*ztmp0 , Cx_min )
            IF( lreturn_chn .OR. lreturn_cen ) ztmp1 = vkarmn2*ztmp0/(zlog_zu - zlog_z0t)
            IF( lreturn_chn )   ChN(ji,jj) = MAX( ztmp1 , Cx_min )
            IF( lreturn_cen )   CeN(ji,jj) = MAX( ztmp1 , Cx_min )

            IF( lreturn_z0 )        xz0(ji,jj) = zz0
            IF( lreturn_ustar ) xu_star(ji,jj) = zus
            IF( lreturn_L )          xL(ji,jj) = 1._wp / z1oL
            IF( lreturn_UN10 )    xUN10(ji,jj) = zus/vkarmn*(zlog_10 - zlog_z0)

         END DO
      END DO

      IF( l_use_wl .AND. PRESENT(pdT_wl) ) pdT_wl = dT_wl
      IF( l_use_wl .AND. PRESENT(pHz_wl) ) pHz_wl = Hz_wl

      IF( l_use_cs .OR. l_use_wl ) DEALLOCATE ( xSST )

      IF( kt == nitend ) CALL ECMWF_EXIT( l_use_wl )

   END SUBROUTINE turb_ecmwf


   !!===============================================================================================
   FUNCTION psi_m_ecmwf_sclr( pzeta )
      !!--------------------------------------------------------------------------------------------
      !! Universal profile stability function for momentum
      !!     ECMWF / as in IFS cy31r1 documentation, available online
      !!     at ecmwf.int
      !!
      !! pzeta : stability paramenter, z/L where z is altitude measurement
      !!         and L is M-O length
      !!
      !! ** Author: L. Brodeau, June 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!--------------------------------------------------------------------------------------------
      REAL(wp), INTENT(in) :: pzeta
      REAL(wp)             :: psi_m_ecmwf_sclr
      !!
      REAL(wp) :: zta, zx2, zx, ztmp, zpsi_unst, zpsi_stab, zstab, zc
      !!--------------------------------------------------------------------------------------------
      zc = 5._wp/0.35_wp
      !
      zta = MIN( pzeta , 5._wp ) !! Very stable conditions (L positif and big!):

      ! *** Unstable (Paulson 1970)    [eq.3.20, Chap.3, p.33, IFS doc - Cy31r1] :
      zx2 = SQRT( ABS(1._wp - 16._wp*zta) )  ! (1 - 16z)^0.5
      zx  = SQRT(zx2)                        ! (1 - 16z)^0.25
      ztmp = 1._wp + zx
      zpsi_unst = LOG( 0.125_wp*ztmp*ztmp*(1._wp + zx2) ) - 2._wp*ATAN( zx ) + 0.5_wp*rpi

      ! *** Stable                   [eq.3.22, Chap.3, p.33, IFS doc - Cy31r1] :
      zpsi_stab = -2._wp/3._wp*(zta - zc)*EXP(-0.35_wp*zta) &
         &        - zta - 2._wp/3._wp*zc
      !
      zstab = 0.5_wp + SIGN(0.5_wp, zta) ! zta > 0 => zstab = 1
      !
      psi_m_ecmwf_sclr =         zstab    * zpsi_stab &  ! (zta > 0) Stable
         &              + (1._wp - zstab) * zpsi_unst    ! (zta < 0) Unstable
      !
   END FUNCTION psi_m_ecmwf_sclr

   FUNCTION psi_m_ecmwf_vctr( pzeta )
      !!--------------------------------------------------------------------------------------------
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pzeta
      REAL(wp), DIMENSION(SIZE(pzeta,1),SIZE(pzeta,2)) :: psi_m_ecmwf_vctr
      INTEGER  ::   ji, jj    ! dummy loop indices
      REAL(wp) :: zta, zx2, zx, ztmp, zpsi_unst, zpsi_stab, zstab, zc
      !!--------------------------------------------------------------------------------------------
      zc = 5._wp/0.35_wp
      !
      DO jj = 1, SIZE(pzeta,2)
         DO ji = 1, SIZE(pzeta,1)
            !
            zta = MIN( pzeta(ji,jj) , 5._wp ) !! Very stable conditions (L positif and big!):

            ! *** Unstable (Paulson 1970)    [eq.3.20, Chap.3, p.33, IFS doc - Cy31r1] :
            zx2 = SQRT( ABS(1._wp - 16._wp*zta) )  ! (1 - 16z)^0.5
            zx  = SQRT(zx2)                          ! (1 - 16z)^0.25
            ztmp = 1._wp + zx
            zpsi_unst = LOG( 0.125_wp*ztmp*ztmp*(1._wp + zx2) ) - 2._wp*ATAN( zx ) + 0.5_wp*rpi

            ! *** Stable                   [eq.3.22, Chap.3, p.33, IFS doc - Cy31r1] :
            zpsi_stab = -2._wp/3._wp*(zta - zc)*EXP(-0.35_wp*zta) &
               &       - zta - 2._wp/3._wp*zc
            !
            zstab = 0.5_wp + SIGN(0.5_wp, zta) ! zta > 0 => zstab = 1
            !
            psi_m_ecmwf_vctr(ji,jj) =         zstab  * zpsi_stab &  ! (zta > 0) Stable
               &              + (1._wp - zstab) * zpsi_unst    ! (zta < 0) Unstable
         END DO
      END DO
   END FUNCTION psi_m_ecmwf_vctr
   !!===============================================================================================


   !!===============================================================================================
   FUNCTION psi_h_ecmwf_sclr( pzeta )
      !!--------------------------------------------------------------------------------------------
      !! Universal profile stability function for temperature and humidity
      !!     ECMWF / as in IFS cy31r1 documentation, available online
      !!     at ecmwf.int
      !!
      !! pzeta : stability paramenter, z/L where z is altitude measurement
      !!         and L is M-O length
      !!
      !! ** Author: L. Brodeau, June 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!--------------------------------------------------------------------------------------------
      REAL(wp), INTENT(in) :: pzeta
      REAL(wp)             :: psi_h_ecmwf_sclr
      !!
      REAL(wp) ::  zta, zx2, zpsi_unst, zpsi_stab, zstab, zc
      !!--------------------------------------------------------------------------------------------
      zc = 5._wp/0.35_wp
      !
      zta = MIN(pzeta , 5._wp)   ! Very stable conditions (L positif and big!):
      !
      ! *** Unstable (Paulson 1970)   [eq.3.20, Chap.3, p.33, IFS doc - Cy31r1] :
      zx2 = SQRT( ABS(1._wp - 16._wp*zta) )  ! (1 -16z)^0.5
      zpsi_unst = 2._wp*LOG( 0.5_wp*(1._wp + zx2) )
      !
      ! *** Stable [eq.3.22, Chap.3, p.33, IFS doc - Cy31r1] :
      zpsi_stab = -2._wp/3._wp*(zta - zc)*EXP(-0.35_wp*zta) &
         &       - ABS(1._wp + 2._wp/3._wp*zta)**1.5_wp - 2._wp/3._wp*zc + 1._wp
      !! LB: added ABS() to avoid NaN values when unstable, which contaminates the unstable solution...
      !
      zstab = 0.5_wp + SIGN(0.5_wp, zta) ! zta > 0 => zstab = 1
      !
      psi_h_ecmwf_sclr =        zstab     * zpsi_stab   &  ! (zta > 0) Stable
         &              + (1._wp - zstab) * zpsi_unst      ! (zta < 0) Unstable
      !
   END FUNCTION psi_h_ecmwf_sclr

   FUNCTION psi_h_ecmwf_vctr( pzeta )
      !!--------------------------------------------------------------------------------------------
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pzeta
      REAL(wp), DIMENSION(SIZE(pzeta,1),SIZE(pzeta,2)) :: psi_h_ecmwf_vctr
      INTEGER  ::   ji, jj     ! dummy loop indices
      REAL(wp) ::  zta, zx2, zpsi_unst, zpsi_stab, zstab, zc
      !!--------------------------------------------------------------------------------------------
      zc = 5._wp/0.35_wp
      !
      DO jj = 1, SIZE(pzeta,2)
         DO ji = 1, SIZE(pzeta,1)
            !
            zta = MIN(pzeta(ji,jj) , 5._wp)   ! Very stable conditions (L positif and big!):
            !
            ! *** Unstable (Paulson 1970)   [eq.3.20, Chap.3, p.33, IFS doc - Cy31r1] :
            zx2 = SQRT( ABS(1._wp - 16._wp*zta) )  ! (1 -16z)^0.5
            zpsi_unst = 2._wp*LOG( 0.5_wp*(1._wp + zx2) )
            !
            ! *** Stable [eq.3.22, Chap.3, p.33, IFS doc - Cy31r1] :
            zpsi_stab = -2._wp/3._wp*(zta - zc)*EXP(-0.35_wp*zta) &
               &       - ABS(1._wp + 2._wp/3._wp*zta)**1.5_wp - 2._wp/3._wp*zc + 1._wp
            !
            ! LB: added ABS() to avoid NaN values when unstable, which contaminates the unstable solution...
            !
            zstab = 0.5_wp + SIGN(0.5_wp, zta) ! zta > 0 => zstab = 1
            !
            psi_h_ecmwf_vctr(ji,jj) =         zstab  * zpsi_stab &  ! (zta > 0) Stable
               &              + (1._wp - zstab) * zpsi_unst    ! (zta < 0) Unstable
         END DO
      END DO
   END FUNCTION psi_h_ecmwf_vctr
   !!===============================================================================================


   !!======================================================================
END MODULE mod_blk_ecmwf

! AeroBulk / 2016 / L. Brodeau
!
!   When using AeroBulk to produce scientific work, please acknowledge with the following citation:
!
!   Brodeau, L., B. Barnier, S. Gulev, and C. Woods, 2016: Climatologically
!   significant effects of some approximations in the bulk parameterizations of
!   turbulent air-sea fluxes. J. Phys. Oceanogr., doi:10.1175/JPO-D-16-0169.1.
!
!
MODULE mod_skin_ecmwf
   !!====================================================================================
   !!       Cool-Skin and warm-layer correction of SST
   !!    Cool-skin and warm-layer parametrization (Fairall et al. 1996)
   !!
   !!       Routine "cs_ecmwf" and "wl_ecmwf" maintained and developed in AeroBulk
   !!                     (https://github.com/brodeau/aerobulk/)
   !!
   !!            Author: Laurent Brodeau, 2019
   !!
   !!====================================================================================
   USE mod_const   !: physical and othe constants
   USE mod_phymbl  !: thermodynamics

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: CS_ECMWF, WL_ECMWF

   !! Warm-layer related arrays:
   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:), PUBLIC :: &
      &                        dT_wl,     &  !: dT due to warm-layer effect => difference between "almost surface (right below viscous layer, z=delta)
                                !!                                     !: and depth of bulk SST (z=gdept_1d(1))
      &                        Hz_wl         !: depth of warm-layer [m]   ! for now constant for ECMWF...

   REAL(wp), PARAMETER, PUBLIC :: rd0  = 3.    !: Depth scale [m] of warm layer, "d" in Eq.11 (Zeng & Beljaars 2005)
   REAL(wp), PARAMETER         :: zRhoCp_w = rho0_w*rCp0_w
   !
   REAL(wp), PARAMETER         :: rNuwl0 = 0.5  !: Nu (exponent of temperature profile) Eq.11
   !                                            !: (Zeng & Beljaars 2005) !: set to 0.5 instead of
   !                                            !: 0.3 to respect a warming of +3 K in calm
   !                                            !: condition for the insolation peak of +1000W/m^2
   !!----------------------------------------------------------------------

CONTAINS

   SUBROUTINE CS_ECMWF( pQsw, pQnsol, pustar, pSST, pdT_cs )
      !!---------------------------------------------------------------------
      !!
      !! Cool-skin parameterization, based on Fairall et al., 1996:
      !!
      !! Fairall, C. W., Bradley, E. F., Godfrey, J. S., Wick, G. A.,
      !! Edson, J. B., and Young, G. S. ( 1996), Cool‐skin and warm‐layer
      !! effects on sea surface temperature, J. Geophys. Res., 101( C1), 1295-1308,
      !! doi:10.1029/95JC03190.
      !!
      !!------------------------------------------------------------------
      !!
      !!  **   INPUT:
      !!     *pQsw*       surface net solar radiation into the ocean     [W/m^2] => >= 0 !
      !!     *pQnsol*     surface net non-solar heat flux into the ocean [W/m^2] => normally < 0 !
      !!     *pustar*     friction velocity u*                           [m/s]
      !!     *pSST*       bulk SST (taken at depth gdept_1d(1))          [K]
      !!------------------------------------------------------------------
      REAL(wp), INTENT(in) :: pQsw   ! net solar a.k.a shortwave radiation into the ocean (after albedo) [W/m^2]
      REAL(wp), INTENT(in) :: pQnsol ! non-solar heat flux to the ocean [W/m^2]
      REAL(wp), INTENT(in) :: pustar ! friction velocity, temperature and humidity (u*,t*,q*)
      REAL(wp), INTENT(in) :: pSST   ! bulk SST [K]
      REAL(wp), INTENT(out):: pdT_cs !: dT due to cool-skin effect => temperature difference between
      !!                             !: air-sea interface (z=0) and right below viscous layer (z=delta)
      !!---------------------------------------------------------------------
      INTEGER  :: jc
      REAL(wp) :: zQabs, zdelta, zfr
      !!---------------------------------------------------------------------
      zQabs = pQnsol ! first guess of heat flux absorbed within the viscous sublayer of thicknes delta,
      !              !   => we DO not miss a lot assuming 0 solar flux absorbed in the tiny layer of thicknes zdelta...

      zdelta = delta_skin_layer_sclr( alpha_sw(pSST), zQabs, pustar )

      DO jc = 1, 4 ! because implicit in terms of zdelta...
         ! Solar absorption, Eq.(5) Zeng & Beljaars, 2005:
         zfr = MAX( 0.065_wp + 11._wp*zdelta - 6.6E-5_wp/zdelta*(1._wp - EXP(-zdelta/8.E-4_wp)) , 0.01_wp )
         !              =>  (WARNING: 0.065 rather than 0.137 in Fairal et al. 1996)
         zQabs = pQnsol + zfr*pQsw
         zdelta = delta_skin_layer_sclr( alpha_sw(pSST), zQabs, pustar )
      END DO

      pdT_cs = zQabs*zdelta/rk0_w   ! temperature increment, yes dT_cs can actually > 0, if Qabs > 0 (rare but possible!)

   END SUBROUTINE CS_ECMWF


   SUBROUTINE WL_ECMWF( ki, kj, pQsw, pQnsol, pustar, pSST,  pustk )
      !!---------------------------------------------------------------------
      !!
      !!  Warm-Layer scheme according to Zeng & Beljaars, 2005 (GRL)
      !!  " A prognostic scheme of sea surface skin temperature for modeling and data assimilation "
      !!
      !!  STIL NO PROGNOSTIC EQUATION FOR THE DEPTH OF THE WARM-LAYER!
      !!
      !!    As included in IFS Cy45r1   /  E.C.M.W.F.
      !!     ------------------------------------------------------------------
      !!
      !!  **   INPUT:
      !!     *pQsw*       surface net solar radiation into the ocean     [W/m^2] => >= 0 !
      !!     *pQnsol*     surface net non-solar heat flux into the ocean [W/m^2] => normally < 0 !
      !!     *pustar*     friction velocity u*                           [m/s]
      !!     *pSST*       bulk SST  (taken at depth gdept_1d(1))         [K]
      !!---------------------------------------------------------------------
      INTEGER , INTENT(in) :: ki, kj
      REAL(wp), INTENT(in) :: pQsw     ! surface net solar radiation into the ocean [W/m^2]     => >= 0 !
      REAL(wp), INTENT(in) :: pQnsol   ! surface net non-solar heat flux into the ocean [W/m^2] => normally < 0 !
      REAL(wp), INTENT(in) :: pustar   ! friction velocity [m/s]
      REAL(wp), INTENT(in) :: pSST     ! bulk SST at depth gdept_1d(1) [K]
      !!
      REAL(wp), OPTIONAL, INTENT(in) :: pustk ! surface Stokes velocity [m/s]
      !
      INTEGER :: jc
      !
      REAL(wp) :: &
         & zHwl,    &  !: thickness of the warm-layer [m]
         & ztcorr,  &  !: correction of dT w.r.t measurement depth of bulk SST (first T-point)
         & zalpha, & !: thermal expansion coefficient of sea-water [1/K]
         & zdTwl_b, zdTwl_n, & ! temp. diff. between "almost surface (right below viscous layer) and bottom of WL
         & zfr, zeta, &
         & zusw, zusw2, &
         & zLa, zfLa, &
         & flg, zwf, zQabs, &
         & zA, zB, zL1, zL2, &
         &  zcst0, zcst1, zcst2, zcst3
      !!
      LOGICAL :: l_pustk_known
      !!---------------------------------------------------------------------
      l_pustk_known = ( PRESENT(pustk) )

      zHwl = Hz_wl(ki,kj) ! first guess for warm-layer depth, and final choice because `Hz_wl` fixed in present ECMWF algo (as opposed to COARE)
      !!                  ! it is constant! => rd0 == 3m ! Zeng & Beljaars....

      !! Previous value of dT / warm-layer, adapted to depth:
      flg = 0.5_wp + SIGN( 0.5_wp , gdept_1d(1)-zHwl )               ! => 1 when gdept_1d(1)>zHwl (dT_wl(ki,kj) = zdTwl) | 0 when z_s$
      ztcorr = flg + (1._wp - flg)*gdept_1d(1)/zHwl
      zdTwl_b = MAX ( dT_wl(ki,kj) / ztcorr , 0._wp )
      ! zdTwl is the difference between "almost surface (right below viscous layer) and bottom of WL (here zHwl)
      ! pdT         "                          "                                    and depth of bulk SST (here gdept_1d(1))!
      !! => but of course in general the bulk SST is taken shallower than zHwl !!! So correction less pronounced!
      !! => so here since pdT is difference between surface and gdept_1d(1), need to increase fof zdTwl !

      zalpha = alpha_sw( pSST ) ! thermal expansion coefficient of sea-water (SST accurate enough!)


      ! *** zfr = Fraction of solar radiation absorbed in warm layer (-)
      zfr = 1._wp - 0.28_wp*EXP(-71.5_wp*zHwl) - 0.27_wp*EXP(-2.8_wp*zHwl) - 0.45_wp*EXP(-0.07_wp*zHwl)  !: Eq. 8.157

      zQabs = zfr*pQsw + pQnsol       ! tot heat absorbed in warm layer

      zusw  = MAX( pustar, 1.E-4_wp ) * sq_radrw    ! u* in the water
      zusw2 = zusw*zusw

      ! Langmuir:
      IF ( l_pustk_known ) THEN
         zLa = SQRT(zusw/MAX(pustk,1.E-6))
      ELSE
         zla = 0.3_wp
      END IF
      zfLa = MAX( zla**(-2._wp/3._wp) , 1._wp )   ! Eq.(6)

      zwf = 0.5_wp + SIGN(0.5_wp, zQabs)  ! zQabs > 0. => 1.  / zQabs < 0. => 0.

      zcst1 = vkarmn*grav*zalpha

      ! 1/L when zQabs > 0 :
      zL2 = zcst1*zQabs / (zRhoCp_w*zusw2*zusw)

      zcst2 = zcst1 / ( 5._wp*zHwl*zusw2 )  !OR: zcst2 = zcst1*rNuwl0 / ( 5._wp*zHwl*zusw2 ) ???

      zcst0 = rdt * (rNuwl0 + 1._wp) / zHwl

      zA = zcst0 * zQabs / ( rNuwl0 * zRhoCp_w )

      zcst3 = -zcst0 * vkarmn * zusw * zfLa

      !! Sorry about all these constants ( constant w.r.t zdTwl), it's for
      !! the sake of optimizations... So all these operations are not done
      !! over and over within the iteration loop...

      !! T R U L L Y   I M P L I C I T => needs itteration
      !! => have to itterate just because the 1/(Obukhov length), zL1, uses zdTwl when zQabs < 0..
      !!    (without this term otherwize the implicit analytical solution is straightforward...)
      zdTwl_n = zdTwl_b
      DO jc = 1, 10
         
         zdTwl_n = 0.5_wp * ( zdTwl_n + zdTwl_b ) ! semi implicit, for faster convergence
         
         ! 1/L when zdTwl > 0 .AND. zQabs < 0 :
         zL1 =         SQRT( zdTwl_n * zcst2 ) ! / zusw !!! Or??? => vkarmn * SQRT( zdTwl_n*grav*zalpha/( 5._wp*zHwl ) ) / zusw
         !zL1 = vkarmn*SQRT( zdTwl_n       *grav*zalpha        / ( 5._wp*zHwl ) ) / zusw   ! => vkarmn outside, not inside zcst1 (just for this particular line) ???
         
         ! Stability parameter (z/L):
         zeta =  (1._wp - zwf) * zHwl*zL1   +   zwf * zHwl*zL2
         
         zB = zcst3 / PHI(zeta)

         zdTwl_n = MAX ( zdTwl_b + zA + zB*zdTwl_n , 0._wp )  ! Eq.(6)

      END DO

      !! Update:
      dT_wl(ki,kj) = zdTwl_n * ztcorr

   END SUBROUTINE WL_ECMWF


   FUNCTION PHI( pzeta)
      !!---------------------------------------------------------------------
      !!
      !! Takaya et al., 2010
      !!  Eq.(5)
      !! L. Brodeau, october 2019
      !!---------------------------------------------------------------------
      REAL(wp)                :: PHI
      REAL(wp), INTENT(in)    :: pzeta    ! stability parameter
      !!---------------------------------------------------------------------
      REAL(wp) :: ztf, zzt2
      !!---------------------------------------------------------------------
      !
      zzt2 = pzeta*pzeta
      !
      ztf = 0.5_wp + SIGN(0.5_wp, pzeta)  ! zeta > 0 => ztf = 1
      !                                   ! zeta < 0 => ztf = 0
      PHI =      ztf     * ( 1. + (5.*pzeta + 4.*zzt2)/(1. + 3.*pzeta + 0.25*zzt2) ) &   ! zeta > 0
         &  + (1. - ztf) * 1./SQRT( 1. - 16.*(-ABS(pzeta)) )                             ! zeta < 0
      !
   END FUNCTION PHI

   !!======================================================================
END MODULE mod_skin_ecmwf

!!! TO DO: consistent psi_m and psi_h needed!!! For now is those of NCAR !!!
!!
!! DAns les psi_x_ecmwf: zeta est corrigé tel qu'il ne peut pas dépasser 5 en conditions très stable!
!!
! AeroBulk / 2020 / L. Brodeau
!
!   When using AeroBulk to produce scientific work, please acknowledge with the following citation:
!
!   Brodeau, L., B. Barnier, S. Gulev, and C. Woods, 2016: Climatologically
!   significant effects of some approximations in the bulk parameterizations of
!   turbulent air-sea fluxes. J. Phys. Oceanogr., doi:10.1175/JPO-D-16-0169.1.
!
!
MODULE mod_blk_andreas
   !!====================================================================================
   !!                   ***  MODULE  mod_blk_andreas  ***
   !! Computes:
   !!   * bulk transfer coefficients C_D, C_E and C_H
   !!   * air temp. and spec. hum. adjusted from zt (2m) to zu (10m) if needed
   !!   * the effective bulk wind speed at 10m Ubzu
   !!  according to Andreas et al. (2015)
   !!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   !!       Andreas, E.L., Mahrt, L. and Vickers, D. (2015),
   !!       An improved bulk air–sea surface flux algorithm,
   !!       including spray‐mediated transfer.
   !!       Q.J.R. Meteorol. Soc., 141: 642-654. doi:10.1002/qj.2424
   !!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   !!
   !!   * bulk transfer coefficients C_D, C_E and C_H
   !!   * air temp. and spec. hum. adjusted from zt (2m) to zu (10m) if needed
   !!   * the effective bulk wind speed at z=zu: Ubzu
   !!   => all these are used in bulk formulas in sbcblk.F90
   !!
   !!    Using the bulk formulation/param. of Large & Yeager 2008
   !!
   !!       Routine turb_andreas maintained and developed in AeroBulk
   !!                     (https://github.com/brodeau/aerobulk/)
   !!
   !!            Author: Laurent Brodeau, 2020
   !!
   !!====================================================================================
   USE mod_const       !: physical and other constants
   USE mod_phymbl      !: misc. physical functions

   IMPLICIT NONE
   PRIVATE

   INTERFACE u_star_andreas
      MODULE PROCEDURE u_star_andreas_vctr, u_star_andreas_sclr
   END INTERFACE u_star_andreas

   
   !! Important (Brodeau fix):
   REAL(wp), PARAMETER :: rRi_max = 0.15_wp   ! Bulk Ri above which the algorithm fucks up!
   !                                          ! (increasing (>0) Ri means that surface layer increasingly stable and/or wind increasingly weak)
   REAL(wp), PARAMETER :: rCs_min = 0.35E-3_wp ! minimum value to tolarate for CE and CH ! Must be larger than "Cx_min" !!!

   !INTEGER, PARAMETER :: iverbose = 1
   INTEGER, PARAMETER :: iverbose = 0

   PUBLIC :: TURB_ANDREAS, u_star_andreas, psi_m_andreas, psi_h_andreas

   !!----------------------------------------------------------------------
CONTAINS

   SUBROUTINE turb_andreas( zt, zu, sst, t_zt, ssq, q_zt, U_zu, &
      &                     Cd, Ch, Ce, t_zu, q_zu, Ubzu,       &
      &                    CdN, ChN, CeN, xz0, xu_star, xL, xUN10 )
      !!----------------------------------------------------------------------
      !!                      ***  ROUTINE  turb_andreas  ***
      !!
      !! ** Purpose :   Computes turbulent transfert coefficients of surface
      !!                fluxes according to Large & Yeager (2004) and Large & Yeager (2008)
      !!                If relevant (zt /= zu), adjust temperature and humidity from height zt to zu
      !!                Returns the effective bulk wind speed at zu to be used in the bulk formulas
      !!
      !! INPUT :
      !! -------
      !!    *  zt   : height for temperature and spec. hum. of air            [m]
      !!    *  zu   : height for wind speed (usually 10m)                     [m]
      !!    *  sst  : bulk SST                                                [K]
      !!    *  t_zt : potential air temperature at zt                         [K]
      !!    *  ssq  : specific humidity at saturation at SST                  [kg/kg]
      !!    *  q_zt : specific humidity of air at zt                          [kg/kg]
      !!    *  U_zu : scalar wind speed at zu                                 [m/s]
      !!
      !! OUTPUT :
      !! --------
      !!    *  Cd     : drag coefficient
      !!    *  Ch     : sensible heat coefficient
      !!    *  Ce     : evaporation coefficient
      !!    *  t_zu   : pot. air temperature adjusted at wind height zu       [K]
      !!    *  q_zu   : specific humidity of air        //                    [kg/kg]
      !!    *  Ubzu   : bulk wind speed at zu                                 [m/s]
      !!
      !! OPTIONAL OUTPUT:
      !! ----------------
      !!    * CdN      : neutral-stability drag coefficient
      !!    * ChN      : neutral-stability sensible heat coefficient
      !!    * CeN      : neutral-stability evaporation coefficient
      !!    * xz0      : return the aerodynamic roughness length (integration constant for wind stress) [m]
      !!    * xu_star  : return u* the friction velocity                    [m/s]
      !!    * xL       : return the Obukhov length                          [m]
      !!    * xUN10    : neutral wind speed at 10m                          [m/s]
      !!
      !! ** Author: L. Brodeau, June 2019 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      REAL(wp), INTENT(in   )                     ::   zt       ! height for t_zt and q_zt                    [m]
      REAL(wp), INTENT(in   )                     ::   zu       ! height for U_zu                             [m]
      REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   sst      ! sea surface temperature                [Kelvin]
      REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   t_zt     ! potential air temperature              [Kelvin]
      REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   ssq      ! sea surface specific humidity           [kg/kg]
      REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   q_zt     ! specific air humidity at zt             [kg/kg]
      REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   U_zu     ! relative wind module at zu                [m/s]
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   Cd       ! transfer coefficient for momentum         (tau)
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   Ch       ! transfer coefficient for sensible heat (Q_sens)
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   Ce       ! transfert coefficient for evaporation   (Q_lat)
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   t_zu     ! pot. air temp. adjusted at zu               [K]
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   q_zu     ! spec. humidity adjusted at zu           [kg/kg]
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   Ubzu    ! bulk wind speed at zu                     [m/s]
      !!
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   CdN
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   ChN
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   CeN
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   xz0     ! Aerodynamic roughness length   [m]
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   xu_star ! u*, friction velocity
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   xL      ! zeta (zu/L)
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   xUN10   ! Neutral wind at zu
      !!
      INTEGER :: Ni, Nj, jit
      LOGICAL :: l_zt_equal_zu = .FALSE.      ! if q and t are given at same height as U
      !!
      REAL(wp), DIMENSION(:,:), ALLOCATABLE ::   u_star, t_star, q_star
      REAL(wp), DIMENSION(:,:), ALLOCATABLE ::   z0       ! roughness length (momentum) [m]
      REAL(wp), DIMENSION(:,:), ALLOCATABLE ::   UN10, UN10_old     ! Neutral wind speed at zu [m/s]
      REAL(wp), DIMENSION(:,:), ALLOCATABLE ::   zeta_u        ! stability parameter at height zu
      REAL(wp), DIMENSION(:,:), ALLOCATABLE ::   ztmp0, ztmp1, ztmp2
      REAL(wp), DIMENSION(:,:), ALLOCATABLE ::   RiB       ! square root of Cd
      !!
      LOGICAL ::  lreturn_cdn=.FALSE., lreturn_chn=.FALSE., lreturn_cen=.FALSE., &
         &        lreturn_z0=.FALSE., lreturn_ustar=.FALSE., lreturn_L=.FALSE., lreturn_UN10=.FALSE.
      CHARACTER(len=40), PARAMETER :: crtnm = 'turb_andreas@mod_blk_andreas.f90'
      !!----------------------------------------------------------------------------------
      Ni = SIZE(sst,1)
      Nj = SIZE(sst,2)

      ALLOCATE( u_star(Ni,Nj), t_star(Ni,Nj), q_star(Ni,Nj), z0(Ni,Nj), &
         &        UN10(Ni,Nj), UN10_old(Ni,Nj), zeta_u(Ni,Nj), RiB(Ni,Nj), &
         &       ztmp0(Ni,Nj),  ztmp1(Ni,Nj),  ztmp2(Ni,Nj) )

      lreturn_cdn   = PRESENT(CdN)
      lreturn_chn   = PRESENT(ChN)
      lreturn_cen   = PRESENT(CeN)
      lreturn_z0    = PRESENT(xz0)
      lreturn_ustar = PRESENT(xu_star)
      lreturn_L     = PRESENT(xL)
      lreturn_UN10  = PRESENT(xUN10)

      l_zt_equal_zu = ( ABS(zu - zt) < 0.01_wp ) ! testing "zu == zt" is risky with double precision

      Ubzu = MAX( 0.25_wp , U_zu )   !  relative wind speed at zu (normally 10m), we don't want to fall under 0.5 m/s

      !! First guess:
      UN10 = Ubzu
      Cd   = 1.1E-3_wp
      Ch   = 1.1E-3_wp
      Ce   = 1.1E-3_wp
      t_zu = t_zt
      q_zu = q_zt

      !! First guess of turbulent scales for scalars:
      ztmp0  = SQRT(Cd)
      t_star = Ch/ztmp0*(t_zu - sst) ! theta*
      q_star = Ce/ztmp0*(q_zu - ssq) ! q*

      ! Bulk Richardson number:
      RiB(:,:) = Ri_bulk( zu, sst, t_zu, ssq, q_zu, Ubzu )


      !! ITERATION BLOCK
      DO jit = 1, nb_iter

         IF(iverbose==1) PRINT *, 'LOLO'

         IF(iverbose==1) PRINT *, 'LOLO *** RiB =', RiB, jit

         WHERE ( RiB < rRi_max )
            !! Normal condition case:
            u_star = u_star_andreas( UN10 )
         ELSEWHERE
            !! Extremely stable + weak wind !!!
            !!  => for we force u* to be consistent with minimum value for CD:
            !!  (otherwize algorithm becomes nonsense...)
            u_star = SQRT(Cx_min) * Ubzu     ! Cd does not go below Cx_min !
         ENDWHERE

         IF(iverbose==1) PRINT *, 'LOLO *** u* =', u_star, jit
         IF(iverbose==2) PRINT *, 'LOLO *** t_zu =', t_zu, jit
         IF(iverbose==2) PRINT *, 'LOLO *** q_zu =', q_zu, jit
         IF(iverbose==1) PRINT *, 'LOLO *** theta* =', t_star, jit
         IF(iverbose==1) PRINT *, 'LOLO *** q* =', q_star, jit

         !! Stability parameter :
         zeta_u = zu*One_on_L( t_zu, q_zu, u_star, t_star, q_star )   ! zu * 1/L

         IF(iverbose==1) PRINT *, 'LOLO *** L =', zu/zeta_u, jit
         IF(iverbose==1) PRINT *, 'LOLO *** zeta_u =', zeta_u, jit
         IF(iverbose==1) PRINT *, 'LOLO *** Ubzu =', Ubzu, jit

         !! Drag coefficient:
         ztmp0 = u_star/Ubzu

         Cd = MAX( ztmp0*ztmp0 , Cx_min )

         IF(iverbose==1) PRINT *, 'LOLO *** CD=', Cd, jit

         !! Roughness length:
         z0 = MIN( z0_from_Cd( zu, Cd,  ppsi=psi_m_andreas(zeta_u) ) , z0_sea_max )
         IF(iverbose==1) PRINT *, 'LOLO *** z0 =', z0, jit
         IF(iverbose==1) PRINT *, 'LOLO'

         !! z0t and z0q, based on LKB, just like into COARE 2.5:
         ztmp0 = z0 * u_star / visc_air(t_zu) ! Re_r
         ztmp1 = z0tq_LKB( 1, ztmp0, z0 )     ! z0t
         ztmp2 = z0tq_LKB( 2, ztmp0, z0 )     ! z0q

         !! Turbulent scales at zu :
         ztmp0 = psi_h_andreas(zeta_u)  ! lolo: zeta_u for scalars???
         IF(iverbose==1) PRINT *, 'LOLO *** psi_h(zeta_u) =', ztmp0, jit
         t_star  = (t_zu - sst)*vkarmn/(LOG(zu) - LOG(ztmp1) - ztmp0)  ! theta* (ztmp1 == z0t in rhs term)
         q_star  = (q_zu - ssq)*vkarmn/(LOG(zu) - LOG(ztmp2) - ztmp0)  !   q*   (ztmp2 == z0q in rhs term)

         IF( (.NOT. l_zt_equal_zu).AND.( jit > 1 ) ) THEN
            !! Re-updating temperature and humidity at zu if zt /= zu:
            ztmp0 = zeta_u/zu*zt   ! zeta_t
            ztmp0 = LOG(zt/zu) + psi_h_andreas(zeta_u) - psi_h_andreas(ztmp0)
            t_zu = t_zt - t_star/vkarmn*ztmp0
            q_zu = q_zt - q_star/vkarmn*ztmp0
            RiB  = Ri_bulk( zu, sst, t_zu, ssq, q_zu, Ubzu ) !LOLO
         ENDIF

         !! Update neutral-stability wind at zu:
         UN10 = MAX( 0.1_wp , UN10_from_ustar( zu, Ubzu, u_star, psi_m_andreas(zeta_u) ) ) ! UN10

         IF(iverbose==1) PRINT *, 'LOLO *** UN10 =', UN10, jit
         IF(iverbose==1) PRINT *, 'LOLO'

      END DO !DO jit = 1, nb_iter

      ! Compute transfer coefficients at zu:
      ztmp0 = u_star/Ubzu

      Cd = MAX( ztmp0*ztmp0 , Cx_min )   ! the earlier use of Cx_min on u* should make use of Cx_min here unnecessary!

      ztmp1 = t_zu - sst ;  ztmp1 = SIGN( MAX(ABS(ztmp1),1.E-6_wp), ztmp1 )  ! dt_zu
      ztmp2 = q_zu - ssq ;  ztmp2 = SIGN( MAX(ABS(ztmp2),1.E-9_wp), ztmp2 )  ! dq_zu
      Ch   = MAX( ztmp0*t_star/ztmp1 , rCs_min )
      Ce   = MAX( ztmp0*q_star/ztmp2 , rCs_min )

      IF( lreturn_cdn .OR. lreturn_chn .OR. lreturn_cen ) ztmp0 = 1._wp/LOG(zu/z0)
      IF( lreturn_cdn )   CdN     = MAX( vkarmn2*ztmp0*ztmp0 , Cx_min )

      IF( lreturn_chn .OR. lreturn_cen ) ztmp1 = z0 * u_star / visc_air(t_zu)  ! Re_r
      IF( lreturn_chn )   ChN     = vkarmn2*ztmp0/LOG(zu/z0tq_LKB( 1, ztmp1, z0 ))
      IF( lreturn_cen )   CeN     = vkarmn2*ztmp0/LOG(zu/z0tq_LKB( 2, ztmp1, z0 ))

      !IF( lreturn_z0 )    xz0     = z0_from_Cd( zu, Cd,  ppsi=psi_m_andreas(zeta_u) )
      IF( lreturn_z0 )    xz0     = z0
      IF( lreturn_ustar ) xu_star = u_star
      IF( lreturn_L )     xL      = zu/zeta_u
      IF( lreturn_UN10 )  xUN10   =  UN10_from_ustar( zu, Ubzu, u_star, psi_m_andreas(zeta_u) )


      DEALLOCATE( u_star, t_star, q_star, z0, UN10, zeta_u, RiB, ztmp0, ztmp1, ztmp2 ) !

   END SUBROUTINE turb_andreas

   
   FUNCTION u_star_andreas_sclr( pun10 )
      !!----------------------------------------------------------------------------------
      !! Estimate of the friction velocity as a function of the neutral-stability wind
      !! speed at at 10m
      !!
      !! Origin: Eq.(2.2) of Andreas et al. (2015)
      !!
      !! ** Author: L. Brodeau, April 2020 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      REAL(wp), INTENT(in) :: pun10          !: neutral-stability scalar wind speed at 10m (m/s)
      REAL(wp)             :: u_star_andreas_sclr !: friction velocity    [m/s]
      !
      REAL(wp) :: za, zt ! local scalars
      !!----------------------------------------------------------------------------------
      za = pun10 - 8.271_wp
      zt = za + SQRT( 0.12_wp*za*za + 0.181_wp )
      u_star_andreas_sclr = 0.239_wp + 0.0433_wp * zt
      !!
   END FUNCTION u_star_andreas_sclr
   !!
   FUNCTION u_star_andreas_vctr( pun10 )
      REAL(wp), DIMENSION(:,:), INTENT(in)             :: pun10               !: neutral-stability scalar wind speed at 10m (m/s)
      REAL(wp), DIMENSION(SIZE(pun10,1),SIZE(pun10,2)) :: u_star_andreas_vctr !: friction velocity    [m/s]
      INTEGER  ::     ji, jj ! dummy loop indices
      DO jj = 1, SIZE(pun10,2)
         DO ji = 1, SIZE(pun10,1)
            u_star_andreas_vctr(ji,jj) = u_star_andreas_sclr( pun10(ji,jj) )
         END DO
      END DO
   END FUNCTION u_star_andreas_vctr


   FUNCTION psi_m_andreas( pzeta )
      !!----------------------------------------------------------------------------------
      !!      Universal profile stability function for momentum
      !!  TO DO !!!!!!!!!!!!!!!!!!!!!
      !! LOLO: paper says Paulson 1970 when unstable and Grachev et al 2007 for STABLE
      !!
      !! pzeta : stability paramenter, z/L where z is altitude measurement
      !!         and L is M-O length
      !!
      !! ** Author: L. Brodeau, April 2020 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pzeta
      REAL(wp), DIMENSION(SIZE(pzeta,1),SIZE(pzeta,2)) :: psi_m_andreas
      !
      REAL(wp), PARAMETER :: zam  = 5._wp      ! a_m (just below Eq.(9b)
      REAL(wp), PARAMETER :: zbm = zam/6.5_wp  ! b_m (just below Eq.(9b)
      !
      REAL(wp), PARAMETER :: z1o3 = 1._wp/3._wp
      REAL(wp), PARAMETER :: zsr3 = SQRT(3._wp)
      !
      INTEGER  ::   ji, jj    ! dummy loop indices
      REAL(wp) :: zta, zx2, zx, zpsi_unst, zbbm, zpsi_stab,  zstab   ! local scalars
      !!----------------------------------------------------------------------------------
      DO jj = 1, SIZE(pzeta,2)
         DO ji = 1, SIZE(pzeta,1)
            !
            zta = MIN( pzeta(ji,jj) , 15._wp ) !! Very stable conditions (L positif and big!)
            !
            !! *** Unstable: Paulson (1970): #LOLO: DOUBLE CHECK IT IS PAULSON!!!!!
            zx2 = SQRT( ABS(1._wp - 16._wp*zta) )  ! (1 - 16z)^0.5
            zx2 = MAX( zx2 , 1._wp )
            zx  = SQRT(zx2)                          ! (1 - 16z)^0.25
            zpsi_unst = 2._wp*LOG(ABS( (1._wp + zx )*0.5_wp ))   &
               &            + LOG(ABS( (1._wp + zx2)*0.5_wp ))   &
               &          - 2._wp*ATAN(zx) + rpi*0.5_wp
            !
            !! *** Stable: Grachev et al 2007 (SHEBA) [Eq.(12) Grachev et al 2007]:
            zx   = ABS(1._wp + zta)**z1o3
            zbbm = ABS( (1._wp - zbm)/zbm )**z1o3 ! B_m
            !
            zpsi_stab = -3.*zam/zbm*(zx - 1._wp) + zam*zbbm/(2.*zbm) * ( &
               &        2.*LOG(ABS( (   zx     +   zbbm         )/(1._wp        +   zbbm   ) )) &
               &         - LOG(ABS( (zx*zx - zx*zbbm + zbbm*zbbm)/(1._wp - zbbm + zbbm*zbbm) )) &
               & + 2.*zsr3*( ATAN( (2.*zx - zbbm)/(zsr3*zbbm) ) - ATAN( (2._wp - zbbm)/(zsr3*zbbm) ) ) )
            !
            !
            zstab = 0.5_wp + SIGN(0.5_wp, zta) ! zta > 0 => zstab = 1
            !
            psi_m_andreas(ji,jj) =       zstab  * zpsi_stab &  ! (zta > 0) Stable
               &              + (1._wp - zstab) * zpsi_unst    ! (zta < 0) Unstable
            !
         END DO
      END DO
   END FUNCTION psi_m_andreas


   FUNCTION psi_h_andreas( pzeta )
      !!----------------------------------------------------------------------------------
      !! Universal profile stability function for temperature and humidity
      !!
      !!    TO DO
      !!       !! LOLO: paper says Paulson 1970 when unstable and Grachev et al 2007 for STABLE
      !!
      !! pzeta : stability paramenter, z/L where z is altitude measurement
      !!         and L is M-O length
      !!
      !! ** Author: L. Brodeau, June 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pzeta
      REAL(wp), DIMENSION(SIZE(pzeta,1),SIZE(pzeta,2)) :: psi_h_andreas
      !
      REAL(wp), PARAMETER ::  zah = 5._wp       ! a_h (just below Eq.(9b)
      REAL(wp), PARAMETER ::  zbh = 5._wp       ! b_h (just below Eq.(9b)
      REAL(wp), PARAMETER ::  zch = 3._wp       ! c_h (just below Eq.(9b)
      REAL(wp), PARAMETER :: zbbh = SQRT(5._wp) ! B_h (just below Eq.(13)
      !
      INTEGER  ::   ji, jj     ! dummy loop indices
      REAL(wp) :: zta, zz, zx2, zpsi_unst, zpsi_stab, zstab  ! local scalars
      !!----------------------------------------------------------------------------------
      DO jj = 1, SIZE(pzeta,2)
         DO ji = 1, SIZE(pzeta,1)
            !
            zta = MIN( pzeta(ji,jj) , 15._wp ) !! Very stable conditions (L positif and large!)
            !
            !! *** Unstable: Paulson (1970): #LOLO: DOUBLE CHECK IT IS PAULSON!!!!!
            zx2 = SQRT( ABS(1._wp - 16._wp*zta) )  ! (1 -16z)^0.5
            zx2 = MAX( zx2 , 1._wp )
            zpsi_unst = 2._wp*LOG( 0.5_wp*(1._wp + zx2) )
            !
            !! *** Stable: Grachev et al 2007 (SHEBA) [Eq.(13) Grachev et al 2007]:
            zz = 2.*zta + zch
            zpsi_stab = - 0.5*zbh*LOG(ABS(1._wp + zch*zta + zta*zta)) &
               &        +  (-zah/zbbh + 0.5*zbh*zch/zbbh)  &
               &          *( LOG(ABS((zz  - zbbh)/(zz  + zbbh))) &
               &           - LOG(ABS((zch - zbbh)/(zch + zbbh)))    )
            !
            zstab = 0.5_wp + SIGN(0.5_wp, zta) ! zta > 0 => zstab = 1
            !
            psi_h_andreas(ji,jj) =            zstab  * zpsi_stab &  ! (zta > 0) Stable
               &                   + (1._wp - zstab) * zpsi_unst    ! (zta < 0) Unstable
            !
         END DO
      END DO
   END FUNCTION psi_h_andreas

   !!======================================================================
END MODULE mod_blk_andreas

! AeroBulk / 2019 / L. Brodeau
!
!***********************************************************************************
! MODULE that gathers a collection of usefull functions related to the physics /
! thermodynamics of air within the Marine Boundaty Layer
!***********************************************************************************
!
!   When using AeroBulk to produce scientific work, please acknowledge with the following paper:
!
!   Brodeau, L., B. Barnier, S. Gulev, and C. Woods, 2016: Climatologically
!   significant effects of some approximations in the bulk parameterizations of
!   turbulent air-sea fluxes. J. Phys. Oceanogr., doi:10.1175/JPO-D-16-0169.1.


MODULE mod_phymbl

   !!   pot_temp      : potential temperature
   !!   virt_temp     : virtual (aka sensible) temperature (potential or absolute)
   !!   rho_air       : density of (moist) air (depends on T_air, q_air and SLP
   !!   visc_air      : kinematic viscosity (aka Nu_air) of air from temperature
   !!   L_vap         : latent heat of vaporization of water as a function of temperature
   !!   cp_air        : specific heat of (moist) air (depends spec. hum. q_air)
   !!   gamma_moist   : adiabatic lapse-rate of moist air
   !!   One_on_L      : 1. / ( Obukhov length )
   !!   Ri_bulk       : bulk Richardson number aka BRN
   !!   q_sat         : saturation humidity as a function of SLP and temperature
   !!   q_air_rh      : specific humidity as a function of RH (fraction, not %), t_air and SLP

   USE mod_const

   IMPLICIT NONE

   INTERFACE pot_temp
      MODULE PROCEDURE pot_temp_vctr, pot_temp_sclr
   END INTERFACE pot_temp

   INTERFACE abs_temp
      MODULE PROCEDURE abs_temp_vctr, abs_temp_sclr
   END INTERFACE abs_temp

   INTERFACE virt_temp
      MODULE PROCEDURE virt_temp_vctr, virt_temp_sclr
   END INTERFACE virt_temp

   INTERFACE Pz_from_P0_tz_qz
      MODULE PROCEDURE Pz_from_P0_tz_qz_vctr, Pz_from_P0_tz_qz_sclr
   END INTERFACE Pz_from_P0_tz_qz

   INTERFACE Theta_from_z_P0_T_q
      MODULE PROCEDURE Theta_from_z_P0_T_q_vctr, Theta_from_z_P0_T_q_sclr
   END INTERFACE Theta_from_z_P0_T_q

   INTERFACE T_from_z_P0_Theta_q
      MODULE PROCEDURE T_from_z_P0_Theta_q_vctr, T_from_z_P0_Theta_q_sclr
   END INTERFACE T_from_z_P0_Theta_q

   INTERFACE visc_air
      MODULE PROCEDURE visc_air_vctr, visc_air_sclr
   END INTERFACE visc_air

   INTERFACE gamma_moist
      MODULE PROCEDURE gamma_moist_vctr, gamma_moist_sclr
   END INTERFACE gamma_moist

   INTERFACE e_sat
      MODULE PROCEDURE e_sat_vctr, e_sat_sclr
   END INTERFACE e_sat

   INTERFACE e_sat_ice
      MODULE PROCEDURE e_sat_ice_vctr, e_sat_ice_sclr
   END INTERFACE e_sat_ice

   INTERFACE de_sat_dt_ice
      MODULE PROCEDURE de_sat_dt_ice_vctr, de_sat_dt_ice_sclr
   END INTERFACE de_sat_dt_ice

   INTERFACE One_on_L
      MODULE PROCEDURE One_on_L_vctr, One_on_L_sclr
   END INTERFACE One_on_L

   INTERFACE Ri_bulk
      MODULE PROCEDURE Ri_bulk_vctr, Ri_bulk_sclr
   END INTERFACE Ri_bulk

   INTERFACE q_sat
      MODULE PROCEDURE q_sat_vctr, q_sat_sclr
   END INTERFACE q_sat

   INTERFACE dq_sat_dt_ice
      MODULE PROCEDURE dq_sat_dt_ice_vctr, dq_sat_dt_ice_sclr
   END INTERFACE dq_sat_dt_ice

   INTERFACE L_vap
      MODULE PROCEDURE L_vap_vctr, L_vap_sclr
   END INTERFACE L_vap

   INTERFACE rho_air
      MODULE PROCEDURE rho_air_vctr, rho_air_sclr
   END INTERFACE rho_air

   INTERFACE cp_air
      MODULE PROCEDURE cp_air_vctr, cp_air_sclr
   END INTERFACE cp_air

   INTERFACE alpha_sw
      MODULE PROCEDURE alpha_sw_vctr, alpha_sw_sclr
   END INTERFACE alpha_sw

   INTERFACE update_qnsol_tau
      MODULE PROCEDURE update_qnsol_tau_vctr, update_qnsol_tau_sclr
   END INTERFACE update_qnsol_tau

   INTERFACE bulk_formula
      MODULE PROCEDURE bulk_formula_vctr, bulk_formula_sclr
   END INTERFACE bulk_formula

   INTERFACE qlw_net
      MODULE PROCEDURE qlw_net_vctr, qlw_net_sclr
   END INTERFACE qlw_net

   INTERFACE z0_from_Cd
      MODULE PROCEDURE z0_from_Cd_vctr, z0_from_Cd_sclr
   END INTERFACE z0_from_Cd

   INTERFACE z0_from_ustar
      MODULE PROCEDURE z0_from_ustar_vctr, z0_from_ustar_sclr
   END INTERFACE z0_from_ustar

   INTERFACE UN10_from_CD
      MODULE PROCEDURE UN10_from_CD_vctr, UN10_from_CD_sclr
   END INTERFACE UN10_from_CD

   INTERFACE f_m_louis
      MODULE PROCEDURE f_m_louis_vctr, f_m_louis_sclr
   END INTERFACE f_m_louis

   INTERFACE f_h_louis
      MODULE PROCEDURE f_h_louis_vctr, f_h_louis_sclr
   END INTERFACE f_h_louis

   !! P R I V A T E :

   REAL(wp), PARAMETER, PRIVATE :: &
                                !! Constants for Goff formula in the presence of ice:
      &      rAg_i = -9.09718_wp, &
      &      rBg_i = -3.56654_wp, &
      &      rCg_i = 0.876793_wp, &
      &      rDg_i = LOG10(6.1071_wp)

   REAL(wp), PARAMETER, PRIVATE :: rc_louis  = 5._wp
   REAL(wp), PARAMETER, PRIVATE :: rc2_louis = rc_louis * rc_louis
   REAL(wp), PARAMETER, PRIVATE :: ram_louis = 2. * rc_louis
   REAL(wp), PARAMETER, PRIVATE :: rah_louis = 3. * rc_louis

   REAL(wp), PARAMETER, PRIVATE :: repsilon = 1.e-6_wp




CONTAINS

   !===============================================================================================
   FUNCTION pot_temp_sclr( pTa, pPz,  pPref )
      !!------------------------------------------------------------------------
      !!                           ***  FUNCTION pot_temp  ***
      !!
      !! Poisson equation to obtain potential temperature from absolute temperature, pressure, and
      !! the reference (sea-level) pressure.
      !!
      !! Air parcel is at height `z` m above sea-level where the pressure is `ppz`,
      !! its absolute temperature is `pTa`.
      !! `pPref` is the reference pressure at sea level aka P0.
      !!
      !! Author: L. Brodeau, June 2021 / AeroBulk
      !!         (https://github.com/brodeau/aerobulk/)
      !!------------------------------------------------------------------------
      REAL(wp), INTENT(in)           :: pTa            !: absolute air temperature at `z` m above sea level  [K]
      REAL(wp), INTENT(in)           :: pPz            !: pressure at `z` m above sea level                  [Pa]
      REAL(wp), INTENT(in), OPTIONAL :: pPref          !: reference pressure (sea-level)                     [Pa]
      REAL(wp)                       :: pot_temp_sclr  !: potential air temperature at `z` m above sea level [K]
      !!
      REAL(wp) :: zPref = Patm
      !!-------------------------------------------------------------------
      IF( PRESENT(pPref) ) zPref = pPref
      pot_temp_sclr = pTa * ( zPref / pPz )**rpoiss_dry
      !!
   END FUNCTION pot_temp_sclr

   FUNCTION pot_temp_vctr( pTa, pPz,  pPref )
      REAL(wp), DIMENSION(:,:), INTENT(in)           :: pTa
      REAL(wp), DIMENSION(:,:), INTENT(in)           :: pPz
      REAL(wp), DIMENSION(:,:), INTENT(in), OPTIONAL :: pPref
      REAL(wp), DIMENSION(SIZE(pTa,1),SIZE(pTa,2))                       :: pot_temp_vctr
      !!-------------------------------------------------------------------
      IF( PRESENT(pPref) ) THEN
         pot_temp_vctr = pTa * ( pPref / pPz )**rpoiss_dry
      ELSE
         pot_temp_vctr = pTa * ( Patm  / pPz )**rpoiss_dry
      END IF
   END FUNCTION pot_temp_vctr
   !===============================================================================================


   !===============================================================================================
   FUNCTION abs_temp_sclr( pThta, pPz,  pPref )
      !!------------------------------------------------------------------------
      !!
      !! Poisson equation to obtain absolute temperature from potential temperature, pressure, and
      !! the reference (sea-level) pressure.
      !!
      !! Air parcel is at height `z` m above sea-level where the pressure is `ppz`,
      !! its potential temperature is `pThta`.
      !! `pPref` is the reference pressure at sea level aka P0.
      !!
      !! Author: L. Brodeau, June 2021 / AeroBulk
      !!         (https://github.com/brodeau/aerobulk/)
      !!------------------------------------------------------------------------
      REAL(wp), INTENT(in)           :: pThta          !: potential air temperature at `z` m above sea level  [K]
      REAL(wp), INTENT(in)           :: pPz            !: pressure at `z` m above sea level                  [Pa]
      REAL(wp), INTENT(in), OPTIONAL :: pPref          !: reference pressure (sea-level)                     [Pa]
      REAL(wp)                       :: abs_temp_sclr  !: potential air temperature at `z` m above sea level [K]
      !!
      REAL(wp) :: zPref = Patm
      !!-------------------------------------------------------------------
      IF( PRESENT(pPref) ) zPref = pPref
      abs_temp_sclr = pThta / MAX ( ( zPref / pPz )**rpoiss_dry, 1.E-9_wp )
      !!
   END FUNCTION abs_temp_sclr

   FUNCTION abs_temp_vctr( pThta, pPz,  pPref )
      REAL(wp), DIMENSION(:,:), INTENT(in)           :: pThta
      REAL(wp), DIMENSION(:,:), INTENT(in)           :: pPz
      REAL(wp), DIMENSION(:,:), INTENT(in), OPTIONAL :: pPref
      REAL(wp), DIMENSION(SIZE(pThta,1),SIZE(pThta,2))                       :: abs_temp_vctr
      !!-------------------------------------------------------------------
      IF( PRESENT(pPref) ) THEN
         abs_temp_vctr = pThta / MAX ( ( pPref / pPz )**rpoiss_dry, 1.E-9_wp )
      ELSE
         abs_temp_vctr = pThta / MAX ( ( Patm  / pPz )**rpoiss_dry, 1.E-9_wp )
      END IF
   END FUNCTION abs_temp_vctr
   !===============================================================================================





   !===============================================================================================
   FUNCTION virt_temp_sclr( pTa, pqa )
      !!------------------------------------------------------------------------
      !!
      !! Compute the (absolute/potential) VIRTUAL temperature, based on the
      !! (absolute/potential) temperature and specific humidity
      !!
      !! If input temperature is absolute then output virtual temperature is absolute
      !! If input temperature is potential then output virtual temperature is potential
      !!
      !! Author: L. Brodeau, June 2019 / AeroBulk
      !!         (https://github.com/brodeau/aerobulk/)
      !!------------------------------------------------------------------------
      REAL(wp)             :: virt_temp_sclr !: virtual temperature [K]
      REAL(wp), INTENT(in) :: pTa       !: absolute or potential air temperature [K]
      REAL(wp), INTENT(in) :: pqa       !: specific humidity of air   [kg/kg]
      !!-------------------------------------------------------------------
      virt_temp_sclr = pTa * (1._wp + rctv0*pqa)
      !!
      !! This is exactly the same thing as:
      !! virt_temp_sclr = pTa * ( pwa + reps0) / (reps0*(1.+pwa))
      !! with wpa (mixing ration) defined as : pwa = pqa/(1.-pqa)
      !!
   END FUNCTION virt_temp_sclr
   !!
   FUNCTION virt_temp_vctr( pTa, pqa )
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pTa !: absolute or potential air temperature [K]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pqa !: specific humidity of air   [kg/kg]
      REAL(wp), DIMENSION(SIZE(pTa,1),SIZE(pTa,2))             :: virt_temp_vctr !: virtual temperature [K]
      virt_temp_vctr(:,:) = pTa(:,:) * (1._wp + rctv0*pqa(:,:))
   END FUNCTION virt_temp_vctr
   !===============================================================================================




   !===============================================================================================
   FUNCTION Pz_from_P0_tz_qz_sclr( pz, pslp, pTa, pqa,  l_ice )
      !!-------------------------------------------------------------------------------
      !!                           ***  FUNCTION Pz_from_P0_tz_qz  ***
      !!
      !! ** Purpose : compute air pressure at height `pz` m above sea level,
      !!              based barometric equation, from absolute air temperature
      !!              and specific humidity at height `pz` and sea-level pressure
      !!
      !! ** Author: G. Samson,  Feb  2021
      !!            L. Brodeau, June 2021
      !!-------------------------------------------------------------------------------
      REAL(wp), INTENT(in)           :: pz               ! height above sea-level             [m]
      REAL(wp), INTENT(in)           :: pslp             ! pressure at sea-level (z=0)        [Pa]
      REAL(wp), INTENT(in)           :: pTa              ! air abs. temperature at z=`pz`     [K]
      REAL(wp), INTENT(in)           :: pqa              ! air specific humidity at z=`pz`    [kg/kg]
      LOGICAL , INTENT(in), OPTIONAL :: l_ice            ! sea-ice presence
      REAL(wp)                       :: Pz_from_P0_tz_qz_sclr  ! pressure at `pz` m above sea level [Pa]
      !!
      REAL(wp)           :: zpa, zxm, zqsat, zf
      INTEGER            :: it
      LOGICAL            :: lice = .FALSE. ! sea-ice presence
      INTEGER, PARAMETER :: niter = 3      ! iteration indice and number
      !!-------------------------------------------------------------------------------
      IF( PRESENT(l_ice) ) lice = l_ice
      !!
      zpa = pslp              ! first guess of air pressure at zt   [Pa]
      DO it = 1, niter
         zqsat = q_sat( pTa, zpa, l_ice=lice )                               ! saturation specific humidity [kg/kg]
         zf    = pqa/zqsat
         zxm   = (1._wp - zf) * rmm_dryair + zf * rmm_water    ! moist air molar mass [kg/mol]
         zpa   = pslp * EXP( -grav * zxm * pz / ( R_gas * pTa ) )
      END DO
      !!
      Pz_from_P0_tz_qz_sclr = zpa
      !!
   END FUNCTION Pz_from_P0_tz_qz_sclr

   FUNCTION Pz_from_P0_tz_qz_vctr( pz, pslp, pTa, pqa,  l_ice )
      REAL(wp),                     INTENT(in) :: pz               ! height above sea-level             [m]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pslp             ! pressure at sea-level (z=0)        [Pa]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pTa              ! air abs. temperature at z=`pz`     [K]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pqa              ! air specific humidity at z=`pz`    [kg/kg]
      LOGICAL , OPTIONAL          , INTENT(in) :: l_ice            ! sea-ice presence
      REAL(wp), DIMENSION(SIZE(pTa,1),SIZE(pTa,2))             :: Pz_from_P0_tz_qz_vctr  ! pressure at `pz` m above sea level [Pa]
      !!
      INTEGER :: ji, jj         ! loop indices
      LOGICAL :: lice = .FALSE. ! presence of ice ?
      !!
      IF( PRESENT(l_ice) ) lice = l_ice
      DO jj = 1, SIZE(pTa,2)
         DO ji = 1, SIZE(pTa,1)
            Pz_from_P0_tz_qz_vctr(ji,jj) = Pz_from_P0_tz_qz_sclr( pz, pslp(ji,jj), pTa(ji,jj), pqa(ji,jj),  l_ice=lice )
         END DO
      END DO
   END FUNCTION Pz_from_P0_tz_qz_vctr

   !===============================================================================================


   !===============================================================================================
   FUNCTION Theta_from_z_P0_T_q_sclr( pz, pslp, pTa, pqa )
      !!-------------------------------------------------------------------------------
      !!                           ***  FUNCTION Theta_from_z_P0_T_q  ***
      !!
      !! ** Purpose : Converts absolute temperature at height `pz` to potential temperature,
      !!              using sea-level pressure and specific humidity at heaight `pz`
      !!
      !! ** Author: G. Samson,  Feb  2021
      !!            L. Brodeau, June 2021
      !!-------------------------------------------------------------------------------
      REAL(wp), INTENT(in) :: pz               ! height above sea-level             [m]
      REAL(wp), INTENT(in) :: pslp             ! pressure at sea-level (z=0)        [Pa]
      REAL(wp), INTENT(in) :: pTa              ! air abs. temperature at z=`pz`     [K]
      REAL(wp), INTENT(in) :: pqa              ! air specific humidity at z=`pz`    [kg/kg]
      REAL(wp)             :: Theta_from_z_P0_T_q_sclr ! air pot. temperature at z=`pz` [K]
      !!
      REAL(wp)           :: zPz
      !!-------------------------------------------------------------------------------
      zPz = Pz_from_P0_tz_qz_sclr( pz, pslp, pTa, pqa ) ! pressure at z=`pz`
      !!
      Theta_from_z_P0_T_q_sclr = pot_temp_sclr( pTa, zPz,  pPref=pslp )
      !!
   END FUNCTION Theta_from_z_P0_T_q_sclr

   FUNCTION Theta_from_z_P0_T_q_vctr( pz, pslp, pTa, pqa )
      REAL(wp),                     INTENT(in) :: pz
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pslp
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pTa
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pqa
      REAL(wp), DIMENSION(SIZE(pTa,1),SIZE(pTa,2))             :: Theta_from_z_P0_T_q_vctr
      !!-------------------------------------------------------------------------------
      Theta_from_z_P0_T_q_vctr = pot_temp_vctr( pTa, Pz_from_P0_tz_qz_vctr( pz, pslp, pTa, pqa ),  pPref=pslp )
   END FUNCTION Theta_from_z_P0_T_q_vctr
   !===============================================================================================


   !===============================================================================================
   FUNCTION T_from_z_P0_Theta_q_sclr( pz, pslp, pThta, pqa )
      !!-------------------------------------------------------------------------------
      !!                           ***  FUNCTION T_from_z_P0_Theta_q  ***
      !!
      !! ** Purpose : Converts potential temperature at height `pz` to absolute temperature,
      !!              using sea-level pressure and specific humidity at heaight `pz`
      !!
      !! ** Author: G. Samson,  Feb  2021
      !!            L. Brodeau, June 2021
      !!-------------------------------------------------------------------------------
      REAL(wp), INTENT(in) :: pz               ! height above sea-level             [m]
      REAL(wp), INTENT(in) :: pslp             ! pressure at sea-level (z=0)        [Pa]
      REAL(wp), INTENT(in) :: pThta            ! air potential temperature at z=`pz`     [K]
      REAL(wp), INTENT(in) :: pqa              ! air specific humidity at z=`pz`    [kg/kg]
      REAL(wp)             :: T_from_z_P0_Theta_q_sclr ! air pot. temperature at z=`pz` [K]
      !!
      REAL(wp) :: zPz, zTa
      INTEGER  :: it
      !!-------------------------------------------------------------------------------
      zTa = pThta - rgamma_dry*pz   ! 1st guess of abs. temp. based on pot. temp
      !!
      DO it = 1, 4
         zPz = Pz_from_P0_tz_qz_sclr( pz, pslp, zTa, pqa ) ! pressure at z=`pz`
         zTa = abs_temp_sclr( pThta, zPz,  pPref=pslp )    ! update of absolute temperature
      END DO
      T_from_z_P0_Theta_q_sclr = zTa
      !!
   END FUNCTION T_from_z_P0_Theta_q_sclr

   FUNCTION T_from_z_P0_Theta_q_vctr( pz, pslp, pThta, pqa )
      REAL(wp),                     INTENT(in) :: pz
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pslp
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pThta
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pqa
      REAL(wp), DIMENSION(SIZE(pslp,1),SIZE(pslp,2))             :: T_from_z_P0_Theta_q_vctr
      INTEGER :: ji, jj
      DO jj = 1, SIZE(pslp,2)
         DO ji = 1, SIZE(pslp,1)
            T_from_z_P0_Theta_q_vctr(ji,jj) = T_from_z_P0_Theta_q_sclr( pz, pslp(ji,jj), pThta(ji,jj), pqa(ji,jj) )
         END DO
      END DO
   END FUNCTION T_from_z_P0_Theta_q_vctr
   !===============================================================================================





   !   !===============================================================================================
   !   FUNCTION Pz_from_P0_sclr( pz, pslp, pqa, pThta, pTa, l_ice )
   !      !!-------------------------------------------------------------------------------
   !      !!                           ***  FUNCTION Pz_from_P0  ***
   !      !!
   !      !! ** Purpose : compute air pressure at height `pz` m above sea level,
   !      !!              based barometric equation, from potential or absolute air temperature
   !      !!              and specific humidity at height `pz` and pressure at sea level
   !      !!
   !      !! ** Author: G. Samson,  Feb  2021
   !      !!            L. Brodeau, June 2021
   !      !!-------------------------------------------------------------------------------
   !      REAL(wp), INTENT(in )             :: pz               ! height above sea-level             [m]
   !      REAL(wp), INTENT(in )             :: pslp             ! pressure at sea-level (z=0)        [Pa]
   !      REAL(wp), INTENT(in )             :: pqa              ! air specific humidity at z=`pz`    [kg/kg]
   !      REAL(wp), INTENT(in )  , OPTIONAL :: pThta            ! air potential temperature          [K]
   !      REAL(wp), INTENT(inout), OPTIONAL :: pTa              ! air absolute temperature           [K]
   !      LOGICAL , INTENT(in)   , OPTIONAL :: l_ice            ! sea-ice presence
   !      REAL(wp)                          :: Pz_from_P0_sclr  ! pressure at `pz` m above sea level [Pa]
   !      !!
   !      REAL(wp)           :: ztpa, zta, zpa, zxm, zmask, zqsat, zf
   !      INTEGER            :: it
   !      LOGICAL            :: lice             ! sea-ice presence
   !      INTEGER, PARAMETER :: niter = 3    ! iteration indice and number
   !
   !      IF( PRESENT(pThta) ) THEN
   !         zmask = 1._wp
   !         ztpa = pThta
   !      ELSE
   !         zmask = 0._wp
   !         zta   = pTa
   !      ENDIF
   !
   !      lice = .FALSE.
   !      IF( PRESENT(l_ice) ) lice = l_ice
   !
   !      zpa = pslp              ! first guess of air pressure at zt   [Pa]
   !      DO it = 1, niter
   !         zta =            zmask  * ztpa*(zpa/Patm )**rpoiss_dry & ! if provided temp is potential => converstion to absolute temp !
   !            &  + (1._wp - zmask) * zta                            !  "           "      absolute  => keep unchanged
   !         !!
   !         zqsat = q_sat( zta, zpa, l_ice=lice )                               ! saturation specific humidity [kg/kg]
   !         zf    = pqa/zqsat
   !         zxm   = (1._wp - zf) * rmm_dryair + zf * rmm_water    ! moist air molar mass [kg/mol]
   !         zpa   = pslp * EXP( -grav * zxm * pz / ( R_gas * zta ) )
   !      END DO
   !
   !      Pz_from_P0_sclr = zpa
   !      IF(( PRESENT(pTa) ).AND.( PRESENT(pThta) )) pTa = zta   !! Absolute temperature is returned (it was not used as an input)
   !
   !   END FUNCTION Pz_from_P0_sclr
   !
   !   FUNCTION Pz_from_P0_vctr( pqa, pslp, pz, pThta, pTa, l_ice )
   !
   !      !!-------------------------------------------------------------------------------
   !      !!                           ***  FUNCTION Pz_from_P0  ***
   !      !!
   !      !! ** Purpose : compute air pressure using barometric equation
   !      !!              from either potential or absolute air temperature
   !      !! ** Author: G. Samson, Feb 2021
   !      !!-------------------------------------------------------------------------------
   !
   !      REAL(wp), DIMENSION(:,:)                          :: Pz_from_P0_vctr ! air pressure              [Pa]
   !      REAL(wp), DIMENSION(:,:), INTENT(in )             :: pqa            ! air specific humidity     [kg/kg]
   !      REAL(wp), DIMENSION(:,:), INTENT(in )             :: pslp           ! sea-level pressure        [Pa]
   !      REAL(wp),                     INTENT(in )             :: pz             ! height above surface      [m]
   !      REAL(wp), DIMENSION(:,:), INTENT(in )  , OPTIONAL :: pThta           ! air potential temperature [K]
   !      REAL(wp), DIMENSION(:,:), INTENT(inout), OPTIONAL :: pTa            ! air absolute temperature  [K]
   !      LOGICAL                     , INTENT(in)   , OPTIONAL :: l_ice          ! sea-ice presence
   !      !!
   !      INTEGER                                               :: ji, jj         ! loop indices
   !      LOGICAL                                               :: lice           ! sea-ice presence
   !      lice = .FALSE.
   !      IF( PRESENT(l_ice) ) lice = l_ice
   !      IF( PRESENT(pThta) ) THEN
   !         DO jj = 1, SIZE(ZZ,2)
   !            DO ji = 1, SIZE(ZZ,1)
   !               Pz_from_P0_vctr(ji,jj) = Pz_from_P0_sclr( pqa(ji,jj), pslp(ji,jj), pz, pThta=pThta(ji,jj), pTa=pTa(ji,jj), l_ice=lice )
   !            END DO
   !         END DO
   !      ELSE
   !         DO jj = 1, SIZE(ZZ,2)
   !            DO ji = 1, SIZE(ZZ,1)
   !               Pz_from_P0_vctr(ji,jj) = Pz_from_P0_sclr( pqa(ji,jj), pslp(ji,jj), pz,                     pTa=pTa(ji,jj), l_ice=lice )
   !            END DO
   !         END DO
   !      ENDIF
   !   END FUNCTION Pz_from_P0_vctr
   !   !===============================================================================================




   !===============================================================================================
   FUNCTION rho_air_sclr( pTa, pqa, pslp )
      !!-------------------------------------------------------------------------------
      !!                           ***  FUNCTION rho_air_sclr  ***
      !!
      !! ** Purpose : compute density of (moist) air using the eq. of state of the atmosphere
      !!
      !! ** Author: L. Brodeau, June 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!-------------------------------------------------------------------------------
      REAL(wp), INTENT(in) :: pTa           ! absolute air temperature             [K]
      REAL(wp), INTENT(in) :: pqa            ! air specific humidity   [kg/kg]
      REAL(wp), INTENT(in) :: pslp           ! pressure in                [Pa]
      REAL(wp)             :: rho_air_sclr   ! density of moist air   [kg/m^3]
      !!-------------------------------------------------------------------------------
      rho_air_sclr = MAX( pslp / (R_dry*pTa * ( 1._wp + rctv0*pqa )) , 0.8_wp )
      !!
   END FUNCTION rho_air_sclr
   !!
   FUNCTION rho_air_vctr( pTa, pqa, pslp )
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pTa         ! absolute air temperature             [K]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pqa          ! air specific humidity   [kg/kg]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pslp          ! pressure in                [Pa]
      REAL(wp), DIMENSION(SIZE(pTa,1),SIZE(pTa,2))             :: rho_air_vctr ! density of moist air   [kg/m^3]
      !!-------------------------------------------------------------------------------
      rho_air_vctr = MAX( pslp / (R_dry*pTa * ( 1._wp + rctv0*pqa )) , 0.8_wp )
   END FUNCTION rho_air_vctr

   !===============================================================================================
   FUNCTION visc_air_sclr(pTa)
      !!----------------------------------------------------------------------------------
      !! Air kinetic viscosity (m^2/s) given from air temperature in Kelvin
      !!
      !! ** Author: L. Brodeau, june 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      REAL(wp)             :: visc_air_sclr   ! kinetic viscosity (m^2/s)
      REAL(wp), INTENT(in) :: pTa       ! absolute air temperature in [K]
      REAL(wp) ::   ztc, ztc2   ! local scalar
      !!----------------------------------------------------------------------------------
      ztc  = pTa - rt0   ! absolute air temp, in deg. C
      ztc2 = ztc*ztc
      visc_air_sclr = 1.326e-5*(1. + 6.542E-3*ztc + 8.301e-6*ztc2 - 4.84e-9*ztc2*ztc)
      !!
   END FUNCTION visc_air_sclr
   !!
   FUNCTION visc_air_vctr(pTa)
      REAL(wp), DIMENSION(:,:), INTENT(in) ::   pTa       ! absolute air temperature in [K]
      REAL(wp), DIMENSION(SIZE(pTa,1),SIZE(pTa,2))             ::   visc_air_vctr   ! kinetic viscosity (m^2/s)
      INTEGER  ::   ji, jj      ! dummy loop indices
      DO jj = 1, SIZE(pTa,2)
         DO ji = 1, SIZE(pTa,1)
            visc_air_vctr(ji,jj) = visc_air_sclr( pTa(ji,jj) )
         END DO
      END DO
   END FUNCTION visc_air_vctr
   !===============================================================================================


   !===============================================================================================
   FUNCTION L_vap_sclr( psst )
      !!---------------------------------------------------------------------------------
      !!                           ***  FUNCTION L_vap_sclr  ***
      !!
      !! ** Purpose : Compute the latent heat of vaporization of water from temperature
      !!
      !! ** Author: L. Brodeau, june 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      REAL(wp)             :: L_vap_sclr  ! latent heat of vaporization   [J/kg]
      REAL(wp), INTENT(in) :: psst        ! water temperature               [K]
      !!----------------------------------------------------------------------------------
      L_vap_sclr = (  2.501_wp - 0.00237_wp * ( psst - rt0)  ) * 1.e6_wp
      !!
   END FUNCTION L_vap_sclr

   FUNCTION L_vap_vctr( psst )
      REAL(wp), DIMENSION(:,:), INTENT(in) :: psst        ! water temperature             [K]
      REAL(wp), DIMENSION(SIZE(psst,1),SIZE(psst,2))             :: L_vap_vctr  ! latent heat of vaporization [J/kg]
      L_vap_vctr = (  2.501_wp - 0.00237_wp * ( psst(:,:) - rt0)  ) * 1.e6_wp
   END FUNCTION L_vap_vctr
   !===============================================================================================


   !===============================================================================================
   FUNCTION cp_air_sclr( pqa )
      !!-------------------------------------------------------------------------------
      !!                           ***  FUNCTION cp_air_sclr  ***
      !!
      !! ** Purpose : Compute specific heat (Cp) of moist air
      !!
      !! ** Author: L. Brodeau, june 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!-------------------------------------------------------------------------------
      REAL(wp), INTENT(in) :: pqa           ! air specific humidity         [kg/kg]
      REAL(wp)             :: cp_air_sclr   ! specific heat of moist air   [J/K/kg]
      !!-------------------------------------------------------------------------------
      cp_air_sclr = rCp_dry + rCp_vap * pqa
      !!
   END FUNCTION cp_air_sclr
   !!
   FUNCTION cp_air_vctr( pqa )
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pqa      ! air specific humidity         [kg/kg]
      REAL(wp), DIMENSION(SIZE(pqa,1),SIZE(pqa,2))             :: cp_air_vctr   ! specific heat of moist air   [J/K/kg]
      cp_air_vctr = rCp_dry + rCp_vap * pqa
   END FUNCTION cp_air_vctr
   !===============================================================================================


   !===============================================================================================
   FUNCTION gamma_moist_sclr( pTa, pqa )
      !!----------------------------------------------------------------------------------
      !! ** Purpose : Compute the moist adiabatic lapse-rate.
      !!     => http://glossary.ametsoc.org/wiki/Moist-adiabatic_lapse_rate
      !!     => http://www.geog.ucsb.edu/~joel/g266_s10/lecture_notes/chapt03/oh10_3_01/oh10_3_01.html
      !!
      !! ** Author: L. Brodeau, June 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      REAL(wp)             :: gamma_moist_sclr !                           [K/m]
      REAL(wp), INTENT(in) ::   pTa           ! absolute air temperature  [K] !LOLO: double check it's absolute !!!
      REAL(wp), INTENT(in) ::   pqa            ! specific humidity     [kg/kg]
      REAL(wp) :: zta, zqa, zwa, ziRT, zLvap        ! local scalars
      !!----------------------------------------------------------------------------------
      zta = MAX( pTa,  180._wp) ! prevents screw-up over masked regions where field == 0.
      zqa = MAX( pqa,  1.E-6_wp) !    "                   "                     "
      !!
      zwa = zqa / (1._wp - zqa)   ! w is mixing ratio w = q/(1-q) | q = w/(1+w)
      ziRT = 1._wp / (R_dry*zta)    ! 1/RT
      zLvap = L_vap_sclr( pTa )
      !!
      gamma_moist_sclr = grav * ( 1._wp + zLvap*zwa*ziRT ) / ( rCp_dry + zLvap*zLvap*zwa*reps0*ziRT/zta )
      !!
   END FUNCTION gamma_moist_sclr
   !!
   FUNCTION gamma_moist_vctr( pTa, pqa )
      REAL(wp), DIMENSION(:,:), INTENT(in) ::   pTa
      REAL(wp), DIMENSION(:,:), INTENT(in) ::   pqa
      REAL(wp), DIMENSION(SIZE(pTa,1),SIZE(pTa,2))             ::   gamma_moist_vctr
      INTEGER  :: ji, jj
      DO jj = 1, SIZE(pTa,2)
         DO ji = 1, SIZE(pTa,1)
            gamma_moist_vctr(ji,jj) = gamma_moist_sclr( pTa(ji,jj), pqa(ji,jj) )
         END DO
      END DO
   END FUNCTION gamma_moist_vctr
   !===============================================================================================


   !===============================================================================================
   FUNCTION One_on_L_sclr( pThta, pqa, pus, pts, pqs )
      !!------------------------------------------------------------------------
      !!
      !! Evaluates the 1./(Obukhov length) from air temperature,
      !! air specific humidity, and frictional scales u*, t* and q*
      !!
      !! Author: L. Brodeau, June 2019 / AeroBulk
      !!         (https://github.com/brodeau/aerobulk/)
      !!------------------------------------------------------------------------
      REAL(wp)             :: One_on_L_sclr !: 1./(Obukhov length) [m^-1]
      REAL(wp), INTENT(in) :: pThta     !: reference potential temperature of air [K]
      REAL(wp), INTENT(in) :: pqa      !: reference specific humidity of air   [kg/kg]
      REAL(wp), INTENT(in) :: pus      !: u*: friction velocity [m/s]
      REAL(wp), INTENT(in) :: pts, pqs !: \theta* and q* friction aka turb. scales for temp. and spec. hum.
      REAL(wp) ::     zqa          ! local scalar
      !!-------------------------------------------------------------------
      zqa = (1._wp + rctv0*pqa)
      !
      ! The main concern is to know whether, the vertical turbulent flux of virtual temperature, < u' theta_v' > is estimated with:
      !  a/  -u* [ theta* (1 + 0.61 q) + 0.61 theta q* ] => this is the one that seems correct! chose this one!
      !                      or
      !  b/  -u* [ theta*              + 0.61 theta q* ]
      !
      One_on_L_sclr = grav*vkarmn*( pts*zqa + rctv0*pThta*pqs ) / MAX( pus*pus*pThta*zqa , 1.E-9_wp )
      !
      One_on_L_sclr = SIGN( MIN(ABS(One_on_L_sclr),200._wp), One_on_L_sclr ) ! (prevent FPE from stupid values over masked regions...)
      !!
   END FUNCTION One_on_L_sclr
   !!
   FUNCTION One_on_L_vctr( pThta, pqa, pus, pts, pqs )
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pThta     !: reference potential temperature of air [K]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pqa      !: reference specific humidity of air   [kg/kg]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pus      !: u*: friction velocity [m/s]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pts, pqs !: \theta* and q* friction aka turb. scales for temp. and spec. hum.
      REAL(wp), DIMENSION(SIZE(pThta,1),SIZE(pThta,2))             :: One_on_L_vctr !: 1./(Obukhov length) [m^-1]
      INTEGER  ::   ji, jj         ! dummy loop indices
      !!-------------------------------------------------------------------
      DO jj = 1, SIZE(pThta,2)
         DO ji = 1, SIZE(pThta,1)
            One_on_L_vctr(ji,jj) = One_on_L_sclr( pThta(ji,jj), pqa(ji,jj), pus(ji,jj), pts(ji,jj), pqs(ji,jj) )
         END DO
      END DO
   END FUNCTION One_on_L_vctr
   !===============================================================================================

   !===============================================================================================
   FUNCTION Ri_bulk_sclr( pz, psst, pThta, pssq, pqa, pub,  pTa_layer, pqa_layer )
      !!----------------------------------------------------------------------------------
      !! Bulk Richardson number according to "wide-spread equation"...
      !!
      !!    Reminder: the Richardson number is the ratio "buoyancy" / "shear"
      !!
      !! ** Author: L. Brodeau, June 2019 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      REAL(wp)             :: Ri_bulk_sclr
      REAL(wp), INTENT(in) :: pz    ! height above the sea (aka "delta z")  [m]
      REAL(wp), INTENT(in) :: psst  ! SST                                   [K]
      REAL(wp), INTENT(in) :: pThta  ! pot. air temp. at height "pz"         [K]
      REAL(wp), INTENT(in) :: pssq  ! 0.98*q_sat(SST)                   [kg/kg]
      REAL(wp), INTENT(in) :: pqa   ! air spec. hum. at height "pz"     [kg/kg]
      REAL(wp), INTENT(in) :: pub   ! bulk wind speed                     [m/s]
      REAL(wp), INTENT(in), OPTIONAL :: pTa_layer ! when possible, a better guess of absolute temperature WITHIN the layer [K]
      REAL(wp), INTENT(in), OPTIONAL :: pqa_layer ! when possible, a better guess of specific humidity    WITHIN the layer [kg/kg]
      LOGICAL  :: l_ptqa_l_prvd = .FALSE.
      REAL(wp) :: zdthv, ztv, zsstv  ! local scalars
      !!-------------------------------------------------------------------
      IF( PRESENT(pTa_layer) .AND. PRESENT(pqa_layer) ) l_ptqa_l_prvd=.TRUE.
      !
      zsstv = virt_temp_sclr( psst, pssq )          ! virtual SST (absolute==potential because z=0!)
      !
      zdthv = virt_temp_sclr( pThta, pqa  ) - zsstv  ! air-sea delta of "virtual potential temperature"
      !
      !! ztv: estimate of the ABSOLUTE virtual temp. within the layer
      IF( l_ptqa_l_prvd ) THEN
         ztv = virt_temp_sclr( pTa_layer, pqa_layer )
      ELSE
         ztv = 0.5_wp*( zsstv + virt_temp_sclr( pThta-rgamma_dry*pz, pqa ) )
      END IF
      !
      Ri_bulk_sclr = grav*zdthv*pz / ( ztv*pub*pub )      ! the usual definition of Ri_bulk_sclr
      !!
   END FUNCTION Ri_bulk_sclr
   !!
   FUNCTION Ri_bulk_vctr( pz, psst, pThta, pssq, pqa, pub,  pTa_layer, pqa_layer )
      REAL(wp)                    , INTENT(in) :: pz
      REAL(wp), DIMENSION(:,:), INTENT(in) :: psst
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pThta
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pssq
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pqa
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pub
      REAL(wp), DIMENSION(:,:), INTENT(in), OPTIONAL :: pTa_layer
      REAL(wp), DIMENSION(:,:), INTENT(in), OPTIONAL :: pqa_layer
      REAL(wp), DIMENSION(SIZE(psst,1),SIZE(psst,2))             :: Ri_bulk_vctr
      LOGICAL  :: l_ptqa_l_prvd = .FALSE.
      INTEGER  ::   ji, jj
      IF( PRESENT(pTa_layer) .AND. PRESENT(pqa_layer) ) l_ptqa_l_prvd=.TRUE.
      DO jj = 1, SIZE(psst,2)
         DO ji = 1, SIZE(psst,1)
            IF( l_ptqa_l_prvd ) THEN
               Ri_bulk_vctr(ji,jj) = Ri_bulk_sclr( pz, psst(ji,jj), pThta(ji,jj), pssq(ji,jj), pqa(ji,jj), pub(ji,jj), &
                  &                                pTa_layer=pTa_layer(ji,jj ),  pqa_layer=pqa_layer(ji,jj ) )
            ELSE
               Ri_bulk_vctr(ji,jj) = Ri_bulk_sclr( pz, psst(ji,jj), pThta(ji,jj), pssq(ji,jj), pqa(ji,jj), pub(ji,jj) )
            END IF
         END DO
      END DO
   END FUNCTION Ri_bulk_vctr
   !===============================================================================================


   !===============================================================================================
   FUNCTION e_sat_sclr( pTa )
      !!----------------------------------------------------------------------------------
      !!                   ***  FUNCTION e_sat_sclr  ***
      !!                  < SCALAR argument version >
      !! ** Purpose : water vapor at saturation in [Pa]
      !!              Based on accurate estimate by Goff, 1957
      !!
      !! ** Author: L. Brodeau, june 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!
      !!    Note: what rt0 should be here, is 273.16 (triple point of water) and not 273.15 like here
      !!----------------------------------------------------------------------------------
      REAL(wp)             ::   e_sat_sclr   ! water vapor at saturation   [kg/kg]
      REAL(wp), INTENT(in) ::   pTa    ! absolute air temperature                  [K]
      REAL(wp) ::   zta, ztmp   ! local scalar
      !!----------------------------------------------------------------------------------
      zta = MAX( pTa , 180._wp )   ! absolute air temp., prevents fpe0 errors dute to unrealistically low values over masked regions...
      ztmp = rt0 / zta   !LOLO: rt0 or rtt0 ???? (273.15 vs 273.16 )
      !
      ! Vapour pressure at saturation [Pa] : WMO, (Goff, 1957)
      e_sat_sclr = 100.*( 10.**( 10.79574*(1. - ztmp) - 5.028*LOG10(zta/rt0)        &
         &    + 1.50475*10.**(-4)*(1. - 10.**(-8.2969*(zta/rt0 - 1.)) )  &
         &    + 0.42873*10.**(-3)*(10.**(4.76955*(1. - ztmp)) - 1.) + 0.78614) )
      !
   END FUNCTION e_sat_sclr
   !!
   FUNCTION e_sat_vctr(pTa)
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pTa    !: temperature [K]
      REAL(wp), DIMENSION(SIZE(pTa,1),SIZE(pTa,2))             :: e_sat_vctr !: vapour pressure at saturation  [Pa]
      INTEGER  ::   ji, jj         ! dummy loop indices
      DO jj = 1, SIZE(pTa,2)
         DO ji = 1, SIZE(pTa,1)
            e_sat_vctr(ji,jj) = e_sat_sclr(pTa(ji,jj))
         END DO
      END DO
   END FUNCTION e_sat_vctr
   !===============================================================================================

   !===============================================================================================
   FUNCTION e_sat_ice_sclr(pTa)
      !!---------------------------------------------------------------------------------
      !! Same as "e_sat" but over ice rather than water!
      !!---------------------------------------------------------------------------------
      REAL(wp)             :: e_sat_ice_sclr !: vapour pressure at saturation in presence of ice [Pa]
      REAL(wp), INTENT(in) :: pTa
      !!
      REAL(wp) :: zta, zle, ztmp
      !!---------------------------------------------------------------------------------
      zta = MAX( pTa , 180._wp )   ! absolute air temp., prevents fpe0 errors dute to unrealistically low values over masked regions...
      ztmp = rtt0/zta
      !!
      zle  = rAg_i*(ztmp - 1._wp) + rBg_i*LOG10(ztmp) + rCg_i*(1._wp - zta/rtt0) + rDg_i
      !!
      e_sat_ice_sclr = 100._wp * 10._wp**zle
   END FUNCTION e_sat_ice_sclr
   !!
   FUNCTION e_sat_ice_vctr(pTa)
      !! Same as "e_sat" but over ice rather than water!
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pTa
      REAL(wp), DIMENSION(SIZE(pTa,1),SIZE(pTa,2)) :: e_sat_ice_vctr !: vapour pressure at saturation in presence of ice [Pa]
      INTEGER  :: ji, jj
      !!----------------------------------------------------------------------------------
      DO jj = 1, SIZE(pTa,2)
         DO ji = 1, SIZE(pTa,1)
            e_sat_ice_vctr(ji,jj) = e_sat_ice_sclr( pTa(ji,jj) )
         END DO
      END DO
   END FUNCTION e_sat_ice_vctr
   !!
   FUNCTION de_sat_dt_ice_sclr(pTa)
      !!---------------------------------------------------------------------------------
      !! d [ e_sat_ice ] / dT   (derivative / temperature)
      !! Analytical exact formulation: double checked!!!
      !!  => DOUBLE-check possible / finite-difference version with "./bin/test_phymbl.x"
      !!---------------------------------------------------------------------------------
      REAL(wp)             :: de_sat_dt_ice_sclr !:  [Pa/K]
      REAL(wp), INTENT(in) :: pTa
      !!
      REAL(wp) :: zta, zde
      !!---------------------------------------------------------------------------------
      zta = MAX( pTa , 180._wp )   ! absolute air temp., prevents fpe0 errors dute to unrealistically low values over masked regions...
      !!
      zde = -(rAg_i*rtt0)/(zta*zta) - rBg_i/(zta*LOG(10._wp)) - rCg_i/rtt0
      !!
      de_sat_dt_ice_sclr = LOG(10._wp) * zde * e_sat_ice_sclr(zta)
   END FUNCTION de_sat_dt_ice_sclr
   !!
   FUNCTION de_sat_dt_ice_vctr(pTa)
      !! Same as "e_sat" but over ice rather than water!
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pTa
      REAL(wp), DIMENSION(SIZE(pTa,1),SIZE(pTa,2)) :: de_sat_dt_ice_vctr !: vapour pressure at saturation in presence of ice [Pa]
      INTEGER  :: ji, jj
      !!----------------------------------------------------------------------------------
      DO jj = 1, SIZE(pTa,2)
         DO ji = 1, SIZE(pTa,1)
            de_sat_dt_ice_vctr(ji,jj) = de_sat_dt_ice_sclr( pTa(ji,jj) )
         END DO
      END DO
   END FUNCTION de_sat_dt_ice_vctr



   !===============================================================================================

   !===============================================================================================
   FUNCTION q_sat_sclr( pTa, pslp,  l_ice )
      !!---------------------------------------------------------------------------------
      !!                           ***  FUNCTION q_sat_sclr  ***
      !!
      !! ** Purpose : Conputes specific humidity of air at saturation
      !!
      !! ** Author: L. Brodeau, june 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      REAL(wp) :: q_sat_sclr
      REAL(wp), INTENT(in) :: pTa  !: absolute temperature of air [K]
      REAL(wp), INTENT(in) :: pslp  !: atmospheric pressure        [Pa]
      LOGICAL,  INTENT(in), OPTIONAL :: l_ice  !: we are above ice
      REAL(wp) :: ze_s
      LOGICAL  :: lice
      !!----------------------------------------------------------------------------------
      lice = .FALSE.
      IF( PRESENT(l_ice) ) lice = l_ice
      IF( lice ) THEN
         ze_s = e_sat_ice( pTa )
      ELSE
         ze_s = e_sat( pTa ) ! Vapour pressure at saturation (Goff) :
      END IF
      q_sat_sclr = reps0*ze_s/(pslp - (1._wp - reps0)*ze_s)
   END FUNCTION q_sat_sclr
   !!
   FUNCTION q_sat_vctr( pTa, pslp,  l_ice )
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pTa  !: absolute temperature of air [K]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pslp  !: atmospheric pressure        [Pa]
      LOGICAL,  INTENT(in), OPTIONAL :: l_ice  !: we are above ice
      REAL(wp), DIMENSION(SIZE(pTa,1),SIZE(pTa,2)) :: q_sat_vctr
      LOGICAL  :: lice
      INTEGER  :: ji, jj
      !!----------------------------------------------------------------------------------
      lice = .FALSE.
      IF( PRESENT(l_ice) ) lice = l_ice
      DO jj = 1, SIZE(pTa,2)
         DO ji = 1, SIZE(pTa,1)
            q_sat_vctr(ji,jj) = q_sat_sclr( pTa(ji,jj) , pslp(ji,jj), l_ice=lice )
         END DO
      END DO
   END FUNCTION q_sat_vctr
   !===============================================================================================


   !===============================================================================================
   FUNCTION dq_sat_dt_ice_sclr( pTa, pslp )
      !!---------------------------------------------------------------------------------
      !!     ***  FUNCTION dq_sat_dt_ice_sclr  ***
      !!    => d [ q_sat_ice(T) ] / dT
      !! Analytical exact formulation: double checked!!!
      !!  => DOUBLE-check possible / finite-difference version with "./bin/test_phymbl.x"
      !!----------------------------------------------------------------------------------
      REAL(wp) :: dq_sat_dt_ice_sclr
      REAL(wp), INTENT(in) :: pTa  !: absolute temperature of air [K]
      REAL(wp), INTENT(in) :: pslp  !: atmospheric pressure        [Pa]
      REAL(wp) :: ze_s, zde_s_dt, ztmp
      !!----------------------------------------------------------------------------------
      ze_s     =  e_sat_ice_sclr( pTa ) ! Vapour pressure at saturation  in presence of ice (Goff)
      zde_s_dt = de_sat_dt_ice(   pTa )
      !
      ztmp = (reps0 - 1._wp)*ze_s + pslp
      !
      dq_sat_dt_ice_sclr = reps0*pslp*zde_s_dt / ( ztmp*ztmp )
      !
   END FUNCTION dq_sat_dt_ice_sclr
   !!
   FUNCTION dq_sat_dt_ice_vctr( pTa, pslp )
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pTa  !: absolute temperature of air [K]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pslp  !: atmospheric pressure        [Pa]
      REAL(wp), DIMENSION(SIZE(pTa,1),SIZE(pTa,2)) :: dq_sat_dt_ice_vctr
      INTEGER  :: ji, jj
      !!----------------------------------------------------------------------------------
      DO jj = 1, SIZE(pTa,2)
         DO ji = 1, SIZE(pTa,1)
            dq_sat_dt_ice_vctr(ji,jj) = dq_sat_dt_ice_sclr( pTa(ji,jj) , pslp(ji,jj) )
         END DO
      END DO
   END FUNCTION dq_sat_dt_ice_vctr
   !===============================================================================================


   !===============================================================================================
   FUNCTION q_air_rh(prha, pTa, pslp)
      !!----------------------------------------------------------------------------------
      !! Specific humidity of air out of Relative Humidity
      !!
      !! ** Author: L. Brodeau, june 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      REAL(wp), DIMENSION(:,:), INTENT(in) :: prha        !: relative humidity       [%]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pTa         !: absolute air temperature [K]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pslp        !: atmospheric pressure    [Pa]
      REAL(wp), DIMENSION(SIZE(pTa,1),SIZE(pTa,2))             :: q_air_rh
      !
      INTEGER  ::   ji, jj      ! dummy loop indices
      REAL(wp) ::   ze      ! local scalar
      !!----------------------------------------------------------------------------------
      !
      DO jj = 1, SIZE(pTa,2)
         DO ji = 1, SIZE(pTa,1)
            ze = 0.01_wp*prha(ji,jj)*e_sat_sclr(pTa(ji,jj))
            q_air_rh(ji,jj) = ze*reps0/MAX( pslp(ji,jj) - (1. - reps0)*ze , 1._wp )
         END DO
      END DO
      !
   END FUNCTION q_air_rh




   FUNCTION q_air_dp(da, slp)
      !!
      !! Air specific humidity from dew point temperature
      REAL(wp), DIMENSION(:,:), INTENT(in) :: da   !: dew-point temperature   [K]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: slp  !: atmospheric pressure    [Pa]
      REAL(wp), DIMENSION(SIZE(da,1),SIZE(da,2)) :: q_air_dp  !: kg/kg
      !!
      q_air_dp = MAX( e_sat(da) , 0._wp ) ! q_air_dp is e_sat !!!
      q_air_dp = q_air_dp*reps0/MAX( slp - (1. - reps0)*q_air_dp, 1._wp )  ! MAX() are solely here to prevent NaN
      !!                                                                   ! over masked regions with silly values
   END FUNCTION q_air_dp







   FUNCTION rho_air_adv(pTa, pqa, pslp)
      !!
      !! Advanced version, using TRUE virtual temperature
      !!
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pTa  !: absolute air temperature in [K]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pqa  !: air spec. hum. [kg/kg]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pslp !: atm. pressure in       [Pa]
      REAL(wp), DIMENSION(SIZE(pTa,1),SIZE(pTa,2)) :: rho_air_adv      !: density of air [kg/m^3]
      !!
      ! " pTa/(1. - e_air(pqa, pslp)/pslp*(1. - reps0)) " is virtual absolute temperature !
      rho_air_adv = pslp / ( R_dry * pTa/(1. - e_air(pqa, pslp)/pslp*(1. - reps0)) )
      !!
   END FUNCTION rho_air_adv








   FUNCTION q_sat_crude(pts, prhoa)
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pts  !: sea surface temperature  [K]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: prhoa  !: air density         [kg/m^3]
      REAL(wp), DIMENSION(SIZE(pts,1),SIZE(pts,2))             :: q_sat_crude
      q_sat_crude = 640380._wp/prhoa * exp(-5107.4_wp/pts)

   END FUNCTION q_sat_crude







   FUNCTION dry_static_energy( pz, pTa, pqa )
      !!----------------------------------------------------------------------------------
      !! Dry static energy "s" (Eq. 3.5 IFS doc)
      !!
      !! ** Author: L. Brodeau, June 2019 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      REAL(wp)                    , INTENT(in) ::   pz    ! height above the sea         [m]
      REAL(wp), DIMENSION(:,:), INTENT(in) ::   pTa   ! absolute air temp. at pz m   [K]
      REAL(wp), DIMENSION(:,:), INTENT(in) ::   pqa   ! air spec. hum. at pz m   [kg/kg]
      REAL(wp), DIMENSION(SIZE(pTa,1),SIZE(pTa,2))             ::   dry_static_energy
      !!----------------------------------------------------------------------------------
      dry_static_energy = grav*pz + cp_air(pqa)*pTa
   END FUNCTION dry_static_energy


   !===============================================================================================
   SUBROUTINE UPDATE_QNSOL_TAU_SCLR( pzu, pts, pqs, pThta, pqa, pust, ptst, pqst, pwnd, pUb, pslp, prlw, &
      &                              pQns, pTau,    Qlat )
      !!----------------------------------------------------------------------------------
      !! Purpose: returns the non-solar heat flux to the ocean aka "Qlat + Qsen + Qlw"
      !!          and the module of the wind stress => pTau = Tau
      !! ** Author: L. Brodeau, Sept. 2019 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      REAL(wp), INTENT(in)  :: pzu  ! height above the sea-level where all this takes place (normally 10m)
      REAL(wp), INTENT(in)  :: pts  ! water temperature at the air-sea interface [K]
      REAL(wp), INTENT(in)  :: pqs  ! satur. spec. hum. at T=pts   [kg/kg]
      REAL(wp), INTENT(in)  :: pThta ! potential air temperature at z=pzu [K]
      REAL(wp), INTENT(in)  :: pqa  ! specific humidity at z=pzu [kg/kg]
      REAL(wp), INTENT(in)  :: pust ! u*
      REAL(wp), INTENT(in)  :: ptst ! t*
      REAL(wp), INTENT(in)  :: pqst ! q*
      REAL(wp), INTENT(in)  :: pwnd ! wind speed module at z=pzu [m/s]
      REAL(wp), INTENT(in)  :: pUb  ! bulk wind speed at z=pzu (inc. pot. effect of gustiness etc) [m/s]
      REAL(wp), INTENT(in)  :: pslp ! sea-level atmospheric pressure [Pa]
      REAL(wp), INTENT(in)  :: prlw ! downwelling longwave radiative flux [W/m^2]
      !
      REAL(wp), INTENT(out) :: pQns ! non-solar heat flux to the ocean aka "Qlat + Qsen + Qlw" [W/m^2]]
      REAL(wp), INTENT(out) :: pTau ! module of the wind stress [N/m^2]
      !
      REAL(wp), OPTIONAL, INTENT(out) :: Qlat
      !
      REAL(wp) :: zdt, zdq, zCd, zCh, zCe, zz0, zQlat, zQsen, zQlw
      !!----------------------------------------------------------------------------------
      zdt = pThta - pts ;  zdt = SIGN( MAX(ABS(zdt),1.E-6_wp), zdt )
      zdq = pqa - pqs ;  zdq = SIGN( MAX(ABS(zdq),1.E-9_wp), zdq )
      zz0 = pust/pUb
      zCd = zz0*zz0
      zCh = zz0*ptst/zdt
      zCe = zz0*pqst/zdq

      CALL BULK_FORMULA_SCLR( pzu, pts, pqs, pThta, pqa, zCd, zCh, zCe, &
         &                    pwnd, pUb, pslp,                         &
         &                    pTau, zQsen, zQlat )

      zQlw = qlw_net_sclr( prlw, pts ) ! Net longwave flux

      pQns = zQlat + zQsen + zQlw

      IF( PRESENT(Qlat) ) Qlat = zQlat

   END SUBROUTINE UPDATE_QNSOL_TAU_SCLR
   !!
   SUBROUTINE UPDATE_QNSOL_TAU_VCTR( pzu, pts, pqs, pThta, pqa, pust, ptst, pqst, pwnd, pUb, pslp, prlw, &
      &                              pQns, pTau,    Qlat)
      !!----------------------------------------------------------------------------------
      !! Purpose: returns the non-solar heat flux to the ocean aka "Qlat + Qsen + Qlw"
      !!          and the module of the wind stress => pTau = Tau
      !! ** Author: L. Brodeau, Sept. 2019 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      REAL(wp),                     INTENT(in)  :: pzu  ! height above the sea-level where all this takes place (normally 10m)
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pts  ! water temperature at the air-sea interface [K]
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pqs  ! satur. spec. hum. at T=pts   [kg/kg]
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pThta  ! potential air temperature at z=pzu [K]
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pqa  ! specific humidity at z=pzu [kg/kg]
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pust ! u*
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: ptst ! t*
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pqst ! q*
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pwnd ! wind speed module at z=pzu [m/s]
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pUb  ! bulk wind speed at z=pzu (inc. pot. effect of gustiness etc) [m/s]
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pslp ! sea-level atmospheric pressure [Pa]
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: prlw ! downwelling longwave radiative flux [W/m^2]
      !
      REAL(wp), DIMENSION(:,:), INTENT(out) :: pQns ! non-solar heat flux to the ocean aka "Qlat + Qsen + Qlw" [W/m^2]]
      REAL(wp), DIMENSION(:,:), INTENT(out) :: pTau ! module of the wind stress [N/m^2]
      !
      REAL(wp), DIMENSION(:,:), OPTIONAL, INTENT(out) :: Qlat
      !
      REAL(wp) :: zQlat
      INTEGER  ::   ji, jj     ! dummy loop indices
      LOGICAL  :: lrQlat=.false.
      !!----------------------------------------------------------------------------------
      lrQlat = PRESENT(Qlat)
      DO jj = 1, SIZE(pts,2)
         DO ji = 1, SIZE(pts,1)
            CALL UPDATE_QNSOL_TAU_SCLR( pzu, pts(ji,jj),  pqs(ji,jj),  pThta(ji,jj), pqa(ji,jj),  &
               &                            pust(ji,jj), ptst(ji,jj), pqst(ji,jj), pwnd(ji,jj), &
               &                             pUb(ji,jj),  pslp(ji,jj), prlw(ji,jj),              &
               &                            pQns(ji,jj), pTau(ji,jj),              Qlat=zQlat   )
            IF( lrQlat ) Qlat(ji,jj) = zQlat
         END DO
      END DO
   END SUBROUTINE UPDATE_QNSOL_TAU_VCTR
   !===============================================================================================


   !===============================================================================================
   SUBROUTINE BULK_FORMULA_SCLR( pzu, pts, pqs, pThta, pqa, &
      &                          pCd, pCh, pCe,            &
      &                          pwnd, pUb, pslp,          &
      &                          pTau, pQsen, pQlat,       &
      &                          pEvap, prhoa, l_ice      )
      !!----------------------------------------------------------------------------------
      REAL(wp),                     INTENT(in)  :: pzu  ! height above the sea-level where all this takes place (normally 10m)
      REAL(wp), INTENT(in)  :: pts  ! water temperature at the air-sea interface [K]
      REAL(wp), INTENT(in)  :: pqs  ! satur. spec. hum. at T=pts   [kg/kg]
      REAL(wp), INTENT(in)  :: pThta  ! potential air temperature at z=pzu [K]
      REAL(wp), INTENT(in)  :: pqa  ! specific humidity at z=pzu [kg/kg]
      REAL(wp), INTENT(in)  :: pCd
      REAL(wp), INTENT(in)  :: pCh
      REAL(wp), INTENT(in)  :: pCe
      REAL(wp), INTENT(in)  :: pwnd ! wind speed module at z=pzu [m/s]
      REAL(wp), INTENT(in)  :: pUb  ! bulk wind speed at z=pzu (inc. pot. effect of gustiness etc) [m/s]
      REAL(wp), INTENT(in)  :: pslp ! sea-level atmospheric pressure [Pa]
      !!
      REAL(wp), INTENT(out) :: pTau  ! module of the wind stress [N/m^2]
      REAL(wp), INTENT(out) :: pQsen !  [W/m^2]
      REAL(wp), INTENT(out) :: pQlat !  [W/m^2]
      !!
      REAL(wp), INTENT(out), OPTIONAL :: pEvap ! Evaporation [kg/m^2/s] (usually <0, as ocean loses water!)
      REAL(wp), INTENT(out), OPTIONAL :: prhoa ! Air density at z=pzu [kg/m^3]
      LOGICAL,  INTENT(in),  OPTIONAL :: l_ice  !: we are above ice
      !!
      REAL(wp) :: zta, zrho, zUrho, zevap
      LOGICAL  :: lice
      !!----------------------------------------------------------------------------------
      lice = .FALSE.
      IF( PRESENT(l_ice) ) lice = l_ice

      !! Need zta, absolute temperature at pzu (formula to estimate rho_air needs absolute temperature, not the potential temperature "pThta")
      zta  = pThta - rgamma_dry*pzu   ! Absolute temp. is slightly colder...
      zrho = rho_air(zta, pqa, pslp)
      zrho = rho_air(zta, pqa, pslp-zrho*grav*pzu) ! taking into account that we are pzu m above the sea level where SLP is given!

      zUrho = pUb*MAX(zrho, 1._wp)     ! rho*U10

      pTau = zUrho * pCd * pwnd ! Wind stress module ( `pwnd` here because `pUb` already in `zUrho`

      zevap = zUrho * pCe * (pqa - pqs)
      pQsen = zUrho * pCh * (pThta - pts) * cp_air(pqa)

      IF( lice) THEN
         pQlat =      rLsub * zevap
         IF( PRESENT(pEvap) ) pEvap = MIN( zevap , 0._wp )
      ELSE
         pQlat = L_vap(pts) * zevap
         IF( PRESENT(pEvap) ) pEvap = zevap
      END IF

      IF( PRESENT(prhoa) ) prhoa = zrho

   END SUBROUTINE BULK_FORMULA_SCLR
   !!
   SUBROUTINE BULK_FORMULA_VCTR( pzu, pts, pqs, pThta, pqa, &
      &                          pCd, pCh, pCe,           &
      &                          pwnd, pUb, pslp,         &
      &                          pTau, pQsen, pQlat,      &
      &                          pEvap, prhoa, l_ice )
      !!----------------------------------------------------------------------------------
      REAL(wp),                     INTENT(in)  :: pzu  ! height above the sea-level where all this takes place (normally 10m)
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pts  ! water temperature at the air-sea interface [K]
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pqs  ! satur. spec. hum. at T=pts   [kg/kg]
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pThta  ! potential air temperature at z=pzu [K]
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pqa  ! specific humidity at z=pzu [kg/kg]
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pCd
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pCh
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pCe
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pwnd ! wind speed module at z=pzu [m/s]
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pUb  ! bulk wind speed at z=pzu (inc. pot. effect of gustiness etc) [m/s]
      REAL(wp), DIMENSION(:,:), INTENT(in)  :: pslp ! sea-level atmospheric pressure [Pa]
      !!
      REAL(wp), DIMENSION(:,:), INTENT(out) :: pTau  ! module of the wind stress [N/m^2]
      REAL(wp), DIMENSION(:,:), INTENT(out) :: pQsen !  [W/m^2]
      REAL(wp), DIMENSION(:,:), INTENT(out) :: pQlat !  [W/m^2]
      !!
      REAL(wp), DIMENSION(:,:), INTENT(out), OPTIONAL :: pEvap ! Evaporation [kg/m^2/s]
      REAL(wp), DIMENSION(:,:), INTENT(out), OPTIONAL :: prhoa ! Air density at z=pzu [kg/m^3]
      LOGICAL,  INTENT(in),  OPTIONAL :: l_ice  !: we are above ice
      !!
      REAL(wp) :: zevap, zrho
      LOGICAL  :: lice=.FALSE., lrE=.FALSE., lrR=.FALSE.
      INTEGER  :: ji, jj
      CHARACTER(len=256) :: cmsg
      !!----------------------------------------------------------------------------------
      lice = PRESENT(l_ice)
      lrE  = PRESENT(pEvap)
      lrR  = PRESENT(prhoa)
      DO jj = 1, SIZE(pts,2)
         DO ji = 1, SIZE(pts,1)
            CALL BULK_FORMULA_SCLR( pzu, pts(ji,jj), pqs(ji,jj), pThta(ji,jj), pqa(ji,jj), &
               &                    pCd(ji,jj), pCh(ji,jj), pCe(ji,jj),                  &
               &                    pwnd(ji,jj), pUb(ji,jj), pslp(ji,jj),                &
               &                    pTau(ji,jj), pQsen(ji,jj), pQlat(ji,jj),             &
               &                    pEvap=zevap, prhoa=zrho, l_ice=lice )
            IF( lrE ) pEvap(ji,jj) = zevap
            IF( lrR ) prhoa(ji,jj) = zrho
            
            !!LOLO/alpha: sanity check on computed fluxes:
            IF( pTau(ji,jj) > ref_tau_max ) THEN
               WRITE(cmsg,'(" => ",f8.2," N/m^2 ! At ji, jj = ", i4.4,", ",i4.4)') pTau(ji,jj), ji, jj
               CALL ctl_stop( 'BULK_FORMULA_VCTR()@mod_phymbl: wind stress too strong!', cmsg )
            END IF
            !IF( pwnd(ji,jj) < 1.E-3 ) THEN
            !   WRITE(cmsg,'(" => ",f8.2," m/s ! At ji, jj = ", i4.4,", ",i4.4)') pwnd(ji,jj), ji, jj
            !   CALL ctl_stop( 'BULK_FORMULA_VCTR()@mod_phymbl: scalar wind speed to close to 0!', cmsg )
            !END IF
            
         END DO
      END DO
   END SUBROUTINE BULK_FORMULA_VCTR
   !===============================================================================================



   !===============================================================================================
   FUNCTION alpha_sw_sclr( psst )
      !!---------------------------------------------------------------------------------
      !!                           ***  FUNCTION alpha_sw_sclr  ***
      !!
      !! ** Purpose : ROUGH estimate of the thermal expansion coefficient of sea-water at the surface (P =~ 1010 hpa)
      !!
      !! ** Author: L. Brodeau, june 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      REAL(wp), INTENT(in) ::   psst   ! sea-water temperature                   [K]
      REAL(wp)             ::   alpha_sw_sclr   ! thermal expansion coefficient of sea-water [1/K]
      !!----------------------------------------------------------------------------------
      alpha_sw_sclr = 2.1e-5_wp * MAX( psst - rt0 + 3.2_wp , 0._wp )**0.79_wp
      !!
   END FUNCTION alpha_sw_sclr
   !!
   FUNCTION alpha_sw_vctr( psst )
      REAL(wp), DIMENSION(:,:), INTENT(in) ::   psst   ! water temperature                [K]
      REAL(wp), DIMENSION(SIZE(psst,1),SIZE(psst,2))             ::   alpha_sw_vctr   ! thermal expansion coefficient of sea-water [1/K]
      alpha_sw_vctr = 2.1e-5_wp * MAX( psst(:,:) - rt0 + 3.2_wp , 0._wp )**0.79_wp
   END FUNCTION alpha_sw_vctr
   !===============================================================================================


   !===============================================================================================
   FUNCTION qlw_net_sclr( pdwlw, pts,  l_ice )
      !!---------------------------------------------------------------------------------
      !!                           ***  FUNCTION qlw_net_sclr  ***
      !!
      !! ** Purpose : Estimate of the net longwave flux at the surface
      !!----------------------------------------------------------------------------------
      REAL(wp) :: qlw_net_sclr
      REAL(wp), INTENT(in) :: pdwlw !: downwelling longwave (aka infrared, aka thermal) radiation [W/m^2]
      REAL(wp), INTENT(in) :: pts   !: surface temperature [K]
      LOGICAL,  INTENT(in), OPTIONAL :: l_ice  !: we are above ice
      REAL(wp) :: zemiss, zt2
      LOGICAL  :: lice
      !!----------------------------------------------------------------------------------
      lice = .FALSE.
      IF( PRESENT(l_ice) ) lice = l_ice
      IF( lice ) THEN
         zemiss = emiss_i
      ELSE
         zemiss = emiss_w
      END IF
      zt2 = pts*pts
      qlw_net_sclr = zemiss*( pdwlw - stefan*zt2*zt2)  ! zemiss used both as the IR albedo and IR emissivity...
      !!
   END FUNCTION qlw_net_sclr
   !!
   FUNCTION qlw_net_vctr( pdwlw, pts,  l_ice )
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pdwlw !: downwelling longwave (aka infrared, aka thermal) radiation [W/m^2]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pts   !: surface temperature [K]
      REAL(wp), DIMENSION(SIZE(pts,1),SIZE(pts,2)) :: qlw_net_vctr
      LOGICAL,  INTENT(in), OPTIONAL :: l_ice  !: we are above ice
      LOGICAL  :: lice
      INTEGER  :: ji, jj
      lice = .FALSE.
      IF( PRESENT(l_ice) ) lice = l_ice
      DO jj = 1, SIZE(pts,2)
         DO ji = 1, SIZE(pts,1)
            qlw_net_vctr(ji,jj) = qlw_net_sclr( pdwlw(ji,jj) , pts(ji,jj), l_ice=lice )
         END DO
      END DO
   END FUNCTION qlw_net_vctr
   !===============================================================================================


   !===============================================================================================
   FUNCTION z0_from_Cd_sclr( pzu, pCd,  ppsi )
      REAL(wp)                       :: z0_from_Cd_sclr        !: roughness length [m]
      REAL(wp), INTENT(in)           :: pzu   !: reference height zu [m]
      REAL(wp), INTENT(in)           :: pCd   !: (neutral or non-neutral) drag coefficient []
      REAL(wp), INTENT(in), OPTIONAL :: ppsi !: "Psi_m(pzu/L)" stability correction profile for momentum []
      !!
      !! If pCd is the NEUTRAL-STABILITY drag coefficient then ppsi must be 0 or not given
      !! If pCd is the drag coefficient (in stable or unstable conditions) then pssi must be provided
      !!----------------------------------------------------------------------------------
      IF( PRESENT(ppsi) ) THEN
         !! Cd provided is the actual Cd (not the neutral-stability CdN) :
         z0_from_Cd_sclr = pzu * EXP( - ( vkarmn/SQRT(pCd) + ppsi ) ) !LB: ok, double-checked!
      ELSE
         !! Cd provided is the neutral-stability Cd, aka CdN :
         z0_from_Cd_sclr = pzu * EXP( - vkarmn/SQRT(pCd) )            !LB: ok, double-checked!
      END IF
      !!
   END FUNCTION z0_from_Cd_sclr

   FUNCTION z0_from_Cd_vctr( pzu, pCd,  ppsi )
      REAL(wp)                    , INTENT(in) :: pzu   !: reference height zu [m]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pCd   !: (neutral or non-neutral) drag coefficient []
      REAL(wp), DIMENSION(:,:), INTENT(in), OPTIONAL :: ppsi !: "Psi_m(pzu/L)" stability correction profile for momentum []
      REAL(wp), DIMENSION(SIZE(pCd,1),SIZE(pCd,2)) :: z0_from_Cd_vctr        !: roughness length [m]
      !!----------------------------------------------------------------------------------
      IF( PRESENT(ppsi) ) THEN
         z0_from_Cd_vctr = pzu * EXP( - ( vkarmn/SQRT(pCd(:,:)) + ppsi(:,:) ) ) !LB: ok, double-checked!
      ELSE
         z0_from_Cd_vctr = pzu * EXP( - vkarmn/SQRT(pCd(:,:)) )            !LB: ok, double-checked!
      END IF
      !!
   END FUNCTION z0_from_Cd_vctr
   !===============================================================================================


   !===============================================================================================
   FUNCTION z0_from_ustar_sclr( pzu, pus, puzu )
      !!----------------------------------------------------------------------------------
      REAL(wp)             :: z0_from_ustar_sclr    !: roughness length    [m]
      REAL(wp), INTENT(in) :: pzu  !: reference height zu [m]
      REAL(wp), INTENT(in) :: pus  !: friction velocity   [m/s]
      REAL(wp), INTENT(in) :: puzu !: wind speed at z=pzu [m/s]
      !!----------------------------------------------------------------------------------
      z0_from_ustar_sclr = pzu * EXP( -  vkarmn*puzu/pus )
      !!
   END FUNCTION z0_from_ustar_sclr
   !!
   FUNCTION z0_from_ustar_vctr( pzu, pus, puzu )
      !!----------------------------------------------------------------------------------
      REAL(wp)                    , INTENT(in) :: pzu  !: reference height zu [m]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pus  !: friction velocity   [m/s]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: puzu !: wind speed at z=pzu [m/s]
      REAL(wp), DIMENSION(SIZE(pus,1),SIZE(pus,2)) :: z0_from_ustar_vctr    !: roughness length    [m]
      !!----------------------------------------------------------------------------------
      z0_from_ustar_vctr = pzu * EXP( -  vkarmn*puzu(:,:)/pus(:,:) )
      !!
   END FUNCTION z0_from_ustar_vctr
   !===============================================================================================


   !===============================================================================================
   FUNCTION Cd_from_z0( pzu, pz0,  ppsi )
      REAL(wp)                    , INTENT(in) :: pzu   !: reference height zu [m]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pz0   !: roughness length [m]
      REAL(wp), DIMENSION(:,:), INTENT(in), OPTIONAL :: ppsi !: "Psi_m(pzu/L)" stability correction profile for momentum []
      REAL(wp), DIMENSION(SIZE(pz0,1),SIZE(pz0,2)) :: Cd_from_z0        !: (neutral or non-neutral) drag coefficient []
      !!
      !! If we want to return the NEUTRAL-STABILITY drag coefficient then ppsi must be 0 or not given
      !! If we want to return the stability-corrected Cd (i.e. in stable or unstable conditions) then pssi must be provided
      !!----------------------------------------------------------------------------------
      IF( PRESENT(ppsi) ) THEN
         !! The Cd we return is the actual Cd (not the neutral-stability CdN) :
         Cd_from_z0 = 1._wp / ( LOG( pzu / pz0(:,:) ) - ppsi(:,:) )
      ELSE
         !! The Cd we return is the neutral-stability Cd, aka CdN :
         Cd_from_z0 = 1._wp /   LOG( pzu / pz0(:,:) )
      END IF
      Cd_from_z0 = vkarmn2 * Cd_from_z0 * Cd_from_z0
      !!
   END FUNCTION Cd_from_z0
   !===============================================================================================


   !===============================================================================================
   FUNCTION f_m_louis_sclr( pzu, pRib, pCdn, pz0 )
      !!----------------------------------------------------------------------------------
      !!  Stability correction function for MOMENTUM
      !!                 Louis (1979)
      !!----------------------------------------------------------------------------------
      REAL(wp)             :: f_m_louis_sclr ! term "f_m" in Eq.(6) when option "Louis" rather than "Psi(zeta) is chosen, Lupkes & Gryanik (2015),
      REAL(wp), INTENT(in) :: pzu     ! reference height (height for pwnd)  [m]
      REAL(wp), INTENT(in) :: pRib    ! Bulk Richardson number
      REAL(wp), INTENT(in) :: pCdn    ! neutral drag coefficient
      REAL(wp), INTENT(in) :: pz0     ! roughness length                      [m]
      !!----------------------------------------------------------------------------------
      REAL(wp) :: ztu, zts, zstab
      !!----------------------------------------------------------------------------------
      zstab = 0.5 + SIGN(0.5_wp, pRib) ; ! Unstable (Ri<0) => zstab = 0 | Stable (Ri>0) => zstab = 1
      !
      ztu = pRib / ( 1._wp + 3._wp * rc2_louis * pCdn * SQRT( ABS( -pRib * ( pzu / pz0 + 1._wp) ) ) ) ! ABS is just here for when it's stable conditions and ztu is not used anyways
      zts = pRib / SQRT( ABS( 1._wp + pRib ) ) ! ABS is just here for when it's UNstable conditions and zts is not used anyways
      !
      f_m_louis_sclr = (1._wp - zstab) *         ( 1._wp - ram_louis * ztu )  &  ! Unstable Eq.(A6)
         &               +      zstab  * 1._wp / ( 1._wp + ram_louis * zts )     ! Stable   Eq.(A7)
      !!
   END FUNCTION f_m_louis_sclr
   !!
   FUNCTION f_m_louis_vctr( pzu, pRib, pCdn, pz0 )
      REAL(wp),                     INTENT(in) :: pzu
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pRib
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pCdn
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pz0
      REAL(wp), DIMENSION(SIZE(pz0,1),SIZE(pz0,2))             :: f_m_louis_vctr
      INTEGER  :: ji, jj
      DO jj = 1, SIZE(pz0,2)
         DO ji = 1, SIZE(pz0,1)
            f_m_louis_vctr(ji,jj) = f_m_louis_sclr( pzu, pRib(ji,jj), pCdn(ji,jj), pz0(ji,jj) )
         END DO
      END DO
   END FUNCTION f_m_louis_vctr
   !===============================================================================================

   !===============================================================================================
   FUNCTION f_h_louis_sclr( pzu, pRib, pChn, pz0 )
      !!----------------------------------------------------------------------------------
      !!  Stability correction function for HEAT
      !!                 Louis (1979)
      !!----------------------------------------------------------------------------------
      REAL(wp)             :: f_h_louis_sclr ! term "f_h" in Eq.(6) when option "Louis" rather than "Psi(zeta) is chosen, Lupkes & Gryanik (2015),
      REAL(wp), INTENT(in) :: pzu     ! reference height (height for pwnd)  [m]
      REAL(wp), INTENT(in) :: pRib    ! Bulk Richardson number
      REAL(wp), INTENT(in) :: pChn    ! neutral heat transfer coefficient
      REAL(wp), INTENT(in) :: pz0     ! roughness length                      [m]
      !!----------------------------------------------------------------------------------
      REAL(wp) :: ztu, zts, zstab
      !!----------------------------------------------------------------------------------
      zstab = 0.5 + SIGN(0.5_wp, pRib) ; ! Unstable (Ri<0) => zstab = 0 | Stable (Ri>0) => zstab = 1
      !
      ztu = pRib / ( 1._wp + 3._wp * rc2_louis * pChn * SQRT( ABS(-pRib * ( pzu / pz0 + 1._wp) ) ) )
      zts = pRib / SQRT( ABS( 1._wp + pRib ) )
      !
      f_h_louis_sclr = (1._wp - zstab) *         ( 1._wp - rah_louis * ztu )  &  ! Unstable Eq.(A6)
         &              +       zstab  * 1._wp / ( 1._wp + rah_louis * zts )     ! Stable   Eq.(A7)  !LOLO: in paper it's "ram_louis" and not "rah_louis" typo or what????
      !!
   END FUNCTION f_h_louis_sclr
   !!
   FUNCTION f_h_louis_vctr( pzu, pRib, pChn, pz0 )
      REAL(wp),                     INTENT(in) :: pzu
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pRib
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pChn
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pz0
      REAL(wp), DIMENSION(SIZE(pz0,1),SIZE(pz0,2))             :: f_h_louis_vctr
      INTEGER  :: ji, jj
      DO jj = 1, SIZE(pz0,2)
         DO ji = 1, SIZE(pz0,1)
            f_h_louis_vctr(ji,jj) = f_h_louis_sclr( pzu, pRib(ji,jj), pChn(ji,jj), pz0(ji,jj) )
         END DO
      END DO
   END FUNCTION f_h_louis_vctr
   !===============================================================================================


   !===============================================================================================
   FUNCTION UN10_from_ustar( pzu, pUzu, pus, ppsi )
      !!----------------------------------------------------------------------------------
      !!  Provides the neutral-stability wind speed at 10 m
      !!----------------------------------------------------------------------------------
      REAL(wp),                     INTENT(in) :: pzu   !: measurement heigh of wind speed   [m]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pUzu  !: bulk wind speed at height pzu m   [m/s]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pus   !: friction velocity                 [m/s]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: ppsi !: "Psi_m(pzu/L)" stability correction profile for momentum []
      REAL(wp), DIMENSION(SIZE(pUzu,1),SIZE(pUzu,2))             :: UN10_from_ustar  !: neutral stability wind speed at 10m [m/s]
      !!----------------------------------------------------------------------------------
      UN10_from_ustar(:,:) = pUzu(:,:) - pus(:,:)/vkarmn * ( LOG(pzu/10._wp) - ppsi(:,:) )
      !!
   END FUNCTION UN10_from_ustar
   !===============================================================================================


   !===============================================================================================
   FUNCTION UN10_from_CDN( pzu, pUb, pCdn, ppsi )
      !!----------------------------------------------------------------------------------
      !!  Provides the neutral-stability wind speed at 10 m
      !!----------------------------------------------------------------------------------
      REAL(wp),                     INTENT(in) :: pzu  !: measurement heigh of bulk wind speed
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pUb  !: bulk wind speed at height pzu m   [m/s]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pCdn !: neutral-stability drag coefficient
      REAL(wp), DIMENSION(:,:), INTENT(in) :: ppsi !: "Psi_m(pzu/L)" stability correction profile for momentum []
      REAL(wp), DIMENSION(SIZE(pUb,1),SIZE(pUb,2))             :: UN10_from_CDN  !: [m/s]
      !!----------------------------------------------------------------------------------
      UN10_from_CDN(:,:) = pUb / ( 1._wp + SQRT(pCdn(:,:))/vkarmn * (LOG(pzu/10._wp) - ppsi(:,:)) )
      !!
   END FUNCTION UN10_from_CDN
   !===============================================================================================


   !===============================================================================================
   FUNCTION UN10_from_CD_sclr( pzu, pUb, pCd, ppsi )
      !!----------------------------------------------------------------------------------
      !!  Provides the neutral-stability wind speed at 10 m
      !!----------------------------------------------------------------------------------
      REAL(wp)             :: UN10_from_CD_sclr  !: [m/s]
      REAL(wp),                     INTENT(in) :: pzu  !: measurement heigh of bulk wind speed
      REAL(wp), INTENT(in) :: pUb  !: bulk wind speed at height pzu m   [m/s]
      REAL(wp), INTENT(in) :: pCd  !: drag coefficient
      REAL(wp), INTENT(in) :: ppsi !: "Psi_m(pzu/L)" stability correction profile for momentum []
      !!----------------------------------------------------------------------------------
      !! Reminder: UN10 = u*/vkarmn * log(10/z0)
      !!     and: u* = sqrt(Cd) * Ub
      !!                                  u*/vkarmn * log(   10   /       z0    )
      UN10_from_CD_sclr = SQRT(pCd)*pUb/vkarmn * LOG( 10._wp / z0_from_Cd_sclr( pzu, pCd, ppsi=ppsi ) )
      !!
   END FUNCTION UN10_from_CD_sclr
   !!
   FUNCTION UN10_from_CD_vctr( pzu, pUb, pCd, ppsi )
      REAL(wp),                     INTENT(in) :: pzu  !: measurement heigh of bulk wind speed
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pUb  !: bulk wind speed at height pzu m   [m/s]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pCd  !: drag coefficient
      REAL(wp), DIMENSION(:,:), INTENT(in) :: ppsi !: "Psi_m(pzu/L)" stability correction profile for momentum []
      REAL(wp), DIMENSION(SIZE(pUb,1),SIZE(pUb,2))             :: UN10_from_CD_vctr  !: [m/s]
      !!----------------------------------------------------------------------------------
      UN10_from_CD_vctr(:,:) = SQRT(pCd(:,:))*pUb/vkarmn * LOG( 10._wp / z0_from_Cd_vctr( pzu, pCd(:,:), ppsi=ppsi(:,:) ) )
      !!
   END FUNCTION UN10_from_CD_vctr
   !===============================================================================================


   !===============================================================================================
   !FUNCTION Re_rough_tq_LKB( iflag, pRer )
   !   !!---------------------------------------------------------------------------------
   !   !!       ***  FUNCTION Re_rough_tq_LKB  ***
   !   !!
   !   !! ** Purpose : returns the "temperature/humidity roughness Reynolds number"
   !   !!              * iflag==1 => temperature => returns: [z_{0t} u*]/Nu_{air}
   !   !!              * iflag==2 => humidity    => returns: [z_{0q} u*]/Nu_{air}
   !   !!              from roughness reynold number "pRer" (i.e. [z_0 u*]/Nu_{air})
   !   !!              between 0 and 1000. Out of range "pRer" indicated by prt=-999.
   !   !!
   !   !!              Based on Liu et al. (1979) JAS 36 1722-1723s
   !   !!
   !   !!              Note: this is what is used into COARE 2.5 to estimate z_{0t} and z_{0q}
   !   !!
   !   !! ** Author: L. Brodeau, April 2020 / AeroBulk (https://github.com/brodeau/aerobulk/)
   !   !!----------------------------------------------------------------------------------
   !   REAL(wp), DIMENSION(:,:)             :: Re_rough_tq_LKB
   !   INTEGER,                      INTENT(in) :: iflag     !: 1 => dealing with temperature; 2 => dealing with humidity
   !   REAL(wp), DIMENSION(:,:), INTENT(in) :: pRer      !: roughness Reynolds number  [z_0 u*]/Nu_{air}
   !   !-------------------------------------------------------------------
   !   ! Scalar Re_r relation from Liu et al.
   !   REAL(wp), DIMENSION(8,2), PARAMETER :: &
   !      & XA = (/ 0.177, 1.376, 1.026, 1.625, 4.661, 34.904, 1667.19, 5.88e5, &
   !      &         0.292, 1.808, 1.393, 1.956, 4.994, 30.709, 1448.68, 2.98e5  /)
   !   !!
   !   REAL(wp), DIMENSION(8,2), PARAMETER :: &
   !      & XB = (/ 0., 0.929, -0.599, -1.018, -1.475, -2.067, -2.907, -3.935, &
   !      &         0., 0.826, -0.528, -0.870, -1.297, -1.845, -2.682, -3.616  /)
   !   !!
   !   REAL(wp), DIMENSION(0:8),   PARAMETER :: &
   !      & XRAN = (/ 0., 0.11, 0.825, 3.0, 10.0, 30.0, 100., 300., 1000. /)
   !   !-------------------------------------------------------------------
   !   ! Scalar Re_r relation from Moana Wave data.
   !   !
   !   !      real*8 A(9,2),B(9,2),RAN(9),pRer,prt
   !   !      integer iflag
   !   !      DATA A/0.177,2.7e3,1.03,1.026,1.625,4.661,34.904,1667.19,5.88E5,
   !   !     &       0.292,3.7e3,1.4,1.393,1.956,4.994,30.709,1448.68,2.98E5/
   !   !      DATA B/0.,4.28,0,-0.599,-1.018,-1.475,-2.067,-2.907,-3.935,
   !   !     &       0.,4.28,0,-0.528,-0.870,-1.297,-1.845,-2.682,-3.616/
   !   !      DATA RAN/0.11,.16,1.00,3.0,10.0,30.0,100.,300.,1000./
   !   !-------------------------------------------------------------------
   !   LOGICAL  :: lfound=.FALSE.
   !   REAL(wp) :: zrr
   !   INTEGER  :: ji, jj, jm
   !   !!----------------------------------------------------------------------------------
   !   Re_rough_tq_LKB(:,:) = -999._wp
   !   !
   !   DO jj = 1, SIZE(ZZ,2)
   !      DO ji = 1, SIZE(ZZ,1)
   !         zrr    = pRer(ji,jj)
   !         lfound = .FALSE.
   !         IF( (zrr > 0.).AND.(zrr < 1000.) ) THEN
   !            jm = 0
   !            DO WHILE ( .NOT. lfound )
   !               jm = jm + 1
   !               lfound = ( (zrr > XRAN(jm-1)) .AND. (zrr <= XRAN(jm)) )
   !            END DO
   !            Re_rough_tq_LKB(ji,jj) = XA(jm,iflag) * zrr**XB(jm,iflag)
   !         END IF
   !      END DO
   !   END DO
   !   !!
   !END FUNCTION Re_rough_tq_LKB
   !===============================================================================================






   !===============================================================================================
   FUNCTION z0tq_LKB( iflag, pRer, pz0 )
      !!---------------------------------------------------------------------------------
      !!       ***  FUNCTION z0tq_LKB  ***
      !!
      !! ** Purpose : returns the "temperature/humidity roughness lengths"
      !!              * iflag==1 => temperature => returns: z_{0t}
      !!              * iflag==2 => humidity    => returns: z_{0q}
      !!              from roughness reynold number "pRer" (i.e. [z_0 u*]/Nu_{air})
      !!              between 0 and 1000. Out of range "pRer" indicated by prt=-999.
      !!              and roughness length (for momentum)
      !!
      !!              Based on Liu et al. (1979) JAS 36 1722-1723s
      !!
      !!              Note: this is what is used into COARE 2.5 to estimate z_{0t} and z_{0q}
      !!
      !! ** Author: L. Brodeau, April 2020 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      INTEGER,                      INTENT(in) :: iflag     !: 1 => dealing with temperature; 2 => dealing with humidity
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pRer      !: roughness Reynolds number  [z_0 u*]/Nu_{air}
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pz0       !: roughness length (for momentum) [m]
      REAL(wp), DIMENSION(SIZE(pRer,1),SIZE(pRer,2))             :: z0tq_LKB
      !-------------------------------------------------------------------
      ! Scalar Re_r relation from Liu et al.
      REAL(wp), DIMENSION(8,2), PARAMETER :: &
         & XA = RESHAPE ( (/ 0.177, 1.376, 1.026, 1.625, 4.661, 34.904, 1667.19, 5.88e5,  &
         &                   0.292, 1.808, 1.393, 1.956, 4.994, 30.709, 1448.68, 2.98e5 /), (/8,2/) )
      !!
      REAL(wp), DIMENSION(8,2), PARAMETER :: &
         & XB = RESHAPE ( (/ 0., 0.929, -0.599, -1.018, -1.475, -2.067, -2.907, -3.935,  &
         &                   0., 0.826, -0.528, -0.870, -1.297, -1.845, -2.682, -3.616 /), (/8,2/) )
      !!
      REAL(wp), DIMENSION(0:8),   PARAMETER :: &
         & XRAN = (/ 0., 0.11, 0.825, 3.0, 10.0, 30.0, 100., 300., 1000. /)
      !-------------------------------------------------------------------
      ! Scalar Re_r relation from Moana Wave data.
      !
      !      real*8 A(9,2),B(9,2),RAN(9),pRer,prt
      !      integer iflag
      !      DATA A/0.177,2.7e3,1.03,1.026,1.625,4.661,34.904,1667.19,5.88E5,
      !     &       0.292,3.7e3,1.4,1.393,1.956,4.994,30.709,1448.68,2.98E5/
      !      DATA B/0.,4.28,0,-0.599,-1.018,-1.475,-2.067,-2.907,-3.935,
      !     &       0.,4.28,0,-0.528,-0.870,-1.297,-1.845,-2.682,-3.616/
      !      DATA RAN/0.11,.16,1.00,3.0,10.0,30.0,100.,300.,1000./
      !-------------------------------------------------------------------
      LOGICAL  :: lfound=.FALSE.
      REAL(wp) :: zrr
      INTEGER  :: ji, jj, jm
      !!---------------------------------------------------------------------------------
      z0tq_LKB(:,:) = -999._wp
      !
      DO jj = 1, SIZE(pRer,2)
         DO ji = 1, SIZE(pRer,1)
            zrr    = pRer(ji,jj)
            lfound = .FALSE.
            IF( (zrr > 0.).AND.(zrr < 1000.) ) THEN
               jm = 0
               DO WHILE ( .NOT. lfound )
                  jm = jm + 1
                  lfound = ( (zrr > XRAN(jm-1)) .AND. (zrr <= XRAN(jm)) )
               END DO
               z0tq_LKB(ji,jj) = XA(jm,iflag)*zrr**XB(jm,iflag) * pz0(ji,jj)/zrr
            END IF
         END DO
      END DO
      z0tq_LKB(:,:) = MIN( MAX(ABS(z0tq_LKB(:,:)), 1.E-9) , 0.05_wp )
      !!
   END FUNCTION z0tq_LKB
   !===============================================================================================


   !===============================================================================================
   FUNCTION e_air(pqa, pslp)
      !!--------------------------------------------------------------------
      !!                  **** Function e_air ****
      !!
      !! Gives vapour pressure of air from pressure and specific humidity
      !!
      !!--------------------------------------------------------------------
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pqa      ! specific humidity of air       [kg/kg]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pslp     ! atmospheric pressure            [Pa]
      REAL(wp), DIMENSION(SIZE(pqa,1),SIZE(pqa,2))             :: e_air    !: vapour pressure at saturation  [Pa]
      !!
      INTEGER :: Ni, Nj
      REAL(wp), DIMENSION(:,:), ALLOCATABLE :: ee, e_old
      REAL(wp) :: zdiff
      Ni = SIZE(pqa,1)
      Nj = SIZE(pqa,2)
      ALLOCATE ( ee(Ni,Nj), e_old(Ni,Nj) )
      !
      zdiff  = 1._wp
      e_old = pqa*pslp/reps0
      !
      DO WHILE ( zdiff > repsilon )
         ee = pqa/reps0*(pslp - (1. - reps0)*e_old)
         zdiff  = SUM( ABS( ee - e_old) )
         e_old = ee
      END DO
      e_air = ee
      !
      DEALLOCATE ( ee, e_old )
      !!
   END FUNCTION e_air
   !===============================================================================================


   !===============================================================================================
   FUNCTION rh_air(pqa, pTa, pslp)
      !!----------------------------------------------------------------------------------
      !!                  **** Function e_air ****
      !!
      !! Gives relative humidity of air of air from spec. hum., temperature and pressure
      !!
      !!---------------------------------------------------------------------------------
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pqa     !: specific humidity of air      [kg/kg]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pTa     !: absolute air temperature               [K]
      REAL(wp), DIMENSION(:,:), INTENT(in) :: pslp    !: atmospheric pressure          [Pa]
      REAL(wp), DIMENSION(SIZE(pqa,1),SIZE(pqa,2))             :: rh_air  !: relative humidity [%]
      !!----------------------------------------------------------------------------------
      rh_air = e_sat(pTa)
      rh_air = 100. * ( e_air(pqa, pslp) / rh_air )
      !!
   END FUNCTION rh_air
   !===============================================================================================




   !   FUNCTION f_m_louis_sclr( pzu, pt_zu, pq_zu, pwnd, pts, pqs, pCdn, pz0 )
   !      !!----------------------------------------------------------------------------------
   !      !!  Stability correction function for MOMENTUM
   !      !!                 Louis (1979)
   !      !!----------------------------------------------------------------------------------
   !      REAL(wp)             :: f_m_louis_sclr ! term "f_m" in Eq.(6) when option "Louis" rather than "Psi(zeta) is chosen, Lupkes & Gryanik (2015),
   !      REAL(wp),                     INTENT(in) :: pzu     ! reference height (height for pwnd)  [m]
   !      REAL(wp), INTENT(in) :: pt_zu   ! potential air temperature            [Kelvin]
   !      REAL(wp), INTENT(in) :: pq_zu   ! specific air humidity at zt          [kg/kg]
   !      REAL(wp), INTENT(in) :: pwnd    ! wind speed                           [m/s]
   !      REAL(wp), INTENT(in) :: pts     ! sea or ice surface temperature       [K]
   !      REAL(wp), INTENT(in) :: pqs     ! humidity at saturation over ice at T=Ts_i [kg/kg]
   !      REAL(wp), INTENT(in) :: pCdn    ! neutral drag coefficient
   !      REAL(wp), INTENT(in) :: pz0     ! roughness length                      [m]
   !      !!----------------------------------------------------------------------------------
   !      REAL(wp) :: zrib, ztu, zts, zstab
   !      !!----------------------------------------------------------------------------------
   !      zrib = Ri_bulk( pzu, pts, pt_zu, pqs, pq_zu, pwnd ) ! Bulk Richardson Number:
   !      !
   !      zstab = 0.5 + SIGN(0.5_wp, zrib) ; ! Unstable (Ri<0) => zstab = 0 | Stable (Ri>0) => zstab = 1
   !      !
   !      ztu = zrib / ( 1._wp + 3._wp * rc2_louis * pCdn * SQRT( ABS( -zrib * ( pzu / pz0 + 1._wp) ) ) ) ! ABS is just here for when it's stable conditions and ztu is not used anyways
   !      zts = zrib / SQRT( ABS( 1._wp + zrib ) ) ! ABS is just here for when it's UNstable conditions and zts is not used anyways
   !      !
   !      f_m_louis_sclr = (1._wp - zstab) *         ( 1._wp - ram_louis * ztu )  &  ! Unstable Eq.(A6)
   !         &               +      zstab  * 1._wp / ( 1._wp + ram_louis * zts )     ! Stable   Eq.(A7)
   !      !
   !   END FUNCTION f_m_louis_sclr



   !===============================================================================================
   FUNCTION VARIANCE( pvc )
      REAL(4)                            :: VARIANCE
      REAL(wp), DIMENSION(:), INTENT(in) :: pvc
      !!
      INTEGER :: Nn
      REAL(wp) :: zmean
      !!
      Nn = SIZE(pvc)
      !!
      zmean = SUM(pvc)/Nn
      !!
      VARIANCE = REAL( SQRT( SUM( (pvc(:) - zmean) * (pvc(:) - zmean) ) / Nn ) , 4)
      !!
   END FUNCTION VARIANCE
   !===============================================================================================

   !===============================================================================================
   FUNCTION VMEAN( pvc )
      REAL(4)                            :: VMEAN
      REAL(wp), DIMENSION(:), INTENT(in) :: pvc
      !!
      INTEGER :: Nn
      !!
      Nn = SIZE(pvc)
      !!
      VMEAN = SUM(pvc)/Nn
      !!
   END FUNCTION VMEAN
   !===============================================================================================


   !===============================================================================================
   SUBROUTINE TO_KELVIN_3D( pt, cname )
      REAL(wp), DIMENSION(:,:,:), INTENT(inout) :: pt
      CHARACTER(len=*), OPTIONAL, INTENT(in)    :: cname
      INTEGER :: nt
      REAL(wp) :: zm
      CHARACTER(len=32) :: cvar='...'
      !
      IF(PRESENT(cname)) cvar=trim(cname)
      !
      nt = SIZE( pt )
      !
      zm = SUM(pt)/REAL(nt)
      IF( (zm < 50._wp).AND.(zm > -80._wp) ) THEN
         PRINT *, ' *** Variable ', TRIM(cvar), ' is in [deg.C] => converting to [K] !!!'
         pt  = pt + rt0
      ELSEIF ( (zm > 200._wp).AND.(zm < 320._wp) ) THEN
         PRINT *, ' *** Variable ', TRIM(cvar), ' is already in [K], doing nothing...'
      ELSE
         PRINT *, ' *** PROBLEM: cannot figure out unit of variable ', TRIM(cvar), ' !!!'
         STOP
      END IF
   END SUBROUTINE TO_KELVIN_3D
   !===============================================================================================

   !===============================================================================================
   SUBROUTINE check_unit_consistency( cfield, Xval,  mask )

      !! Ignore values where mask==0

      CHARACTER(len=*),                     INTENT(in) :: cfield
      REAL(wp),   DIMENSION(:,:),           INTENT(in) :: Xval
      INTEGER(1), DIMENSION(:,:), OPTIONAL, INTENT(in) :: mask

      INTEGER(1), DIMENSION(:,:), ALLOCATABLE :: imask
      LOGICAL,    DIMENSION(:,:), ALLOCATABLE :: lmask
      INTEGER :: nx, ny
      CHARACTER(len=64) :: cunit
      REAL(wp) :: zmean, zmin, zmax
      LOGICAL  :: l_too_large=.FALSE., l_too_small=.FALSE., l_mean_outside=.FALSE.

      nx = SIZE(Xval,1)
      ny = SIZE(Xval,2)
      ALLOCATE( lmask(nx,ny), imask(nx,ny) )
      imask(:,:) =   1
      lmask(:,:) = .TRUE.

      IF( PRESENT(mask) ) THEN
         IF( (SIZE(mask,1) /= nx).OR.(SIZE(mask,2) /= ny) ) THEN
            WRITE(*,'(" *** ERROR (check_unit_consistency@mod_phymbl): shape of `mask` does not agree with array of field ",a," !")') TRIM(cfield)
            STOP
         END IF
         imask(:,:) = mask(:,:)
         WHERE( mask==0 ) lmask = .FALSE.
      END IF
      !! if no `mask` is passed as argument then nothing is masked...

      zmean = SUM( Xval * REAL(imask,wp) ) / SUM( REAL(imask,wp) )
      !PRINT *, 'LOLO, zmean of '//TRIM(cfield)//' =>', zmean

      SELECT CASE (TRIM(cfield))

      CASE('sst','SST','Ts')
         zmax = ref_sst_max
         zmin = ref_sst_min
         cunit = 'K'

      CASE('t_air','taa','t2m','T2M')
         zmax = ref_taa_max
         zmin = ref_taa_min
         cunit = 'K'

      CASE('q_air','sh','sha','q2m','Q2M')
         zmax = ref_sha_max
         zmin = ref_sha_min
         cunit = 'kg/kg'

      CASE('rh_air','rh','RH','rlh','rha')
         zmax = ref_rlh_max
         zmin = ref_rlh_min
         cunit = 'kg/kg'

      CASE('dp_air','dp','d2m','D2M')
         zmax = ref_dpt_max
         zmin = ref_dpt_min
         cunit = 'kg/kg'

      CASE('slp','mslp','MSL','msl','P')
         zmax = ref_slp_max
         zmin = ref_slp_min
         cunit = 'Pa'

      CASE('u10','v10')
         zmax =   ref_wnd_max
         zmin = - ref_wnd_max
         cunit = 'm/s'

      CASE('wnd','wind','w10','W10')
         zmax = ref_wnd_max
         zmin = ref_wnd_min
         cunit = 'm/s'

      CASE('rad_sw')
         zmax = ref_rsw_max
         zmin = ref_rsw_min
         cunit = 'W/m^2'

      CASE('rad_lw')
         zmax = ref_rlw_max
         zmin = ref_rlw_min
         cunit = 'W/m^2'

      CASE DEFAULT
         WRITE(*,'(" *** ERROR (check_unit_consistency@mod_phymbl): we do not know field `",a,"` !")') TRIM(cfield)
         STOP
      END SELECT

      l_too_large     = ( MAXVAL(Xval, MASK=lmask) > zmax )
      l_too_small    = ( MINVAL(Xval, MASK=lmask) < zmin )
      l_mean_outside = ( (zmean < zmin) .OR. (zmean > zmax) )

      IF ( l_too_large .OR. l_too_small .OR. l_mean_outside ) THEN
         WRITE(*,'(" *** ERROR (check_unit_consistency@mod_phymbl): field `",a,"` does not seem to be in ",a," !")') TRIM(cfield), TRIM(cunit)
         WRITE(*,'(" min value = ", es10.3," max value = ", es10.3," mean value = ", es10.3)') MINVAL(Xval), MAXVAL(Xval), zmean
         STOP
      END IF
      DEALLOCATE( imask, lmask )
      !WRITE(*,'(" *** `check_unit_consistency@mod_phymbl`: field `",a,"` is okay! [",a,"]")') TRIM(cfield), TRIM(cunit)
      !!
   END SUBROUTINE check_unit_consistency


   FUNCTION type_of_humidity( Xval, mask )
      !!
      !! Guess the type of humidity contained into array Xval
      !! based on the mean, min and max values of the field!
      !! Values where mask==0 are ignored !
      !!
      REAL(wp),   DIMENSION(:,:), INTENT(in) :: Xval
      INTEGER(1), DIMENSION(:,:), INTENT(in) :: mask
      CHARACTER(len=2)                       :: type_of_humidity !: => 'sh', 'rh' or 'dp'
      !!
      LOGICAL, DIMENSION(:,:), ALLOCATABLE :: lmask
      INTEGER :: nx, ny
      REAL(wp) :: zmean, zmin, zmax
      !!
      nx = SIZE(mask,1)
      ny = SIZE(mask,2)
      ALLOCATE( lmask(nx,ny) )
      lmask(:,:) = .FALSE.
      WHERE( mask==1 ) lmask = .TRUE.

      zmean =    SUM( Xval * REAL(mask,wp) ) / SUM( REAL(mask,wp) )
      zmin  = MINVAL( Xval,  MASK=lmask )
      zmax  = MAXVAL( Xval,  MASK=lmask )

      !PRINT *, 'LOLO, zmean of '//TRIM(cfield)//' =>', zmean
      type_of_humidity = '00'

      IF(     (zmean >= ref_sha_min).AND.(zmean < ref_sha_max).AND.(zmin >= ref_sha_min).AND.(zmax < ref_sha_max) ) THEN
         !! Specific humidity! [kg/kg]
         type_of_humidity = 'sh'

      ELSEIF( (zmean >= ref_dpt_min).AND.(zmean < ref_dpt_max).AND.(zmin >= ref_dpt_min).AND.(zmax < ref_dpt_max) ) THEN
         !! Dew-point temperature [K]
         type_of_humidity = 'dp'

      ELSEIF( (zmean >= ref_rlh_min).AND.(zmean <= ref_rlh_max).AND.(zmin >= ref_rlh_min).AND.(zmax <= ref_rlh_max) ) THEN
         !! Relative humidity [%]
         type_of_humidity = 'rh'

      ELSE
         WRITE(6,*) 'ERROR: type_of_humidity()@mod_aerobulk_compute => un-identified humidity type!'
         WRITE(6,*) '   ==> we could not identify the humidity type based on the mean, min & max of the field:'
         WRITE(6,*) '     * mean =', REAL(zmean,4)
         WRITE(6,*) '     * min  =', REAL(zmin, 4)
         WRITE(6,*) '     * max  =', REAL(zmax, 4)
         STOP
      END IF

      DEALLOCATE( lmask )

   END FUNCTION type_of_humidity

   
   FUNCTION delta_skin_layer_sclr( palpha, pQd, pustar_a,  Qlat )
      !!---------------------------------------------------------------------
      !! Computes the thickness (m) of the viscous skin layer.
      !! Based on Fairall et al., 1996
      !!
      !! Fairall, C. W., Bradley, E. F., Godfrey, J. S., Wick, G. A.,
      !! Edson, J. B., and Young, G. S. ( 1996), Cool‐skin and warm‐layer
      !! effects on sea surface temperature, J. Geophys. Res., 101( C1), 1295-1308,
      !! doi:10.1029/95JC03190.
      !!
      !! L. Brodeau, october 2019
      !!---------------------------------------------------------------------
      REAL(wp),           INTENT(in) :: palpha   ! thermal expansion coefficient of sea-water (SST accurate enough!)
      REAL(wp),           INTENT(in) :: pQd   ! (<0!) part of `Qnet` absorbed in the WL [W/m^2] => term "Q + Rs*fs" in eq.6 of Fairall et al. 1996
      REAL(wp),           INTENT(in) :: pustar_a ! friction velocity in the air (u*) [m/s]
      REAL(wp), OPTIONAL, INTENT(in) :: Qlat    ! latent heat flux [W/m^2]
      REAL(wp)                       :: delta_skin_layer_sclr
      !!---------------------------------------------------------------------
      REAL(wp) :: zusw, zusw2, zlamb, zQd, ztf, ztmp
      !!---------------------------------------------------------------------
      zQd = pQd
      IF( PRESENT(Qlat) ) zQd = pQd + 0.026*MIN(Qlat,0._wp)*rCp0_w/rLevap/palpha ! LOLO: Double check sign + division by palpha !!! units are okay!

      ztf = 0.5_wp + SIGN(0.5_wp, zQd)  ! Qabs < 0 => cooling of the viscous layer => ztf = 0 (regular case)
      !                                 ! Qabs > 0 => warming of the viscous layer => ztf = 1 (ex: weak evaporation and strong positive sensible heat flux)
      !
      zusw  = MAX(pustar_a, 1.E-4_wp) * sq_radrw    ! u* in the water
      zusw2 = zusw*zusw
      !
      zlamb = 6._wp*( 1._wp + MAX(palpha*rcst_cs/(zusw2*zusw2)*zQd, 0._wp)**0.75 )**(-1./3.) ! see Eq.(14) in Fairall et al., 1996
      !  => zlamb is not used when Qd > 0, and since rcst_cs < 0, we just use this "MAX" to prevent FPE errors (something_negative)**0.75
      !
      ztmp = rnu0_w/zusw
      delta_skin_layer_sclr = (1._wp-ztf) *     zlamb*ztmp           &  ! regular case, Qd < 0, see Eq.(12) in Fairall et al., 1996
         &               +   ztf     * MIN(6._wp*ztmp , 0.007_wp)  ! when Qd > 0
      !!
   END FUNCTION delta_skin_layer_sclr



END MODULE mod_phymbl

! AeroBulk / 2019 / L. Brodeau
!
!   When using AeroBulk to produce scientific work, please acknowledge with the following citation:
!
!   Brodeau, L., B. Barnier, S. Gulev, and C. Woods, 2016: Climatologically
!   significant effects of some approximations in the bulk parameterizations of
!   turbulent air-sea fluxes. J. Phys. Oceanogr., doi:10.1175/JPO-D-16-0169.1.
!
!
MODULE mod_blk_coare3p6
   !!====================================================================================
   !!       Computes turbulent components of surface fluxes
   !!         according to Fairall et al. 2018 (COARE v3.6)
   !!         "THE TOGA-COARE BULK AIR-SEA FLUX ALGORITHM"
   !!
   !!       With Cool-Skin and Warm-Layer correction of SST (if needed)
   !!
   !!   * bulk transfer coefficients C_D, C_E and C_H
   !!   * air temp. and spec. hum. adjusted from zt (usually 2m) to zu (usually 10m) if needed
   !!   * the "effective" bulk wind speed at zu: Ubzu (including gustiness contribution in unstable conditions)
   !!   => all these are used in bulk formulas in sbcblk.F90
   !!
   !!       Routine turb_coare3p6 maintained and developed in AeroBulk
   !!                     (https://github.com/brodeau/aerobulk/)
   !!
   !!            Author: Laurent Brodeau, July 2019
   !!
   !!====================================================================================
   USE mod_const        !: physical and othe constants
   USE mod_phymbl       !: thermodynamics
   USE mod_common_coare !: common stuff across COARE versions...
   USE mod_skin_coare   !: cool-skin parameterization

   IMPLICIT NONE

   INTERFACE charn_coare3p6
      MODULE PROCEDURE charn_coare3p6_vctr, charn_coare3p6_sclr
   END INTERFACE charn_coare3p6

   PRIVATE

   PUBLIC :: TURB_COARE3P6, charn_coare3p6

   !! COARE own values for given constants:
   REAL(wp), PARAMETER :: zi0   = 600._wp     ! scale height of the atmospheric boundary layer...
   REAL(wp), PARAMETER :: Beta0 =  1.2_wp     ! gustiness parameter
   REAL(wp), PARAMETER :: zeta_abs_max = 50._wp
   !!----------------------------------------------------------------------
CONTAINS


   SUBROUTINE COARE3P6_INIT(nx, ny, l_use_wl)
      !!---------------------------------------------------------------------
      !!                  ***  FUNCTION coare3p6_init  ***
      !!
      !! INPUT :
      !! -------
      !!    * l_use_wl : use the warm-layer parameterization
      !!---------------------------------------------------------------------
      INTEGER, INTENT(in) :: nx, ny   ! shape of the domain
      LOGICAL, INTENT(in) :: l_use_wl ! use the warm-layer parameterization
      INTEGER :: ierr
      !!---------------------------------------------------------------------
      IF( l_use_wl ) THEN
         ierr = 0
         ALLOCATE ( Tau_ac(nx,ny) , Qnt_ac(nx,ny), dT_wl(nx,ny), Hz_wl(nx,ny), STAT=ierr )
         IF( ierr > 0 ) CALL ctl_stop( ' COARE3P6_INIT => allocation of Tau_ac, Qnt_ac, dT_wl & Hz_wl failed!' )
         Tau_ac(:,:) = 0._wp
         Qnt_ac(:,:) = 0._wp
         dT_wl(:,:)  = 0._wp
         Hz_wl(:,:)  = Hwl_max
      ENDIF
      !IF( l_use_cs ) THEN
      !   ierr = 0
      !   ALLOCATE ( dT_cs(nx,ny), STAT=ierr )
      !   IF( ierr > 0 ) CALL ctl_stop( ' COARE3P6_INIT => allocation of dT_cs failed!' )
      !   dT_cs(:,:) = -0.25_wp  ! First guess of skin correction
      !ENDIF
   END SUBROUTINE COARE3P6_INIT

   SUBROUTINE COARE3P6_EXIT(l_use_wl)
      !!---------------------------------------------------------------------
      !!                  ***  FUNCTION coare3p6_exit  ***
      !!
      !! INPUT :
      !! -------
      !!    * l_use_wl : use the warm-layer parameterization
      !!---------------------------------------------------------------------
      LOGICAL , INTENT(in) ::   l_use_wl ! use the warm-layer parameterization
      INTEGER :: ierr
      !!---------------------------------------------------------------------
      IF( l_use_wl ) THEN
         ierr = 0
         DEALLOCATE ( Tau_ac , Qnt_ac, dT_wl, Hz_wl, STAT=ierr )
         IF( ierr > 0 ) CALL ctl_stop( ' COARE3P6_EXIT => deallocation of Tau_ac, Qnt_ac, dT_wl & Hz_wl failed!' )
      ENDIF
      !IF( l_use_cs ) THEN
      !   ierr = 0
      !   DEALLOCATE ( dT_cs, STAT=ierr )
      !   IF( ierr > 0 ) CALL ctl_stop( ' COARE3P6_EXIT => deallocation of dT_cs failed!' )
      !ENDIF
   END SUBROUTINE COARE3P6_EXIT




   SUBROUTINE TURB_COARE3P6( kt, zt, zu, T_s, t_zt, q_s, q_zt, U_zu, l_use_cs, l_use_wl, &
      &                      Cd, Ch, Ce, t_zu, q_zu, Ubzu,                               &
      &                      Qsw, rad_lw, slp, pdT_cs,                                   & ! optionals for cool-skin (and warm-layer)
      &                      isecday_utc, plong, pdT_wl, pHz_wl,                         & ! optionals for warm-layer only
      &                      CdN, ChN, CeN, xz0, xu_star, xL, xUN10 )
      !!----------------------------------------------------------------------
      !!                      ***  ROUTINE  turb_coare3p6  ***
      !!
      !! ** Purpose :   Computes turbulent transfert coefficients of surface
      !!                fluxes according to Fairall et al. (2003)
      !!                If relevant (zt /= zu), adjust temperature and humidity from height zt to zu
      !!                Returns the effective bulk wind speed at zu to be used in the bulk formulas
      !!
      !!                Applies the cool-skin warm-layer correction of the SST to T_s
      !!                if the net shortwave flux at the surface (Qsw), the downwelling longwave
      !!                radiative fluxes at the surface (rad_lw), and the sea-leve pressure (slp)
      !!                are provided as (optional) arguments!
      !!
      !! INPUT :
      !! -------
      !!    *  kt   : current time step (starts at 1)
      !!    *  zt   : height for temperature and spec. hum. of air            [m]
      !!    *  zu   : height for wind speed (usually 10m)                     [m]
      !!    *  t_zt : potential air temperature at zt                         [K]
      !!    *  q_zt : specific humidity of air at zt                          [kg/kg]
      !!    *  U_zu : scalar wind speed at zu                                 [m/s]
      !!    * l_use_cs : use the cool-skin parameterization
      !!    * l_use_wl : use the warm-layer parameterization
      !!
      !! INPUT/OUTPUT:
      !! -------------
      !!    *  T_s  : always "bulk SST" as input                              [K]
      !!              -> unchanged "bulk SST" as output if CSWL not used      [K]
      !!              -> skin temperature as output if CSWL used              [K]
      !!
      !!    *  q_s  : SSQ aka saturation specific humidity at temp. T_s       [kg/kg]
      !!              -> doesn't need to be given a value if skin temp computed (in case l_use_cs=True or l_use_wl=True)
      !!              -> MUST be given the correct value if not computing skint temp. (in case l_use_cs=False or l_use_wl=False)
      !!
      !! OPTIONAL INPUT:
      !! ---------------
      !!    *  Qsw    : net solar flux (after albedo) at the surface (>0)     [W/m^2]
      !!    *  rad_lw : downwelling longwave radiation at the surface  (>0)   [W/m^2]
      !!    *  slp    : sea-level pressure                                    [Pa]
      !!    * isecday_utc:
      !!    *  plong  : longitude array                                       [deg.E]
      !!
      !! OPTIONAL OUTPUT:
      !! ----------------
      !!    * pdT_cs  : SST increment "dT" for cool-skin correction           [K]
      !!    * pdT_wl  : SST increment "dT" for warm-layer correction          [K]
      !!    * pHz_wl  : thickness of warm-layer                               [m]
      !!
      !! OUTPUT :
      !! --------
      !!    *  Cd     : drag coefficient
      !!    *  Ch     : sensible heat coefficient
      !!    *  Ce     : evaporation coefficient
      !!    *  t_zu   : pot. air temperature adjusted at wind height zu       [K]
      !!    *  q_zu   : specific humidity of air        //                    [kg/kg]
      !!    *  Ubzu  : bulk wind speed at zu                                 [m/s]
      !!
      !! OPTIONAL OUTPUT:
      !! ----------------
      !!    * CdN      : neutral-stability drag coefficient
      !!    * ChN      : neutral-stability sensible heat coefficient
      !!    * CeN      : neutral-stability evaporation coefficient
      !!    * xz0      : return the aerodynamic roughness length (integration constant for wind stress) [m]
      !!    * xu_star  : return u* the friction velocity                    [m/s]
      !!    * xL       : return the Obukhov length                          [m]
      !!    * xUN10    : neutral wind speed at 10m                          [m/s]
      !!
      !! ** Author: L. Brodeau, June 2019 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      INTEGER,  INTENT(in   )                 ::   kt       ! current time step
      REAL(wp), INTENT(in   )                 ::   zt       ! height for t_zt and q_zt                    [m]
      REAL(wp), INTENT(in   )                 ::   zu       ! height for U_zu                             [m]
      REAL(wp), INTENT(inout), DIMENSION(:,:) ::   T_s      ! sea surface temperature                [Kelvin]
      REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   t_zt     ! potential air temperature              [Kelvin]
      REAL(wp), INTENT(inout), DIMENSION(:,:) ::   q_s      ! sea surface specific humidity           [kg/kg]
      REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   q_zt     ! specific air humidity at zt             [kg/kg]
      REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   U_zu     ! relative wind module at zu                [m/s]
      LOGICAL , INTENT(in   )                 ::   l_use_cs ! use the cool-skin parameterization
      LOGICAL , INTENT(in   )                 ::   l_use_wl ! use the warm-layer parameterization
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   Cd       ! transfer coefficient for momentum         (tau)
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   Ch       ! transfer coefficient for sensible heat (Q_sens)
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   Ce       ! transfert coefficient for evaporation   (Q_lat)
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   t_zu     ! pot. air temp. adjusted at zu               [K]
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   q_zu     ! spec. humidity adjusted at zu           [kg/kg]
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   Ubzu    ! bulk wind speed at zu                     [m/s]
      !
      REAL(wp), INTENT(in   ), OPTIONAL, DIMENSION(:,:) ::   Qsw      !             [W/m^2]
      REAL(wp), INTENT(in   ), OPTIONAL, DIMENSION(:,:) ::   rad_lw   !             [W/m^2]
      REAL(wp), INTENT(in   ), OPTIONAL, DIMENSION(:,:) ::   slp      !             [Pa]
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   pdT_cs
      !
      INTEGER,  INTENT(in   ), OPTIONAL                     ::   isecday_utc ! current UTC time, counted in second since 00h of the current day
      REAL(wp), INTENT(in   ), OPTIONAL, DIMENSION(:,:) ::   plong    !             [deg.E]
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   pdT_wl   !             [K]
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   pHz_wl   !             [m]
      !
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   CdN
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   ChN
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   CeN
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   xz0  ! Aerodynamic roughness length   [m]
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   xu_star  ! u*, friction velocity
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   xL  ! zeta (zu/L)
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   xUN10  ! Neutral wind at zu
      !
      INTEGER :: Ni, Nj, ji, jj, jit
      LOGICAL :: l_zt_equal_zu = .FALSE.      ! if q and t are given at same height as U
      !
      REAL(wp), DIMENSION(:,:), ALLOCATABLE :: xSST     ! to back up the initial bulk SST
      !
      REAL(wp) :: zdt, zdq, zus, zus2, zUzu, zts, zqs, zNu_a, z1oL, zdT_cs
      REAL(wp) :: zUn10, zgust2, zz0, zz0t, zzta_u, zzta_t
      REAL(wp) :: zlog_10, zlog_zu, zlog_zt, zlog_ztu, zlog_z0, zlog_z0t
      REAL(wp) :: zQns, zQlat, zTau
      REAL(wp) :: ztmp0, ztmp1
      !
      LOGICAL ::  lreturn_cdn=.FALSE., lreturn_chn=.FALSE., lreturn_cen=.FALSE., &
         &        lreturn_z0=.FALSE., lreturn_ustar=.FALSE., lreturn_L=.FALSE., lreturn_UN10=.FALSE.
      CHARACTER(len=40), PARAMETER :: crtnm = 'turb_coare3p6@mod_blk_coare3p6.f90'
      !!----------------------------------------------------------------------------------
      Ni = SIZE(T_s,1)
      Nj = SIZE(T_s,2)

      IF( kt == nit000 ) CALL COARE3P6_INIT( Ni, Nj,  l_use_wl )

      lreturn_cdn   =  PRESENT(CdN)
      lreturn_chn   =  PRESENT(ChN)
      lreturn_cen   =  PRESENT(CeN)
      lreturn_z0    =  PRESENT(xz0)
      lreturn_ustar =  PRESENT(xu_star)
      lreturn_L     =  PRESENT(xL)
      lreturn_UN10  =  PRESENT(xUN10)

      l_zt_equal_zu = ( ABS(zu - zt) < 0.01_wp )

      !! Initializations for cool skin and warm layer:
      IF( l_use_cs .AND. (.NOT.(PRESENT(Qsw) .AND. PRESENT(rad_lw) .AND. PRESENT(slp))) ) &
         &   CALL ctl_stop( '['//TRIM(crtnm)//'] => ' , 'you need to provide Qsw, rad_lw & slp to use cool-skin param!' )

      IF( l_use_wl .AND. (.NOT.(PRESENT(Qsw) .AND. PRESENT(rad_lw) .AND. PRESENT(slp)     &
         &  .AND. PRESENT(isecday_utc) .AND. PRESENT(plong)) ) ) &
         &   CALL ctl_stop( '['//TRIM(crtnm)//'] => ' , 'you need to provide Qsw, rad_lw, slp, isecday_utc', &
         &   ' & plong to use warm-layer param!'  )

      IF( l_use_cs .OR. l_use_wl ) THEN
         ALLOCATE ( xSST(Ni,Nj) )
         xSST = T_s ! backing up the bulk SST
         IF( l_use_cs ) T_s = T_s - 0.25_wp   ! First guess of correction
         q_s    = rdct_qsat_salt*q_sat(MAX(T_s, 200._wp), slp) ! First guess of q_s
      ENDIF

      !! Constants:
      zlog_10  = LOG(10._wp)
      zlog_zt  = LOG(zt)
      zlog_zu  = LOG(zu)
      zlog_ztu = LOG(zt/zu)

      DO jj = 1, Nj
         DO ji = 1, Ni

            zUzu = U_zu(ji,jj)

            CALL FIRST_GUESS_COARE( zt, zu, T_s(ji,jj), t_zt(ji,jj), q_s(ji,jj), q_zt(ji,jj), zUzu, &
               &                    charn_coare3p6(zUzu),  zus, zts, zqs, &
               &                    t_zu(ji,jj), q_zu(ji,jj), Ubzu(ji,jj),  pz0=zz0 )

            zlog_z0 = LOG(zz0)
            znu_a   = visc_air(t_zu(ji,jj)) ! Air viscosity (m^2/s) at zt given from temperature in (K)

            !! Pot. temp. difference (and we don't want it to be 0!)
            zdt = t_zu(ji,jj) - T_s(ji,jj) ;   zdt = SIGN( MAX(ABS(zdt),1.E-6_wp), zdt )
            zdq = q_zu(ji,jj) - q_s(ji,jj) ;   zdq = SIGN( MAX(ABS(zdq),1.E-9_wp), zdq )


            !! ITERATION BLOCK
            DO jit = 1, nb_iter

               zus2    = zus*zus   ! u*^2

               !!Inverse of Obukov length (1/L) :
               z1oL = One_on_L(t_zu(ji,jj), q_zu(ji,jj), zus, zts, zqs)  ! 1/L == 1/[Obukhov length]
               z1oL = SIGN( MIN(ABS(z1oL),200._wp), z1oL ) ! 1/L (prevents FPE from stupid values from masked region later on...)

               !! Update wind at zu with convection-related wind gustiness in unstable conditions (Fairall et al. 2003, Eq.8):
               zgust2 = Beta0*Beta0*zus2*(MAX(-zi0*z1oL/vkarmn,0._wp))**(2._wp/3._wp) ! square of wind gustiness contribution, zgust2 == Ug^2
               !!   ! Only true when unstable (L<0) => when z1oL < 0 => explains "-" before zi0
               Ubzu(ji,jj) = MAX(SQRT(zUzu*zUzu + zgust2), 0.2_wp)        ! include gustiness in bulk wind speed
               ! => 0.2 prevents Ubzu to be 0 in stable case when U_zu=0.

               !! Stability parameters:
               zzta_u = zu*z1oL
               zzta_u = SIGN( MIN(ABS(zzta_u),zeta_abs_max), zzta_u )
               IF( .NOT. l_zt_equal_zu ) THEN
                  zzta_t = zt*z1oL
                  zzta_t = SIGN( MIN(ABS(zzta_t),zeta_abs_max), zzta_t )
               ENDIF

               !! Adjustment the wind at 10m (not needed in the current algo form):
               !IF( zu \= 10._wp ) U10 = U_zu + zus/vkarmn*(LOG(10._wp/zu) - psi_m_coare(10._wp*z1oL) + psi_m_coare(zzta_u))

               !! Roughness lengthes z0, z0t (z0q = z0t) :
               zUn10 = zus/vkarmn*(zlog_10 - zlog_z0)       ! Neutral wind speed at 10m
               zz0    = charn_coare3p6(zUn10)*zus2/grav + 0.11_wp*znu_a/zus ! Roughness length (eq.6)
               zz0     = MIN( MAX(ABS(zz0), 1.E-9) , 1._wp )  ! (prevents FPE from stupid values from masked region later on)
               zlog_z0 = LOG(zz0)

               ztmp1 = ( znu_a / (zz0*zus) )**0.72_wp        ! COARE3.6-specific! (1./Re_r)^0.72 (Re_r: roughness Reynolds number) COARE3.6-specific!
               zz0t   = MIN( 1.6E-4_wp , 5.8E-5_wp*ztmp1 )   ! COARE3.6-specific!
               zz0t   = MIN( MAX(ABS(zz0t), 1.E-9) , 1._wp ) ! (prevents FPE from stupid values from masked region later on)
               zlog_z0t = LOG(zz0t)

               !! Turbulent scales at zu :
               ztmp0   = psi_h_coare(zzta_u)
               ztmp1   = vkarmn/(zlog_zu - zlog_z0t - ztmp0) ! #LB: in ztmp0, some use psi_h_coare(zzta_t) rather than psi_h_coare(zzta_t) ???

               zts = zdt*ztmp1
               zqs = zdq*ztmp1
               zus = MAX( Ubzu(ji,jj)*vkarmn/(zlog_zu - zlog_z0 - psi_m_coare(zzta_u)) , 1.E-9 )

               IF( .NOT. l_zt_equal_zu ) THEN
                  !! Re-updating temperature and humidity at zu if zt /= zu :
                  ztmp1 = zlog_zt - zlog_zu + ztmp0 - psi_h_coare(zzta_t)
                  t_zu(ji,jj) = t_zt(ji,jj) - zts/vkarmn*ztmp1
                  q_zu(ji,jj) = q_zt(ji,jj) - zqs/vkarmn*ztmp1
               ENDIF

               IF( l_use_cs ) THEN
                  !! Cool-skin contribution
                  CALL UPDATE_QNSOL_TAU( zu, T_s(ji,jj), q_s(ji,jj), t_zu(ji,jj), q_zu(ji,jj), zus, zts, zqs, &
                     &                   zUzu, Ubzu(ji,jj), slp(ji,jj), rad_lw(ji,jj), zQns, zTau, Qlat=zQlat )

                  CALL CS_COARE( Qsw(ji,jj), zQns, zus, xSST(ji,jj), zQlat, zdT_cs )
                  IF( PRESENT(pdT_cs) ) pdT_cs(ji,jj) = zdT_cs
                  T_s(ji,jj) = xSST(ji,jj) + zdT_cs
                  IF( l_use_wl ) T_s(ji,jj) = T_s(ji,jj) + dT_wl(ji,jj)
                  q_s(ji,jj) = rdct_qsat_salt*q_sat(MAX(T_s(ji,jj), 200._wp), slp(ji,jj))
               ENDIF

               IF( l_use_wl ) THEN
                  !! Warm-layer contribution
                  CALL UPDATE_QNSOL_TAU( zu, T_s(ji,jj), q_s(ji,jj), t_zu(ji,jj), q_zu(ji,jj), zus, zts, zqs, &
                     &                   zUzu, Ubzu(ji,jj), slp(ji,jj), rad_lw(ji,jj),  zQns, zTau)
                  !! In WL_COARE or , Tau_ac and Qnt_ac must be updated at the final itteration step => add a flag to do this!
                  CALL WL_COARE( ji, jj, Qsw(ji,jj), zQns, zTau, xSST(ji,jj), plong(ji,jj), isecday_utc, MOD(nb_iter,jit) )

                  !! Updating T_s and q_s !!!
                  T_s(ji,jj) = xSST(ji,jj) + dT_wl(ji,jj)
                  IF( l_use_cs ) T_s(ji,jj) = T_s(ji,jj) + zdT_cs
                  q_s(ji,jj) = rdct_qsat_salt*q_sat(MAX(T_s(ji,jj), 200._wp), slp(ji,jj))
               ENDIF

               IF( l_use_cs .OR. l_use_wl .OR. (.NOT. l_zt_equal_zu) ) THEN
                  zdt = t_zu(ji,jj) - T_s(ji,jj) ;  zdt = SIGN( MAX(ABS(zdt),1.E-6_wp), zdt )
                  zdq = q_zu(ji,jj) - q_s(ji,jj) ;  zdq = SIGN( MAX(ABS(zdq),1.E-9_wp), zdq )
               ENDIF

            END DO !DO jit = 1, nb_iter

            ! compute transfer coefficients at zu :
            ztmp0 = zus/Ubzu(ji,jj)
            Cd(ji,jj) = MAX( ztmp0*ztmp0   , Cx_min )
            Ch(ji,jj) = MAX( ztmp0*zts/zdt , Cx_min )
            Ce(ji,jj) = MAX( ztmp0*zqs/zdq , Cx_min )

            !! Optional output
            IF( lreturn_cdn .OR. lreturn_chn .OR. lreturn_cen ) ztmp0 = 1._wp/(zlog_zu - zlog_z0)
            IF( lreturn_cdn )   CdN(ji,jj) = MAX( vkarmn2*ztmp0*ztmp0 , Cx_min )
            IF( lreturn_chn .OR. lreturn_cen ) ztmp1 = vkarmn2*ztmp0/(zlog_zu - zlog_z0t)
            IF( lreturn_chn )   ChN(ji,jj) = MAX( ztmp1 , Cx_min )
            IF( lreturn_cen )   CeN(ji,jj) = MAX( ztmp1 , Cx_min )

            IF( lreturn_z0 )        xz0(ji,jj) = zz0
            IF( lreturn_ustar ) xu_star(ji,jj) = zus
            IF( lreturn_L )          xL(ji,jj) = 1._wp / z1oL
            IF( lreturn_UN10 )    xUN10(ji,jj) = zus/vkarmn*(zlog_10 - zlog_z0)

         END DO
      END DO

      IF( l_use_wl .AND. PRESENT(pdT_wl) ) pdT_wl = dT_wl
      IF( l_use_wl .AND. PRESENT(pHz_wl) ) pHz_wl = Hz_wl

      IF( l_use_cs .OR. l_use_wl ) DEALLOCATE ( xSST )

      IF( kt == nitend ) CALL COARE3P6_EXIT( l_use_wl )

   END SUBROUTINE TURB_COARE3P6


   !!===============================================================================================
   FUNCTION charn_coare3p6_sclr( pwnd )
      !!-------------------------------------------------------------------
      !! Computes the Charnock parameter as a function of the Neutral wind speed at 10m
      !!  "wind speed dependent formulation"
      !!  (Eq. 13 in Edson et al., 2013)
      !!
      !! Author: L. Brodeau, July 2019 / AeroBulk  (https://github.com/brodeau/aerobulk/)
      !!-------------------------------------------------------------------
      REAL(wp), INTENT(in) :: pwnd   ! neutral wind speed at 10m
      REAL(wp)             :: charn_coare3p6_sclr
      !
      REAL(wp), PARAMETER :: charn0_max = 0.028  !: value above which the Charnock parameter levels off for winds > 18 m/s
      !!-------------------------------------------------------------------
      charn_coare3p6_sclr = MAX( MIN( 0.0017_wp*pwnd - 0.005_wp , charn0_max) , 0._wp )
      !!
   END FUNCTION charn_coare3p6_sclr

   FUNCTION charn_coare3p6_vctr( pwnd )
      REAL(wp), DIMENSION(:,:), INTENT(in)           :: pwnd   ! neutral wind speed at 10m
      REAL(wp), DIMENSION(SIZE(pwnd,1),SIZE(pwnd,2)) :: charn_coare3p6_vctr
      !
      REAL(wp), PARAMETER :: charn0_max = 0.028  !: value above which the Charnock parameter levels off for winds > 18 m/s
      !!-------------------------------------------------------------------
      charn_coare3p6_vctr = MAX( MIN( 0.0017_wp*pwnd - 0.005_wp , charn0_max) , 0._wp )
   END FUNCTION charn_coare3p6_vctr
   !!===============================================================================================




   FUNCTION charn_coare3p6_wave( pus, pwsh, pwps )
      !!-------------------------------------------------------------------
      !! Computes the Charnock parameter as a function of wave information and u*
      !!
      !!  (COARE 3.6, Fairall et al., 2018)
      !!
      !! Author: L. Brodeau, October 2019 / AeroBulk  (https://github.com/brodeau/aerobulk/)
      !!-------------------------------------------------------------------
      REAL(wp), INTENT(in) :: pus   ! friction velocity             [m/s]
      REAL(wp), INTENT(in) :: pwsh  ! significant wave height       [m]
      REAL(wp), INTENT(in) :: pwps  ! phase speed of dominant waves [m/s]
      REAL(wp)             :: charn_coare3p6_wave
      !!-------------------------------------------------------------------
      charn_coare3p6_wave = ( pwsh*0.2_wp*(pus/pwps)**2.2_wp ) * grav/(pus*pus)
      !!
   END FUNCTION charn_coare3p6_wave

   !!======================================================================
END MODULE mod_blk_coare3p6

! AeroBulk / 2019 / L. Brodeau
!
!   When using AeroBulk to produce scientific work, please acknowledge with the following citation:
!
!   Brodeau, L., B. Barnier, S. Gulev, and C. Woods, 2016: Climatologically
!   significant effects of some approximations in the bulk parameterizations of
!   turbulent air-sea fluxes. J. Phys. Oceanogr., doi:10.1175/JPO-D-16-0169.1.
!
!
MODULE mod_blk_ncar
   !!====================================================================================
   !!       Computes turbulent components of surface fluxes
   !!         according to Large & Yeager (2004,2008)
   !!
   !!   * bulk transfer coefficients C_D, C_E and C_H
   !!   * air temp. and spec. hum. adjusted from zt (2m) to zu (10m) if needed
   !!   * the effective bulk wind speed at 10m Ubzu
   !!   => all these are used in bulk formulas in sbcblk.F90
   !!
   !!    Using the bulk formulation/param. of Large & Yeager 2008
   !!
   !!       Routine turb_ncar maintained and developed in AeroBulk
   !!                     (https://github.com/brodeau/aerobulk/)
   !!
   !!            Author: Laurent Brodeau, 2016
   !!
   !!====================================================================================
   USE mod_const       !: physical and other constants
   USE mod_phymbl      !: misc. physical functions

   IMPLICIT NONE
   PRIVATE

   INTERFACE cd_n10_ncar
      MODULE PROCEDURE cd_n10_ncar_vctr, cd_n10_ncar_sclr
   END INTERFACE cd_n10_ncar

   INTERFACE ch_n10_ncar
      MODULE PROCEDURE ch_n10_ncar_vctr, ch_n10_ncar_sclr
   END INTERFACE ch_n10_ncar

   INTERFACE ce_n10_ncar
      MODULE PROCEDURE ce_n10_ncar_vctr, ce_n10_ncar_sclr
   END INTERFACE ce_n10_ncar

   INTERFACE psi_m_ncar
      MODULE PROCEDURE psi_m_ncar_vctr, psi_m_ncar_sclr
   END INTERFACE psi_m_ncar

   INTERFACE psi_h_ncar
      MODULE PROCEDURE psi_h_ncar_vctr, psi_h_ncar_sclr
   END INTERFACE psi_h_ncar

   PUBLIC :: TURB_NCAR, cd_n10_ncar, ch_n10_ncar, ce_n10_ncar, psi_m_ncar, psi_h_ncar

   !!----------------------------------------------------------------------
CONTAINS

   SUBROUTINE turb_ncar( zt, zu, sst, t_zt, ssq, q_zt, U_zu,   &
      &                  Cd, Ch, Ce, t_zu, q_zu, Ubzu,         &
      &                  CdN, ChN, CeN, xz0, xu_star, xL, xUN10 )
      !!----------------------------------------------------------------------------------
      !!                      ***  ROUTINE  turb_ncar  ***
      !!
      !! ** Purpose :   Computes turbulent transfert coefficients of surface
      !!                fluxes according to Large & Yeager (2004) and Large & Yeager (2008)
      !!                If relevant (zt /= zu), adjust temperature and humidity from height zt to zu
      !!                Returns the effective bulk wind speed at zu to be used in the bulk formulas
      !!
      !! INPUT :
      !! -------
      !!    *  zt   : height for temperature and spec. hum. of air            [m]
      !!    *  zu   : height for wind speed (usually 10m)                     [m]
      !!    *  sst  : bulk SST                                                [K]
      !!    *  t_zt : potential air temperature at zt                         [K]
      !!    *  ssq  : specific humidity at saturation at SST                  [kg/kg]
      !!    *  q_zt : specific humidity of air at zt                          [kg/kg]
      !!    *  U_zu : scalar wind speed at zu                                 [m/s]
      !!
      !!
      !! OUTPUT :
      !! --------
      !!    *  Cd     : drag coefficient
      !!    *  Ch     : sensible heat coefficient
      !!    *  Ce     : evaporation coefficient
      !!    *  t_zu   : pot. air temperature adjusted at wind height zu       [K]
      !!    *  q_zu   : specific humidity of air        //                    [kg/kg]
      !!    *  Ubzu  : bulk wind speed at zu                                 [m/s]
      !!
      !! OPTIONAL OUTPUT:
      !! ----------------
      !!    * CdN      : neutral-stability drag coefficient
      !!    * ChN      : neutral-stability sensible heat coefficient
      !!    * CeN      : neutral-stability evaporation coefficient
      !!    * xz0      : return the aerodynamic roughness length (integration constant for wind stress) [m]
      !!    * xu_star  : return u* the friction velocity                    [m/s]
      !!    * xL       : return the Obukhov length                          [m]
      !!    * xUN10    : neutral wind speed at 10m                          [m/s]
      !!
      !! ** Author: L. Brodeau, June 2019 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      REAL(wp), INTENT(in   )                     ::   zt       ! height for t_zt and q_zt                    [m]
      REAL(wp), INTENT(in   )                     ::   zu       ! height for U_zu                             [m]
      REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   sst      ! sea surface temperature                [Kelvin]
      REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   t_zt     ! potential air temperature              [Kelvin]
      REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   ssq      ! sea surface specific humidity           [kg/kg]
      REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   q_zt     ! specific air humidity at zt             [kg/kg]
      REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   U_zu     ! relative wind module at zu                [m/s]
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   Cd       ! transfer coefficient for momentum         (tau)
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   Ch       ! transfer coefficient for sensible heat (Q_sens)
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   Ce       ! transfert coefficient for evaporation   (Q_lat)
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   t_zu     ! pot. air temp. adjusted at zu               [K]
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   q_zu     ! spec. humidity adjusted at zu           [kg/kg]
      REAL(wp), INTENT(  out), DIMENSION(:,:) ::   Ubzu    ! bulk wind speed at zu                     [m/s]
      !
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   CdN
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   ChN
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   CeN
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   xz0  ! Aerodynamic roughness length   [m]
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   xu_star  ! u*, friction velocity
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   xL  ! zeta (zu/L)
      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(:,:) ::   xUN10  ! Neutral wind at zu
      !
      INTEGER :: Ni, Nj, jit, ji, jj
      LOGICAL :: l_zt_equal_zu = .FALSE.      ! if q and t are given at same height as U
      !
      REAL(wp) ::   zstab, zCdN, zCeN, zChN        ! 10m neutral latent/sensible coefficient
      REAL(wp) ::   zsqrt_Cd, zsqrt_CdN   ! square root of Cd_n10
      REAL(wp) ::   zeta_u, zeta_t         ! stability parameter at height zu and zt
      REAL(wp) :: zlog1, zlog2, ztmp, ztmp2
      REAL(wp) :: zdt, zdq, zus, zts, zqs, z1oL, zpsi_m, zUn10
      !
      LOGICAL ::  lreturn_cdn=.FALSE., lreturn_chn=.FALSE., lreturn_cen=.FALSE., &
         &        lreturn_z0=.FALSE., lreturn_ustar=.FALSE., lreturn_L=.FALSE., lreturn_UN10=.FALSE.
      CHARACTER(len=40), PARAMETER :: crtnm = 'turb_ncar@mod_blk_ncar.f90'
      !!----------------------------------------------------------------------------------
      Ni = SIZE(sst,1)
      Nj = SIZE(sst,2)

      lreturn_cdn   = PRESENT(CdN)
      lreturn_chn   = PRESENT(ChN)
      lreturn_cen   = PRESENT(CeN)
      lreturn_z0    = PRESENT(xz0)
      lreturn_ustar = PRESENT(xu_star)
      lreturn_L     = PRESENT(xL)
      lreturn_UN10  = PRESENT(xUN10)

      l_zt_equal_zu = ( ABS(zu - zt) < 0.01_wp ) ! testing "zu == zt" is risky with double precision

      Ubzu = MAX( 0.5_wp , U_zu )   !  relative wind speed at zu (normally 10m), we don't want to fall under 0.5 m/s

      !! ij-independant constants:
      zlog1 = LOG(zt/zu)
      zlog2 = LOG(zu/10._wp)

      DO jj = 1, Nj
         DO ji = 1, Ni

            !! First guess of stability:
            zstab = 0.5_wp + SIGN( 0.5_wp , virt_temp(t_zt(ji,jj), q_zt(ji,jj)) - virt_temp(sst(ji,jj), ssq(ji,jj)) )

            !! Neutral coefficients at 10m:
            zCdN = cd_n10_ncar( Ubzu(ji,jj) )
            zsqrt_CdN = SQRT( zCdN )

            !! Initializing transf. coeff. with their first guess neutral equivalents :
            Cd(ji,jj) = zCdN
            Ce(ji,jj) = ce_n10_ncar( zsqrt_CdN )
            Ch(ji,jj) = ch_n10_ncar( zsqrt_CdN , zstab )   ! zstab is stability (1/0)
            zsqrt_Cd = zsqrt_CdN


            !! Initializing values at z_u with z_t values:
            t_zu(ji,jj) = MAX( t_zt(ji,jj) ,  180._wp )   ! who knows what's given on masked-continental regions...
            q_zu(ji,jj) = MAX( q_zt(ji,jj) , 1.e-6_wp )   !               "


            !! ITERATION BLOCK
            DO jit = 1, nb_iter
               !
               zdt = t_zu(ji,jj) - sst(ji,jj)   ! Updating air/sea differences
               zdq = q_zu(ji,jj) - ssq(ji,jj)

               ! Updating turbulent scales :   (L&Y 2004 Eq. (7))
               zus = zsqrt_Cd*Ubzu(ji,jj)      ! u*
               zts = Ch(ji,jj)/zsqrt_Cd*zdt    ! theta*
               zqs = Ce(ji,jj)/zsqrt_Cd*zdq    ! q*

               ! Estimate the inverse of Obukov length (1/L) at height zu:
               z1oL = One_on_L( t_zu(ji,jj), q_zu(ji,jj), zus, zts, zqs )

               !! Stability parameters :
               zeta_u   = zu*z1oL
               zeta_u   = sign( min(abs(zeta_u),10._wp), zeta_u )

               !! Shifting temperature and humidity at zu (L&Y 2004 Eq. (9b-9c))
               IF( .NOT. l_zt_equal_zu ) THEN
                  zeta_t = zt*z1oL ! zeta_t !
                  zeta_t = SIGN( MIN(ABS(zeta_t),10._wp), zeta_t )
                  ztmp = zlog1 + psi_h_ncar(zeta_u) - psi_h_ncar(zeta_t)
                  t_zu(ji,jj) = t_zt(ji,jj) - zts/vkarmn*ztmp
                  q_zu(ji,jj) = q_zt(ji,jj) - zqs/vkarmn*ztmp
                  q_zu(ji,jj) = MAX(0._wp, q_zu(ji,jj))
               END IF

               ! Update neutral wind speed at 10m and neutral Cd at 10m (L&Y 2004 Eq. 9a)...
               !   In very rare low-wind conditions, the old way of estimating the
               !   neutral wind speed at 10m leads to a negative value that causes the code
               !   to crash. To prevent this a threshold of 0.25m/s is imposed.
               zpsi_m = psi_m_ncar(zeta_u)
               zUn10 = MAX( 0.25_wp , UN10_from_CD(zu, Ubzu(ji,jj), Cd(ji,jj), ppsi=zpsi_m) )
               zCdN = cd_n10_ncar(zUn10)
               zsqrt_CdN = SQRT(zCdN)

               !! Update of transfer coefficients:

               !! C_D
               ztmp  = 1._wp + zsqrt_CdN/vkarmn*(zlog2 - zpsi_m)   ! L&Y 2004 Eq. (10a) (zpsi_m == psi_m(zeta_u))
               Cd(ji,jj)     = MAX( zCdN / ( ztmp*ztmp ), Cx_min )

               !! C_H and C_E
               zsqrt_Cd = SQRT( Cd(ji,jj) )
               ztmp = ( zlog2 - psi_h_ncar(zeta_u) ) / vkarmn / zsqrt_CdN
               ztmp2 = zsqrt_Cd / zsqrt_CdN

               zstab = 0.5_wp + SIGN(0.5_wp,zeta_u)                                ! update stability
               zChN  = 1.e-3_wp * zsqrt_CdN*(18._wp*zstab + 32.7_wp*(1._wp - zstab))  ! L&Y 2004 eq. (6c-6d)
               zCeN  = 1.e-3_wp * (34.6_wp * zsqrt_CdN)                             ! L&Y 2004 eq. (6b)

               Ch(ji,jj)    = MAX( zChN*ztmp2 / ( 1._wp + zChN*ztmp ) , Cx_min ) ! L&Y 2004 eq. (10b)
               Ce(ji,jj)    = MAX( zCeN*ztmp2 / ( 1._wp + zCeN*ztmp ) , Cx_min ) ! L&Y 2004 eq. (10c)

            END DO !DO jit = 1, nb_iter

            IF( lreturn_cdn )       CdN(ji,jj) = zCdN
            IF( lreturn_cen )       CeN(ji,jj) = zCeN
            IF( lreturn_chn )       ChN(ji,jj) = zChN
            IF( lreturn_UN10 )    xUN10(ji,jj) = zUn10
            IF( lreturn_L )          xL(ji,jj) = 1._wp/z1oL
            IF( lreturn_ustar ) xu_star(ji,jj) = zus
            IF( lreturn_z0 )        xz0(ji,jj) = MIN( z0_from_Cd( zu, zCdN ) , z0_sea_max )

         END DO
      END DO

   END SUBROUTINE turb_ncar


   !!===============================================================================================
   FUNCTION cd_n10_ncar_sclr( pw10 )
      !!----------------------------------------------------------------------------------
      !! Estimate of the neutral drag coefficient at 10m as a function
      !! of neutral wind  speed at 10m
      !!
      !! Origin: Large & Yeager 2008, Eq. (11)
      !!
      !! ** Author: L. Brodeau, june 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      REAL(wp), INTENT(in) :: pw10           ! scalar wind speed at 10m (m/s)
      REAL(wp)             :: cd_n10_ncar_sclr
      !!
      REAL(wp) :: zgt33, zw, zw6 ! local scalars
      !!----------------------------------------------------------------------------------
      zw  = pw10
      zw6 = zw*zw*zw
      zw6 = zw6*zw6
      !
      ! When wind speed > 33 m/s => Cyclone conditions => special treatment
      zgt33 = 0.5_wp + SIGN( 0.5_wp, (zw - 33._wp) )   ! If pw10 < 33. => 0, else => 1
      !
      cd_n10_ncar_sclr = 1.e-3_wp * ( &
         &       (1._wp - zgt33)*( 2.7_wp/zw + 0.142_wp + zw/13.09_wp - 3.14807E-10_wp*zw6) & ! wind <  33 m/s
         &      +    zgt33   *      2.34_wp )                                                 ! wind >= 33 m/s
      !
      cd_n10_ncar_sclr = MAX( cd_n10_ncar_sclr, Cx_min )
      !
   END FUNCTION cd_n10_ncar_sclr

   FUNCTION cd_n10_ncar_vctr( pw10 )
      REAL(wp), DIMENSION(:,:), INTENT(in)           :: pw10           ! scalar wind speed at 10m (m/s)
      REAL(wp), DIMENSION(SIZE(pw10,1),SIZE(pw10,2)) :: cd_n10_ncar_vctr
      INTEGER :: ji, jj
      !!----------------------------------------------------------------------------------
      DO jj = 1, SIZE(pw10,2)
         DO ji = 1, SIZE(pw10,1)
            cd_n10_ncar_vctr(ji,jj) = cd_n10_ncar_sclr(pw10(ji,jj))
         END DO
      END DO
   END FUNCTION cd_n10_ncar_vctr
   !!===============================================================================================

   !!===============================================================================================
   FUNCTION ch_n10_ncar_sclr( psqrtcdn10 , pstab )
      !!----------------------------------------------------------------------------------
      !! Estimate of the neutral heat transfer coefficient at 10m      !!
      !! Origin: Large & Yeager 2008, Eq. (9) and (12)
      !!----------------------------------------------------------------------------------
      REAL(wp), INTENT(in) :: psqrtcdn10 ! sqrt( CdN10 )
      REAL(wp), INTENT(in) :: pstab      ! stable ABL => 1 / unstable ABL => 0
      REAL(wp)             :: ch_n10_ncar_sclr
      !!----------------------------------------------------------------------------------
      IF( (pstab < -0.00001).OR.(pstab >  1.00001) ) THEN
         PRINT *, 'ERROR: ch_n10_ncar_sclr@mod_blk_ncar.f90: pstab ='
         PRINT *, pstab
         STOP
      END IF
      ch_n10_ncar_sclr = MAX( 1.e-3_wp * psqrtcdn10*( 18._wp*pstab + 32.7_wp*(1._wp - pstab) )  , Cx_min )   ! Eq. (9) & (12) Large & Yeager, 2008
   END FUNCTION ch_n10_ncar_sclr

   FUNCTION ch_n10_ncar_vctr( psqrtcdn10 , pstab )
      REAL(wp), DIMENSION(:,:), INTENT(in)                       :: psqrtcdn10 ! sqrt( CdN10 )
      REAL(wp), DIMENSION(:,:), INTENT(in)                       :: pstab      ! stable ABL => 1 / unstable ABL => 0
      REAL(wp), DIMENSION(SIZE(psqrtcdn10,1),SIZE(psqrtcdn10,2)) :: ch_n10_ncar_vctr
      ch_n10_ncar_vctr = MAX( 1.e-3_wp * psqrtcdn10*( 18._wp*pstab + 32.7_wp*(1._wp - pstab) )  , Cx_min )   ! Eq. (9) & (12) Large & Yeager, 2008
   END FUNCTION ch_n10_ncar_vctr
   !!===============================================================================================

   !!===============================================================================================
   FUNCTION ce_n10_ncar_sclr( psqrtcdn10 )
      !!----------------------------------------------------------------------------------
      !! Estimate of the neutral heat transfer coefficient at 10m      !!
      !! Origin: Large & Yeager 2008, Eq. (9) and (13)
      !!----------------------------------------------------------------------------------
      REAL(wp), INTENT(in) :: psqrtcdn10 ! sqrt( CdN10 )
      REAL(wp)             :: ce_n10_ncar_sclr
      !!----------------------------------------------------------------------------------
      ce_n10_ncar_sclr = MAX( 1.e-3_wp * ( 34.6_wp * psqrtcdn10 ) , Cx_min )
   END FUNCTION ce_n10_ncar_sclr

   FUNCTION ce_n10_ncar_vctr( psqrtcdn10 )
      REAL(wp), DIMENSION(:,:), INTENT(in)                       :: psqrtcdn10 ! sqrt( CdN10 )
      REAL(wp), DIMENSION(SIZE(psqrtcdn10,1),SIZE(psqrtcdn10,2)) :: ce_n10_ncar_vctr
      ce_n10_ncar_vctr = MAX( 1.e-3_wp * ( 34.6_wp * psqrtcdn10 ) , Cx_min )
   END FUNCTION ce_n10_ncar_vctr
   !!===============================================================================================


   !!===============================================================================================
   FUNCTION psi_m_ncar_sclr( pzeta )
      !!----------------------------------------------------------------------------------
      !! Universal profile stability function for momentum
      !!    !! Psis, L&Y 2004, Eq. (8c), (8d), (8e)
      !!
      !! pzeta : stability paramenter, z/L where z is altitude measurement
      !!         and L is M-O length
      !!
      !! ** Author: L. Brodeau, June 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      REAL(wp), INTENT(in) :: pzeta
      REAL(wp)             :: psi_m_ncar_sclr
      !!
      REAL(wp) :: zta, zx2, zx, zpsi_unst, zpsi_stab,  zstab   ! local scalars
      !!----------------------------------------------------------------------------------
      zta = pzeta
      !
      zx2 = SQRT( ABS(1._wp - 16._wp*zta) )  ! (1 - 16z)^0.5
      zx2 = MAX( zx2 , 1._wp )
      zx  = SQRT(zx2)                          ! (1 - 16z)^0.25
      zpsi_unst = 2._wp*LOG( (1._wp + zx )*0.5_wp )   &
         &            + LOG( (1._wp + zx2)*0.5_wp )   &
         &          - 2._wp*ATAN(zx) + rpi*0.5_wp
      !
      zpsi_stab = -5._wp*zta
      !
      zstab = 0.5_wp + SIGN(0.5_wp, zta) ! zta > 0 => zstab = 1
      !
      psi_m_ncar_sclr =          zstab  * zpsi_stab &  ! (zta > 0) Stable
         &              + (1._wp - zstab) * zpsi_unst    ! (zta < 0) Unstable
   END FUNCTION psi_m_ncar_sclr

   FUNCTION psi_m_ncar_vctr( pzeta )
      REAL(wp), DIMENSION(:,:), INTENT(in)             :: pzeta
      REAL(wp), DIMENSION(SIZE(pzeta,1),SIZE(pzeta,2)) :: psi_m_ncar_vctr
      INTEGER :: ji, jj
      !!----------------------------------------------------------------------------------
      DO jj = 1, SIZE(pzeta,2)
         DO ji = 1, SIZE(pzeta,1)
            psi_m_ncar_vctr(ji,jj) = psi_m_ncar_sclr(pzeta(ji,jj))
         END DO
      END DO
   END FUNCTION psi_m_ncar_vctr
   !!===============================================================================================

   !!===============================================================================================
   FUNCTION psi_h_ncar_sclr( pzeta )
      !!----------------------------------------------------------------------------------
      !! Universal profile stability function for temperature and humidity
      !!    !! Psis, L&Y 2004, Eq. (8c), (8d), (8e)
      !!
      !! pzeta : stability paramenter, z/L where z is altitude measurement
      !!         and L is M-O length
      !!
      !! ** Author: L. Brodeau, June 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
      !!----------------------------------------------------------------------------------
      REAL(wp), INTENT(in) :: pzeta
      REAL(wp)             :: psi_h_ncar_sclr
      !!
      REAL(wp) :: zta, zx2, zpsi_unst, zpsi_stab, zstab  ! local scalars
      !!----------------------------------------------------------------------------------
      zta = pzeta
      !
      zx2 = SQRT( ABS(1._wp - 16._wp*zta) )  ! (1 -16z)^0.5
      zx2 = MAX( zx2 , 1._wp )
      zpsi_unst = 2._wp*LOG( 0.5_wp*(1._wp + zx2) )
      !
      zpsi_stab = -5._wp*zta
      !
      zstab = 0.5_wp + SIGN(0.5_wp, zta) ! zta > 0 => zstab = 1
      !
      psi_h_ncar_sclr =          zstab  * zpsi_stab &  ! (zta > 0) Stable
         &              + (1._wp - zstab) * zpsi_unst    ! (zta < 0) Unstable
      !
   END FUNCTION psi_h_ncar_sclr

   FUNCTION psi_h_ncar_vctr( pzeta )
      REAL(wp), DIMENSION(:,:), INTENT(in)             :: pzeta
      REAL(wp), DIMENSION(SIZE(pzeta,1),SIZE(pzeta,2)) :: psi_h_ncar_vctr
      INTEGER :: ji, jj
      !!----------------------------------------------------------------------------------
      DO jj = 1, SIZE(pzeta,2)
         DO ji = 1, SIZE(pzeta,1)
            psi_h_ncar_vctr(ji,jj) = psi_h_ncar_sclr(pzeta(ji,jj))
         END DO
      END DO
   END FUNCTION psi_h_ncar_vctr
   !!===============================================================================================

END MODULE mod_blk_ncar
